function create_detail_row(id){
	return $("<tr class='ap_detail_row' data-id='" + id + "'><td colspan='100'><div class='ap_detail_div col-lg-12 col-md-12 col-sm-12 col-xs-12' > </div></td></tr>");
}

// need this func as cb for show_select_string when load files; NOTE: detail may be closed at this moment
function update_detail(){
	if($(".ap_detail_row").length){
		$(".ap_detail_row").find(".ap_detail_div").html("");
		var id = $(".ap_detail_row").data("id");
		show_detail(id); 
	}
}

function get_detail_id(){return  $(".ap_detail_row").data("id"); } 
function get_rec_id(){ return cl_get_active_rec_id( $(".tc_thumbs_form") ) ; }
// DEF GRID_VS_FLEX when use flex within table - elem is shrinked to col width (even with colspan); only col-12 helped

var on_hide_detail = null;
function hide_detail(){ 
	$(".ap_detail_row").remove();
	if( on_hide_detail ) on_hide_detail();
}
function detail_shown(){ return $(".ap_detail_row").length; }
function show_detail_click(id){
	var id_prev = 0;
	if(detail_shown()){
			// TODO: need some hide_detail func called here; eg in orders.php need set apps=null
			id_prev = $(".ap_detail_row").data("id");
			hide_detail();
	}
	if(id!=id_prev){
		// DEF GRID_VS_FLEX when use flex within table - elem is shrinked to col width (even with colspan); only col-12 helped
		var rec = $(".tc_thumbs_form").find(".data-row[data-id='" + id + "']");
		if(!rec.length) return; // DEF ALA_BUG adr lap bug: error 5283  SELECT count(*) FROM app_lbs WHERE (camp_id=undefined AND shop_id=undefined AND img_id<>0); seems happens in on_show orders.php
		create_detail_row(id).insertAfter( rec );
		// individual part
		show_detail(id, rec); // NOTE: This should set id: tr.data("id", id);
	}
}
// from given arr of elems get arr of data attrs
function get_data_arr(recset, dataname){var r=[]; if(recset&&recset.length) recset.each( function(){r.push($(this).data(dataname));} ); return r;}

// SETCAMP TODO: pass set_camp as param
function show_sel_camp(state="opened", par_sel = ".mc_table_control"){
	$(par_sel).append(   call_php_sync("contr/main.php", {"action" : "get_camps_cb", state:state}, 'POST').resp_text ) ; // NOTE: call it before use get_camp_id
	$("#mi_camp").on("change", function(){ set_camp( $(this).val() ); } );
	return $("#mi_camp");
}

function get_camp_id(){ var c = $("#mi_camp"); return c.length? c.val() : 0; }

function check_upload_finished(ok){
	var inupload = false, notstarted=false;
	var nuf = $("#fileupload .files").find(".progress.active").each( function(){ 
		notstarted=true; if( $(this).attr("aria-valuenow")!="0") inupload=true;   
	} );
	if(inupload){ alert(lp("some_uploads_not_yet_finished")); return 0; }
	if(ok && notstarted && !confirm(lp("confirm_close_not_uploaded")) ) return 0;
	return 1;
}

var incass = false;
function cass_filter(opts, val, field){
	var v=null,n=0;
	opts.each( function(){
		var opt = $(this);
		if( val && opt.data(field)!=val ) opt.addClass("hidden"); else {opt.removeClass("hidden"); v=opt.val(); n++;}
	});
	if(v&&n==1) opts.closest("select").val(v);
}
function cass_init(){
	// TODO: if a sel has single opt - select it (also in onchange)
	$("#sf_area").val(""); $("#sf_country").val(""); $("#sf_city").val(""); $("#sf_shop_name").val("");
	$("#sf_area").on("change", function(){
		if(incass)return; incass=true;
		var val = $(this).val();
		$("#sf_country").val(""); $("#sf_city").val(""); $("#sf_shop_name").val("");
		cass_filter( $("#sf_country option"), val, "area" );
		cass_filter( $("#sf_city option"), val, "area" );
		cass_filter( $("#sf_shop_name option"), val, "area" );
		incass=false;
	});
	$("#sf_country").on("change", function(){
		if(incass)return; incass=true;
		var val = $(this).val();
		$("#sf_city").val(""); $("#sf_shop_name").val("");
		cass_filter( $("#sf_city option"), val, "country" );
		cass_filter( $("#sf_shop_name option"), val, "country" );
		incass=false;
	});
	$("#sf_city").on("change", function(){
		if(incass)return; incass=true;
		var val = $(this).val();
		$("#sf_shop_name").val("");
		cass_filter( $("#sf_shop_name option"), val, "city" );
		incass=false;
	});
}

// DEF PREVIEW - show med thumb on image click
function show_preview_url(url, name){
	var content = $("<div style='max-width:500px;max-height:500px;'></div>");
	var img = create_boxed_image(url, 500, 500);
	$(img).removeClass("ap_detail_elem");
	content.append(img);
	show_select_string(null, '', content, name);
}
function show_preview(img_id, name){
	var url = call_php_sync("contr/main.php", {"action" : "get_img_url", id: img_id} ).resp_text;
	show_preview_url(url, name);
}
function update_td(rec, name, val){
	rec.find(".td-" + alias_name + "-" + name).html(val);
	rec.data(name, val);
}

// PUH
var puh_timeout = 0, puh_priority = 3;
function puh_close(){
	$(".mc_puh_div").addClass("hidden");
	puh_timeout = 0;
}
// tm - timeout to close msg in seconds; pass 0 to not set timer (always shown)
function puh(msg, tm=10, pri=3){
	if(puh_timeout && puh_priority>pri) return;
	$(".mc_puh_div").removeClass("hidden");
	$(".mc_puh_msg").html(lp(msg));
	puh_priority = pri;
	if(puh_timeout)
		clearTimeout(puh_timeout);
	if(tm)
		puh_timeout = setTimeout(puh_close, tm*1000);
}

var ur_role; // UR TODO: now role selection is done during login, so this scheme with page_init not necessary
$(document).ready( function(){
	// vert menu (similar to archive.js)
	var mv = call_php_sync("contr/main.php", {"action" : "menu_vert"} ).resp_text;
	$('#mi_main_menu_vert').html(mv);
	$('#mi_main_menu_vert .mc_item').click( menu_item_click );
	var page = window.location.pathname.split("/").pop();
	$('#mi_main_menu_vert .mc_item').each( function(){ if( $(this).data("handler").includes(page) ) $(this).addClass("active"); } );
	/* can't use ajax, or else tt.show called before menu shown and occupies whole width /
	$.ajax({
		type: 'POST',
		url: 'contr/main.php',
		data: {action: 'menu_vert'},
		success: function(menu_html){
			$('#mi_main_menu_vert').html(menu_html);
			$('.mc_item').click( menu_item_click );
		}
	}); */
	// actually utils.js contains code to resize tables on win resize, but they use .fh-table sel which is not used (why?) in this app; besides probably need ensure that outer table is resized first (then detail)
	// also for TASMA
	$(window).resize( function(){
		fh_on_resize( $(".tc_thumbs_form") );
		fh_on_resize( $(".ap_detail_div") );
	});
});
