<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<link href="css/v_menu.css" rel="stylesheet">
		<link href="lib/fontawesome/css/all.css" rel="stylesheet">
	</head>
	<body style="background: #000000;"> 
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<script src="hyifen/sidemenu.js"></script>


<nav class="navbar navbar-inverse navbar-fixed-top" id="sidebar-wrapper" role="navigation" style="overflow: hidden;">
    <ul class="nav sidebar-nav">
        <li>
            <a id="users" href="/Lightbox/Users">
                <i class="fa fa-users fa-fw-20" aria-hidden="true"></i>
                <span>Users</span>
            </a>
        </li>
        <li>
            <a id="stores" href="/Lightbox/Stores">
                <i class="fa fa-shopping-bag fa-fw-20" aria-hidden="true"></i>
                <span>Stores</span>
            </a>
        </li>
        <li>
            <a id="campaigns" href="/Lightbox/Campaigns">
                <i class="fa fa-list fa-fw-20" aria-hidden="true"></i>
                <span>Adv Campaigns</span>
            </a>
        </li>
        <li>
            <a id="orders" href="/Lightbox/Orders">
                <i class="fa fa-calendar fa-fw-20" aria-hidden="true"></i>
                <span>Orders</span>
            </a>
        </li>
    </ul>
</nav>


	</body>
</html>
