/*
	21.09.18 aggiungo selezione parziale
	se una cartella viene de/selezionata - devo aggiornare a) tutti i descendenti (incluse se stesso);  b) la catena dei parenti
	a) i descendenti perdono 'indeterminate" e ottengono lo stato schelto
	b) il parente e': 
		- selezionato se tutti i child sono selezionati (quindi determinati)
		- de-selezionato se tutti sono deselezionati
		- de-selezionato e indeterminato se i primi due non veri
	se un elemento si cambia - deve essere aggiornato il parente (con algo precedente), cioe' ricorsivamente
 */
/*
 * .tree-cont - div containing <li>; contains data
 * .tree-item (tree-item-file, tree-item-dir) - <li> which receives folder onclick event
 * .tree-elem (tree-file, tree-dir) - <input> checkbox, contains 'checked' state, receives check/uncheck events
*/

//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT VARS (getters, setters, simples) -----------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

var detail_view = "thumbs"; // to switch thumbs/details;  = [thumbs,details]
function set_detail_view(view){ if(view!="thumbs" && view!="details") return /*error*/; detail_view=view; } 
// NOTE: it should be path (string, not dom elem)
var current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
var current_dir = ""; // added 24.01.20 ; properly path; 
var prev_current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
var target_dir = null; // the dir upon which last right click was made (popup target); js (not jquery) elem
var current_item = null; // CURREL NOTE: now it's id; may happen that curr elem not present in tree (show_files=0)
// NOTE: now use_paths in fact is equivalent to: 'allow show empty folders' (= do not check if a folder is empty (to hide it))
var use_paths = 0; // indicates how open folder: using paths table (open_dir_paths) or usual way (open_dir)
function set_use_paths(val){ use_paths=val; }
var shm_table_num = 0; // '0' now means not use shm
function set_shm_table_num(num){shm_table_num=num;}
var show_files = null;   // HIDEFILES indicates if need show files in tree view; (in MS normall only folders are shown)
function set_show_files(sf=true){show_files=sf;} // client should call it to set up if show files (def is yes (in contr))
var on_show_plain=null;
function set_on_show_plain(f){on_show_plain = f;} // ex-set_on_show_table
var user_dir = ""; // 14.01.20 MUSD
function set_user_dir(sd){user_dir = sd;}
function get_user_dir(){return user_dir;}
// used in space: hide tree explorer
var tree_hidden = false;
function hide_tree(){
	tree_hidden = true;
	set_show_files(false); // thus shrink data exchange
	$("#tt_explore_form").addClass("hidden");
	$("#tt_exp_btn_div .musd").detach().appendTo("#tt_thumbs_header");  // move buttons to thumb sect
}
function get_cont(elem){
	return elem.closest('.tree-cont');
}
function get_data(elem, param){
	var res = get_cont(elem).data(param);
	return (typeof res === "undefined")? "" : res;
}
function set_data(elem, param, value){
	get_cont(elem).data(param, value);
}
function get_item(cont){
	return cont.children('.tree-item').first();
}
function get_elem(cont){
	return cont.children('.tree-item').children('.tree-elem').first();
}
function get_parent(cont){
	return cont.parent('.tree-cont');
}
function get_thumb_cont(thumb_child){ // thumb_child is some inner elem - img or ref..
	return thumb_child.closest('.thumb');
}
function get_id_detail(id){
	return detail_view=="thumbs"? $("#tt_thumbs_form .thumb[data-id='" + id + "']") : $("#tt_thumbs_form .clickable-row[data-id='" + id + "']");
}
function get_id_elem(id){return $('#tt_explore_form .tree-file.id'+id);} // return elem by file id
function get_thumb_elem(thumb){
	var id = get_thumb_cont(thumb).data('id');
	return $('#tt_explore_form .tree-file.id'+id);
}
function get_path_cont(path){ // DIRTHUMB  find elem in dir-tree corresponding to a folder in thumb panel
	return cont = $("#tt_explore_form .tree-cont[data-path='" + path + "']");
}
function is_dir(elem){
	return elem.hasClass('tree-dir') || elem.hasClass('thumb-dir'); // latter is for detail elem
}
function is_file(elem){
	return elem.hasClass('tree-file');
}
// 
function dir_opened(cont){ // shows if the cont (from explorer) was opend and then closed; CORRECTION: seems now used to indicate if currently opened; for opened/closed is used opened_closed() 
	return get_item(cont).hasClass("ttc_folder_opened");
}
function set_table(t){ table_tree = t; }
function set_table_files(t){ table_files = t; }
function get_table(){return table_tree;}
function set_where(w=""){ table_where = w; }
function get_where(){return table_where;}
function get_target_dir(){return target_dir;}  //CURREL returns
function set_target_dir(td){ return (target_dir=td); }
function get_curr_dir_item(){return current_dir_item;}  //CURREL returns
function set_curr_dir(path){current_dir=path;}
function get_curr_dir(){return current_dir;}
function set_curr_dir_item(jquery_obj){ prev_current_dir_item = current_dir_item; current_dir_item = jquery_obj[0]; $(".tree-item.active").removeClass("active"); jquery_obj.addClass("active"); set_curr_dir(get_data(jquery_obj, "path"));}
function get_curr_item(){return current_item;}  //CURREL returns
function set_curr_item(item){ current_item = item;} // TODO: need sync curr item table-tree
function ro_set(fo){files_order = {"field" : fo.field, "order" : fo.order}; } // added 3.10.19 for MS; allow custom sort order; this func must be called by client;  DEF FIORD NOTE: actually more likely will be called innerly by table column click
// CLIENTSHOWDET 
function set_show_details( shd ){
	client_show_details_func = shd;
}
// SELIN
var on_select = 0;
function set_on_select(f){
	on_select = f;
}
var project_name = ""; // SHARE must equal to the name of php file in ./share/ folder
function set_project_name(pn){project_name=pn;}
var table_tree = "";
var table_files = ""; // corresponds to = of model/db.php
var table_where = ""; // additional condition applied when a node is opened; NOTE: now is applied only for opening and not for find/stat
var files_order = null; // FIORD
var table_tree_path = "table_tree/", contr_path = "table_tree/contr/main.php";
var client_show_details_func; // DEF CLIENTSHOWDET allso client to set its own show_details function; params: (file_id); used in mailstore to show mail contents in an inline panel
function set_table_tree_path(tp){ table_tree_path = tp; contr_path = tp + "contr/main.php"; }

function set_active_section(sect){
	$(".mc_tt_section").removeClass("mc_tt_active_section");
	$("#" + sect).addClass("mc_tt_active_section");
}
// now used only in sd_, but may may be used overall DEF MFB move files bug, found 26.06; to the contr is passed path without end-slash; firstly, found here that data-path not contains end-slash (not that name may be empty and needs no es), but bug persists
function tt_create_emtpy_folder(parent_path,name){ var es = name? '/':''; return $("<div class='tree-cont' data-path='" + parent_path + name + es + "'><li class='tree-item tree-item-dir'>" + name + "</li></div>"); }
function tt_get_elem_name(elem){ return elem.hasClass("mc_file")? elem.find(".file-ref").html() : elem.data("path"); }

//--------------------------------------------------- ESECT VARS (getters, setters, simples) -----------------------------------------------------------------


//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT UTILS  --------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT ADD_INFO --------------------------------------------------------------------------------
// DEF ADD_INFO stuff used to show some additional info for files/folders; user should provide funcs func(elem) and pass them by add_info_handler; normally user funcs use ajax
// object containing custom callback which is used to display additional info; the client should set the callback for each application
var add_data = {
	// called each time a result is added to the tree; param = parent element;
	// selects not processed file/dir items - <li> elements which contain visual data; calles user defined handlers; marks elements as processed;
	// then does same thing for folders
	run : function(parent_cont){
		parent_cont.find('.tree-item').each(function(index){
			var elem = $(this);
			var processed = elem.data('processed');
			if( typeof processed == 'undefined' || processed == false){ // not yet processed ~ attr 'processed' not yet exists 
				if( elem.hasClass('tree-item-file') )
					add_data.process_file( elem );
				if( elem.hasClass('tree-item-dir') )
					add_data.process_dir( elem );
				set_data(parent_cont, 'processed', true);
			}
		});
	},
	// THIS IS THE PART THAT USER MUST REDEFINE if necessary to add some additional visual data to html (or somehow process each added file/dir)
	// to get some data use get_data: 
	process_file: function(file){return true},
	process_dir : function(dir ){return true}
}
// adds 'additional info handler' - the function which adds some non-standard info about an element
// elem_type = file/dir/all
function add_info_handler(handler, element_type='all'){
	switch(element_type){
		case 'file': add_data.process_file = handler; break;
		case 'dir' : add_data.process_dir  = handler; break;
		case 'all' : add_data.process_file  = handler; add_data.process_dir  = handler;  // TODO: only this is used now;
	}
}

//--------------------------------------------------------- SUBSECT TABCOL ----------------------------------------------------------------
// DEF TABCOL setting up visible table columns
var visible_columns; // commented 24.04.20; now read from server;  = ["RES_checked", "date_mod", "subject", "correspondent", "attach_exist"]; // CB_SEL_REC  TODO: setter
function col_visible(name){ return visible_columns.includes(name); } // TODO: not used; info saved in pm?
function col_show(name){ visible_columns.push(name);}
function col_hide(name){ for(i=0;i<visible_columns.length;i++) if(visible_columns[i]==name) visible_columns.splice(i,1);}
function repeate_show_table(){ var page = $("#tt_pager").length? get_counter_val( $("#tt_pager") ) : 0; show_page(page);}
function tabcol_click(target, name, state){
	if(state)
		col_show(name);
	else
		col_hide(name);
	repeate_show_table();
}
// set initially visible columns and create popup to add/rem a col
function tabcol_init(){
	var vc = call_php_sync(contr_path, {'action' : 'visible_columns', 'project' : project_name}, 'POST');
	visible_columns = JSON.parse(vc.resp_text);
	var tc = create_popup_div();
	init_popup(tc, "mc_field_capt", null, true, "tt_thumbs_form");
	var req = call_php_sync(contr_path, {'action' : 'table_fields', 'project' : project_name}, 'POST');
	var fields = JSON.parse(req.resp_text);
	for( let name in fields)
		add_popup_checkbox(tc, fields[name], name, visible_columns.includes(name), tabcol_click);
}

//--------------------------------------------------------- SUBSECT FIORD ---------------------------------------------  
function ro_extract(header){ // used to find out (possible new) order field; this singled out to be used by others, TODO: maybe move to utils
	header = header.closest(".fh_header");
	var field_name = $(header).data("fhid");
	var new_dir = $(header).hasClass("mc_desc")? "asc" : "desc" ; // TODO: more correctly is to find dir so: if new_field==old_field => !old_order; else => asc (=def)
	return {"field" : field_name, "order" : new_dir};
}
function ro_show_order(parent_, tname, order){ // called once after table is shown, adds the corresp class to order-field (to show it)
	// $(".th-tt_detail-" + files_order.field).data("order", files_order.order); // also may use '#tt_thumbs_form .fh-header th[data-fhid]=<field>' (not checked) ; TODO: not works.. data attr change (run-time) - css not works
	if(order)
		$(parent_ + " .th-" + tname + "-" + order.field).addClass("mc_" + order.order);
}
function ro_to_str(files_order){ return files_order? files_order.field + " " + files_order.order : ""; }

//--------------------------------------------------------- SUBSECT ADD ACTION --------------------------------------------
// DEF AA adding action button 
// action is an obj: {id, handler (function defined in client), caption}
function add_action(action){
	$('#tt_buttons').removeClass('hidden'); // gets visible if at a button added
	var btn = $('#tt_buttons').append('<button type="button" class="btn btn-success btn-sm" id="' + action.id + '">' + action.caption + '</button>&nbsp;');
	// onclick contains some validation logic and then calls user handler, passing to it the list of selected paths
	$('#' + action.id).on('click',function(){
		var selection = find_selection();
		if( selection===0 )
			show_alert(lp("no_file_sel"));
		else
			action.handler(selection.paths, selection.files); // TODO: maybe call it by ajax (wait screen)
	})
	return $("#"+action.id);
}

//--------------------------------------------------------- SUBSECT SEL_FOL ---------------------------------- TODO: maybe move to utils
function sd_switch_dir_state(e){ // SEL_FOL
	var dir = $(this);
	var path = get_data(dir, 'path');
	var cont = get_cont(dir);
	var opened = dir_opened(cont);
	$("#tt_select_folder_root_item .tree-item.active").removeClass("active"); dir.addClass("active");
	set_selected_string(path); // MD_SS func; somewhat tricky mechanism to pass res dir to user; md_ss calls passed callback with that val
	if(opened){
		close_cont(cont);
	}else{ // not ever opened or opened/closed
		if(opened_closed(cont) ){  // opened&closed
			cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
		}else // not ever opened
			sd_open_dir(path, cont);
	}
	dir.toggleClass("ttc_folder_opened");
	dir.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: to use it need also set it true when showing already opened folders (show_tree)
}
function sd_open_dir(path, cont){ 
	wait_screen.add_operation("open_dir");
	xhr = $.ajax(acid("open_show_folder", {
		//data: {'path': path, 'cond' : table_where, 'use_paths': use_paths, 'shm_table_num': shm_table_num},  // table_where is for RECSUR
		data: {'path': path},  // table_where is for RECSUR
		success: function(res){
			if( res.length>2 ){ // empty json may be """"
				cont.append(res);
				cont.find(".col-lg-12").removeClass("col-lg-12"); // TODO: temp LG12
			}
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("open_dir");
		}
	}))
}
function sd_create_folder(){
	var name = document.getElementById("tt_new_folder_text").value;
	if(!name){alert(lp("ins_name"));return;}
	var parent = sd_get_selected();
	// NOTE: after adding SEL_FOL_ROOT parent must always be not null
	var parent_path = parent && parent.length? parent.data("path") : "";
	if(!parent || !parent.length)
		parent = $("#tt_select_folder_root_item");
	var new_fol = tt_create_emtpy_folder(parent_path, name);
	new_fol.find(".tree-item-dir").addClass("active");
	$("#tt_select_folder_root_item .tree-item").removeClass("active");
	parent.append(new_fol);
	set_selected_string(parent_path+name+'/'); // MFB, added end-slash
}
// SEL_FOL INTERFACE funcs
// callback(selected path or null)
function sd_select_folder(callback){ // SEL_FOL ex show_select_folder
	show_select_string(callback,"",$("#tt_select_folder"));
	$("#tt_select_folder_root_item").html("");
	// SEL_FOL_ROOT : if need move files to root folder - need have it in the dialog
	var root = tt_create_emtpy_folder("", "");
	//root.find(".tree-item-dir").addClass("active");
	$("#tt_select_folder_root_item").append(root);
	sd_open_dir("", root);
	root.find(".tree-item").addClass("active");
	$('#tt_select_folder').on('click','.tree-item-dir',sd_switch_dir_state);   // NOTE: need it here (although similar is in init but not work when place in init - maybe because div gets att/de-tached)
	// NEW_FOL
	$("#tt_new_folder_btn").click(sd_create_folder);
}
function sd_get_selected(){ var item = $("#tt_select_folder_root_item .tree-item.active"); return item.length? item.closest(".tree-cont") : null; } // not used now; also get_selected_string (of MD_SS) returns the same

//--------------------------------------------------------- SUBSECT REQUEST DATA ------------------------------------------------
// DEF RD sometimes it's necessary to repeate request; eg when user requests re-order files
var request_data = null;
function rd_set(data){ request_data = data; }
function rd_get(){ return request_data; }
function rd_run(){
	if(request_data)
	switch(request_data.type){
		case "open": 	open_dir(request_data.path, request_data.cont); break;
		case "open_rec": 	open_dir_recursive(request_data.item); break;
		case "find": 	find_files(request_data.params); break;
		case "refresh_cache": 	refresh_cache(request_data.childs); break;
	}
}

//--------------------------------------------------------- SUBSECT HIDEFILES_CACHE --------------------------------------------------------------------------
// for the given folder (cont) finds its files saved in cache; ouputs to the output param 'files'; return res = 'some files present'  HIDEFILES_CACHE
function get_file_cache_arr(cont, files, recursive=false){ // NOTE: designed to be used for find_opened_childs, so files is the output param
	var file_cache =  cont.children(".ttc_file_cache");
	if(file_cache.length){ // NOTE: can't just concat - it returns new array; TODO: actually useless conversion, need pass string to server
		var nf = file_cache.html().split(",");
		for(i=0;i<nf.length;i++)
			if(nf[i]!="")
				files.push(parseInt(nf[i]));
	}
	if(recursive){
		var childs = cont.find(".tree-item-dir");
		for(i=0;i<childs.length;i++)
			get_file_cache_arr( childs[i], files, true );
	}
	return files.length>0;
}
// DEF OPEN_CACHE (not used now, replaced with HIDEFILES_CACHE) : once folder is opened, data is kept even after close; so when re-open - this data is reused;
// find childs of already opened dir; if recursive - returns childs of all branch (not only immediate)
// TODO: PIT paths are passed itself (not ids) while do not know if can have id in all cases
function find_opened_childs(cont, folders, files, recursive=false){ // DIRTHUMB: added folders
	var files_hidden = get_file_cache_arr(cont, files); // NEW: get files from cache ( when HIDEFILES, files are not present (hidden) in the folder, just store them in cache  HIDEFILES_CACHE;
	cont.children('.tree-cont').each( function(a,b){ 
		var child_cont = $(this);
		if( is_file(get_elem(child_cont)) ){ // item is file  // TODO: may add here && not file_cache.length
			if(!files_hidden) //  !PFCA
				files.push(child_cont.data('id')); 
		}else{ // item is dir
			folders.push(child_cont.data('path')); 
			if (recursive)
				find_opened_childs(child_cont, folders, files, recursive);
		}
	} )
}
// show thumbs of an opened&closed folder
// TODO: here also must select what show - thumbs/table NOTE: 27.04.20 seems it not shows thumbs, only refreshes cache, so TODO: rename to on_select_opened
function show_opened_plain(cont){
	rd_set( {type:"open",path:cont.data("path"),cont:cont} ) ; // if open folder by unhiding data - anyway need set request data DEF BACK_UP: if click thumb-folder to go level up - r.d. contains invalid data, so need save it
	var folders = [];
	var files = [];
	find_opened_childs(cont, folders, files, false);
	var json_list = JSON.stringify({"folders": folders, "files": files});
	refresh_cache(json_list); // SARE
}
function opened_closed(cont){ // shows if the cont (from explorer) was opend and then closed 
	//return cont.children('.tree-cont:hidden').length > 0; 
	var cache = cont.children('.ttc_file_cache').length > 0;   // use this while ttc_folder_opened is not yet finished (not works for find)  HIDEFILES_CACHE; if PFCA - this suffies
	var hidden = cont.children('.tree-cont:hidden').length > 0; // TODO: this method not usable when emtpy dirs possible (in MH); need add some class to opened dir
	return !get_item(cont).hasClass("ttc_folder_opened") && (cache || hidden);
	//return !get_item(cont).hasClass("ttc_folder_opened") && get_item(cont).hasClass("ttc_folder_once_opened");
}
// DEF CACHE_REFRESH: normally, if user requests some data (open/find) happens following: 1. data request to server (data saved in cache) 2. view request to server (data taken from cache and view is built); (2) may be done several times (eg for different views); thus cache represents "current data" to be shown; but may happen that current data changes without (1), it happens when user re-opens folder and data is taken from local cache; in this case need first forse update server cache
function refresh_cache(childs){
	// rd_set( {"type": "refresh_cache", "childs": childs} ) ; // SARE   commented it for the bug BACK_UP ; this reseted the path that i set it show_opened_plain ; besides, this func takes data from r.d., so unlogical to set it here
	xhr = $.ajax(acid("refresh_cache", {
		data: {'childs' : childs}, 
		success: function(res){
			show_plain( childs, 1 ); // DIRTHUMB added folders
		}
	}))
}

//--------------------------------------------------------- SUBSECT CLEAR -----------------------------------------
// DEF H&B - to make flex work - table elems (header and body) must be on same level with other elems (header and pager), so can't just replace whole html, but need remove old stuff and add new (after marker)
function clear_detail(clear_pager=true){ // TODO: check how works for both details
	$('#tt_thumbs_form').find(".fh-elem").remove(); // remove table header/body
	$('#tt_thumbs_section').html(""); // remove thumbs
	if(clear_pager)
		$('#tt_thumbs_form').find("#tt_pager").remove();
	$("#tt_preview_body").html(""); 
}
function close_cont(cont){
	cont.children('.tree-cont').addClass('hidden');
}

//--------------------------------------------------------- SUBSECT POPUP (PUMA) ----------------------------------

// PUMA this wrapper is only necessary to find popup_div; is to be used by client
function tt_add_popup_item(caption, action, files=true, folders=true, notarget=false, custom_class=""){ // TODO: notarget is used to perform ops with selection; here also need control if there are some selected
	var popup_div = $('#tt_popup_div');
	var cl = (files?"ttc_pu_file ":"") + (folders?"ttc_pu_folder ":"") + (notarget?"ttc_pu_notarget":"") + " " + custom_class;
	return add_popup_item( popup_div, caption, action).addClass(cl);
}
// set up popup menu before showing it (depending on target and current situation)
function set_pu_items(target, popup_div){
	if( $(target).closest("#md_ss_div").length ){ popup_div.addClass("hidden"); return; } // TODO: quickfix not to show pm in SEL_FOL
	if( $(target).hasClass("tt_emp_explore_menu") ){ // if user clicked menu icon (not folder/file item) - then use active elem  DEF PM_EMB   NOTE: in momo first select then click menu; TODO: quite tricky, may do it without pm
		target = get_curr_dir_item();
		set_popup_target(target);
	}
	var td = $(target).closest(".mc_dir");
	var is_dir = set_target_dir(td.length? td[0] : null)!=null; 
	var tf = $(target).closest(".mc_file");
	var is_file = set_target_dir(tf.length? tf[0] : null)!=null; 
	var is_tree = $(target).closest(".tree-cont").length;  // OPEN_ALL_TREE
	popup_div.find(".ttc_pu_item").each( function() { 
		if($(this).hasClass("ttc_pu_notarget") || is_dir && $(this).hasClass("ttc_pu_folder") || is_file && $(this).hasClass("ttc_pu_file") ) // NOTE: some items visible only if have active file/folder
			$(this).removeClass("hidden");
		else
			$(this).addClass("hidden");
		if($(this).hasClass("mc_tree_only") && !is_tree) // DEF OPEN_ALL_TREE: open/close all must be enabled only if invoked on a tree elem
			$(this).addClass("hidden");
	} );
}

//--------------------------------------------------------- SUBSECT UTILS MISC TODO-----------------------------------------

function add_slash(s){ return s[s.length-1]=='/'? s : s+"/"; } // adds slash if not yet contains; at the moment it's disorder with having/not having end-slash
// handle search error situation
function search_error(j,errorS,p){
	var msg = '';	
	if(p == 'abort')
		msg = lp("search_stop");
	else if(j.status == 400 && p.indexOf('max_count')==0)
		msg = lpp("$too_many_found$", p.substring(10));
	else if(j.status == 400 && p.indexOf('not_found')==0)
		msg = lp("no_file_found");
	// some unhandled error
	else msg = lpp(p);
	if(p=="no_user"){ // LOGONEXP
		show_login();
		return;
	}
	// show msg
	show_alert(msg);
	j.done();
	//alert(msg);
}

// elem = js object 
function scroll_top_if_hidden(elem){
	if( typeof scrollIntoViewIfNeeded === 'function' )
		elem.scrollIntoViewIfNeeded(true);
	else
		elem.scrollIntoView(true);
}
// TODO: why not used?
function reset_table_tree(){
	$('#tt_explore_root_item').html("");
	clear_detail();
	si_reset();
}
function show_search_panel(){
	$("#tt_table_tree_div .mc_search_panel").css({'top': ($("#tt_table_tree_div").offset().top + 'px') }); $("#tt_table_tree_div .mc_search_panel").removeClass("hidden");
}
function hide_search_panel(){
	$("#tt_table_tree_div .mc_search_panel").addClass("hidden");
}
function show_folder_search(item){
	$(".ttc_filter_path").val( get_data(item, "path") );
	show_search_panel();
}	

// TODO: rename to tt_
function tt_download_file(){
	var id = get_curr_item();
	if(!id){ alert(lp("no_file_sel")); return;}
	download_file(table_tree_path + "download_file.php?id=" + id);
}

// usage: when user requests some action on selected items (eg delete selected files); the func finds selection and performs passed action-callback
function selection_action(action, confirm_msg=lpp("$continue$?"), ok_msg="OK", error_msg="error"){
	var sel = find_selection(); // tt funcs
	var snap_info = {'paths': JSON.stringify(sel.paths), 'files': JSON.stringify(sel.files) }; // NOTE: paths are not used now, maybe; need control if selecting folders in thumb form works
	// stat selected files
	wait_screen.add_operation(action);
	xhr = $.ajax({
		type: "POST",
		data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": user_dir, 'summary' : 1},
		url: 'contr/main.php',
		success: function(res){
			var count = res;
			if(confirm(lpp("$sel_n_files$, $2", res, confirm_msg))){
				xhr = $.ajax({
					type: "POST",
					data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": user_dir, 'summary' : 0},
					url: 'contr/main.php',
					success: function(res){
						alert(ok_msg);
						open_root_dir();
					}})
			}
		},
		complete: function(){
			wait_screen.remove_operation(action);
		}
	})
}

// used in REDI ; note: would be better to get file cache of curr dir, but wihtout root item (another reason to have always root item) it may be null
function tt_get_all_shown_thumbs(){return $("#tt_thumbs_section").find(".thumb.mc_file");}
//function tt_set_thumb_add_info(dataname, dataval, html){ $("#tt_thumbs_section").find("[data-"+dataname+"='"+dataval+"']").append( $("<div class='ttc_thumb_add_info'>" + html + "</div>") ); }
function tt_set_thumb_add_info(thumb, html, title=''){ thumb.append( $("<div class='ttc_thumb_add_info' title='" + title + "'>" + html + "</div>") ); }
function tt_reset_thumb_add_info(){$("#tt_thumbs_section").find(".ttc_thumb_add_info").remove();}

// ---- ALERT _----  TODO: move to a util lib
// 26.03.20 had to give tt_alert up while search panel (which holds it) is hidden normally; also other panels are shown/hidden dynamically, so hard to find some to hold it permanently; note: also search panel now hides upper screen part, so even can't use to container to show alert
function show_alert(msg, id="tt_alert"){
	alert(msg); return;
	var html = '<div class="alert alert-danger" role="alert">';
	html +='<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
	html +='<strong>' + lp('attention') + '!</strong><br>' + msg;
	html +='</div>';
	$('#' + id).html(html);
}
function clear_alert(id="tt_alert"){
	$('#' + id).html("");
}
// DEF SHARE: tricks to allow the same code to use for different projects (like needed in mh - to explore files and explore mails);
// acid (Add Controller Data) is just used to add the data which is sent in each controller call
// NOTE: in js params passed by ref note that sometimes data passed to contr is enormous, so passing to and fro by value would be costful
function acid(action,  params ){
	params.type = "POST";
	params.url = contr_path;
	if(!("data" in params))
		params.data = {};
	params.data.action = action;
	params.data.table = table_tree;
	params.data.table_files = table_files;
	params.data.project = project_name; // SHARE
	params.data.order = ro_to_str(files_order); // FIORD
	params.data.user_dir = user_dir; // MUSD
	if(show_files!==null) params.data.show_files = show_files?1:0; // HIDEFILES
	return params;
}

//--------------------------------------------------- ESECT UTILS  -------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT OPEN / FIND  -------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT OPEN / FIND MISC  --------------------------------------------------------------
// TODO: this should be counted in SARE?
function open_root_dir(cond=''){ // cond is set when making 'recursive search' 
	set_where(cond); // 3.10.19; added to solve prob: if make search then click 'explore' - keeps using filter; TODO: need bring in order all uses of cond/table_where
	$('#tt_explore_root_item').html('');
	open_dir('', $('#tt_explore_root_item'));
	si_reset();
}
function show_plain(json_list, id=0){ // can pass list of paths or ids (id=true)
	thumbs_list = json_list; // FIRE save thumb list to use to show next portion TODO: id=0/1 => json_list may have different formats, so thumb_list also may have diff. form?.. turns out that 'id' flag arrives always to show_thumbs_portion (but by params); the fact that thumb_list is global while 'id' local - makes some confusion
	// clear_detail(); commented: can't be here: if have 2 requests at same time - they both clear and then both add
	if(detail_view=="thumbs")
		show_thumbs_portion(0, page_size, id); // FIRE next portion
	else
		show_table_portion(); // DETA
}

var thumbs_list; // FIRE
var page_size = 50; // FIRE CASE  after each data fetch this should be re-set to 0;
// this function is called by pager and should call all other funcs which page output of files
function show_page(page){ // FIRE CASE TODO: do not get: now pages work only for DETA (not for thumbs)?
	clear_detail(false);
	show_table_portion((page-1)*page_size, false);
}
// closes removing (not hiding) child elems
function close_dir_recursive(item){
	var cont = get_cont(item);
	cont.children('.tree-cont').remove();
	get_elem(cont).prop('indeterminate', false);
	update_parent_selection(cont);
}
function show_panels(){
	if( !tree_hidden && $('#tt_explore_form').find('.tree-cont').length )
		$('#tt_explore_form').removeClass('hidden');
	if( $('#tt_thumbs_form').html()!="" )
		$('#tt_thumbs_form').removeClass('hidden');
}
// hides and clears panels
function hide_panels(hideTree=false){
	// return; TODO: commented this; why it was here?
	if(hideTree){
		$('#tt_explore_form').addClass('hidden');
		$('#tt_explore_root_item').html('');
	}
	if(!tree_hidden)
		$('#tt_thumbs_form').addClass('hidden');
	clear_detail();//$('#tt_thumbs_form').html('');
}
function def_search_fields(){
	var params = acid("search_fields", {}); // normally acid is used to return array for ajax; here is used only .data (while call_php_async takes several params instead of one object)
	var resp = call_php_sync(contr_path, params.data, 'POST'); 
	return resp.resp_text;
}



//--------------------------------------------------------- SUBSECT USER ACTIONS ------------------------------------------------

// e = tree-item; logic of opening a dir: if already was opened - show hidden childs and their thumbs; else - open_dir
function dir_click(e){ // NOTE: input not receives event on name click - it's out of input
	var dir = $(this);
	e.preventDefault();
	if(dir[0]==get_curr_dir_item()) // DBLOPEN
		switch_dir_state( dir , e.ctrlKey, e.shiftKey);
	else if( dir_opened( get_cont(dir) ) )
		show_opened_plain(get_cont(dir) ); // need show thumbs; not like at firs open - now find all ids and send to php TODO: it now uses HIDEFILES_CACHE, so maybe may be used even if !dir_opened 
	//
	set_curr_dir_item(dir); // CURREL
}
// 	find files action
function find_files_click(){
	if(ff_empty( $("#tt_search_form") ) ){
		show_alert(lp("no_filter_cond"));
		return false;
	}
	var recursive_search = $("#tt_find_recursive").prop("checked");  // RECSUR
	var params = ff_params($("#tt_search_form"));
	reset_table_tree(); // new, not checked
	if(recursive_search){ // ex-start_recursive_search()
		var where = compile_search(params);
		open_root_dir(where);
	}else
		find_files(params);
}

//
function switch_dir_state(dir, ctrl, shift){
	var path = get_data(dir, 'path');
	var level = get_data(dir, 'level');
	var cont = get_cont(dir);
	var opened = dir_opened(cont);
	// special reaction if ctrl pressed - open/close recursively
	if(ctrl){
		if(opened) close_dir_recursive( dir );
		else        open_dir_recursive( dir );
		return;
	}
	// normal open/close
	if(opened){
		close_cont(cont);
		hide_panels(false); // hide only thumbs panel
	}else{ // not ever opened or opened/closed
		if(opened_closed(cont) ){  // opened&closed
			cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
			show_opened_plain(cont); // need show thumbs; not like at firs open - now find all ids and send to php
		}else // not ever opened
			open_dir(path, cont);
	}
	// DEF SAVEOPEN need a way to say if a folder is opened independently on if it has some childs; reason: in MS diplaying files (=mails) in explorer may be turned off, so the old way "child.count>0" not works
	// TODO: now it's realized only for simple user click case; need also: recursive open; find-, find+ ...
	dir.toggleClass("ttc_folder_opened");
	dir.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: not used now; to use it need also set it true when showing already opened folders (show_tree)
}
// callbacks passed to clickable table
function on_row_select(state, id, path){
	// 1. sync thumb->tree
	var is_path = id==0; // DEF TODO: here 'if is path' detected by id==0 which is against DEF USE_PATH_ID - using also ids of paths
	if(is_path && path=="") select_all(state);
	var cont = null, parent_cont = null;
	if(is_path){
		cont = get_path_cont(path); // tree elem; note the trick: for a file this gives parent elem, for a thumb-folder - itself
		get_elem(cont).prop("checked", state);
		get_elem(cont).prop('indeterminate', false);
	}else{
		parent_cont = get_path_cont(path); // this finds elem's parent container, path = file path (without name)
		var elem = get_id_elem(id);  // if files are shown - need update tree-file elem
		if(elem.length)
			elem.prop('checked', state );
	}
	// 2.
	update_item(id, path, state, is_path, cont, parent_cont);
}
function on_row_active(elem){
	var path = elem.data("path");
	var cont = get_path_cont( path );
	if( is_dir(elem) ){
		// A this if/else segm duplicated from switch_dir_state
		if(opened_closed(cont) ){  // opened&closed   ; if upper-level dir is clicked - need just activate previously opened instead of re-opening to keep selected paths
			cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
			show_opened_plain(cont); // need show thumbs; not like at firs open - now find all ids and send to php
		}else // not ever opened
			open_dir(path, cont);
		// B open_dir(path, cont); replaced with A ; 
		set_curr_dir(path); 
	}else{
		var id = elem.data("id");
		show_details(id);
		set_curr_item(id);
	}
	if(cont.length) // DEF HIDETREE in space version explorer not shown ; need forsee situations when it not exists
		scroll_top_if_hidden(elem[0]);
}
function on_select_item(e){ // on_item_click on_click_item
	e.stopPropagation();
	update_item1($(this));
}
function row_order_click(header){
	ro_set(ro_extract(header)); // FIORD
	// TODO: refresh...
	rd_run();
}



//--------------------------------------------------------- SUBSECT SERVER DATA REQUESTS  ------------------------------------------------------------------------

function open_dir(path, cont){ // TODO: by idea cont.data("path") = path, so no need to pass it
	rd_set( {type:"open",path:path,cont:cont} ) ; // DEF SARE Save Request used for FIORD; save data of request to re-run when user requests change show order
	clear_alert();
	hide_panels(false); 
	wait_screen.add_operation("open_dir");
	xhr = $.ajax(acid("open_dir", {
		data: {'path': path, 'cond' : table_where, 'use_paths': use_paths, 'shm_table_num': shm_table_num},  // table_where is for RECSUR
		success: function(res){
			if( res.length>2 ){ // empty json may be """"
				// show child elems 
				render_childs('show_dir', path, res, cont, false, function(){
					// 20.11.18 select newly opened folders if parent was selected; this also selects thumbs
					if(path!="" && get_elem(cont).prop("checked") )
						set_childs_selected( cont, true ); // here not need yet set thumb state - they are not yet shown
				});
				// show plain 
				//show_plain(res); moved to render_childs
			}
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("open_dir");
			// show_panels();  TODO: wrong place for this: show_childs/thumbs only fire ajax which will be called asyncr.
		},
		//error: search_error,  commented 13.04.20 - if open empty ws - shows error; this is rather for empty search 
		global: false
	}))
}
function open_dir_recursive(item){
	rd_set( {type:"open_rec",item:item} ) ; // SARE 
	var path = get_data(item, "path");
	var cont = get_cont(item);
	var elem = get_elem(cont);
	clear_alert();
	hide_panels(false); 
	wait_screen.add_operation("open_dir");
	xhr = $.ajax(acid("open_dir_recursive", {
		data: {'path': path, "cond" : table_where},   // table_where is for RECSUR
		success: function(res){
			render_childs('show_tree', path, res, cont, false, function(){set_childs_selected(cont, elem.prop('checked') );}); // show_tree selects items by default, need deselect them
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("open_dir");
		},
		error: function(j,errorS,p){} // TODO: send 400 on empty res and catch it here
	}))
}
// RECSUR sets table_where; input = array of params (in format of search form); normally controller receives data in raw format (from form) and compiles, but sometimes compiled format is also necessary here (or rather always) 
// TODO: in fact it's called anyway if called find_files_click, so could call it from there, the only exception is that find_files may fail (in this case need table_where still = ''); but may unset where in search_error()
// TODO: the 'compile_search' action in contr uses the standard get_filter_fields() func, so can't be used to compile any search
function compile_search(params){
	var params_compiled_json = call_php_sync(contr_path, {'action' : 'compile_search', 'table' : table_tree, 'params' : JSON.stringify(params), 'project' : project_name}, 'POST');
	return JSON.parse(params_compiled_json.resp_text);
}
// performs search of files (calls php) according to filter form
function find_files(params){
	rd_set( {type:"find",params:params} ) ; // SARE 
// params - conditions from search form (not yet compiled, that is without info from metadata)
	set_where(); // cancel possible prev recursive search RECSUR
	clear_alert();
	hide_panels(true);
	wait_screen.add_operation("search");
	xhr = $.ajax(acid("find", {
		data: {'params' : JSON.stringify(params) , 'max_count': 7000, 'shm_table_num': shm_table_num},
		success: function(res){
			set_where( compile_search(params) ); // new 12.03 this is only used when finding statistics   DEF FIND_COND save find params in table_where to use them on folder opers like stats, size (now may select also folders in find res)
			// show tree 
			$('#tt_explore_root_item').html("");
			var renderer = $("#tt_full_view").prop("checked")? "show_tree_complete" : "show_tree"; // tt_full_view - button "+" (search plus)
			render_childs(renderer, "", res, $('#tt_explore_root_item'), true, null, true);
			// show thumbs
			show_plain(res);
		},
		error: search_error,
		complete: function(xhr, stat){
			wait_screen.remove_operation("search");
		}
	}))
}
//--------------------------------------------------------- SUBSECT SERVER VIEW REQUESTS ------------------------------------------------------------------------
//INITIAL VIEW REQUEST (show as tree and call other (plain) views (table/thumbs) ---------------------------------------------------------------------------------

// shows files; input: files list in json format (found previously by open_dir or find_files); output: result html is added to the cont
// TODO: donno why, wait screen show is made only by search_started (not show_started), so need call former before calling render_childs; or need show screen also in show_started (better)
// INC DEF : when files are res of search - that means that a folder childs are (may be) incomplete - exist other, not displayed files of this folder; when a file is deselected and the selected and it's the only file in its folder - the parent folder is set selected by update_parent_selection); that causes wrong selection result: folder is sent as selected and all files in it are included; possible solutions: 1. disable parent selection in 'find mode' or 2: not send at all paths in 'find mode'; may happen that user may want to select the whole folder on purpose, meaning that needs all files from it, thus the (2) not fits, so use (1); Realization: find_files passes further info that folders may be incomplete and the 'incomplete' class is added to files and accounted for in update_parent_selection(). 
var found_count = 0; // FIND_COUNT found in render_childs but used in show_thumbs_portion (while takes much time between these calls and info already fades); TODO: need some better way to sync
// renderer = show_dir/show_tree/show_tree_complete
function render_childs(renderer, path, json_list, cont, close_selected=true, call_back=null, incomplete=false){ // renderer - is the name of contr/main function which should process json list
	wait_screen.add_operation("show_tree");
	xhr = $.ajax(acid(renderer, {
		data: {'path' : path, 'childs' : json_list}, // TODO: was used encodeURI... which not works  TODO: path seems not used; but now use it as "start_path" for the open_dir_recursive (contr/main show_tree/show_tree_id)
		success: function(res){
			cont.children('.tree-cont').remove(); // this may be useful when re-request SARE
			cont.append(res);
			add_data.run(cont);
			found_count = cont.find(".tree-item-file").length; // FIND_COUNT remember count
			if(incomplete) $(".tree-cont").addClass("incomplete");  // INC
			$('.indeterminate').prop("indeterminate", true); // NEW to show half-selected state
			// new 21.09.18 after showing a sub-tree may be convenient not to display contents fully selected nodes; note: can't just call it after render_childs call, the latter is async
			if(close_selected)
				cont.find('.tree-dir:checked').each( function(){  close_cont(get_cont( $(this) ) ) ;	});
			// HIS Hidable Instrument Panel // this event indicates that need close nagiv panel (this happens only on successfull search)
			$(".tt_hide_on_render").addClass("hidden"); // TODO: what is this
			// now used only to select child files in open_dir
			if( call_back ) call_back(); // call it before show_plain, while latter makes selection synch
			// new: show thumbs is here now; othewise selection synch not works (starts when files not yet shown) TODO: bug: before, it wasn't called for case: renderer=show_tree_id - here need call show_plain(list, true)
			var id = renderer=="show_tree_id" || renderer=="show_tree_complete_id"? 1 : 0; // show_plain need to know what is in list - full info or ids TODO: temp solution
			show_plain(json_list, id);
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("show_tree");
			show_panels();
		}

	}))
}

// FIRE need two separate funcs: one which resets fire, other - which proceeds
function show_thumbs_portion(from, cnt, id=0){ // can pass list of paths of ids (id=true)
	wait_screen.add_operation("show_thumbs");
	var rd = rd_get();
	var path = "path" in rd? rd["path"] : ""; // THUMB_UP need pass the opened path (is null in find)	
	xhr = $.ajax(acid("show_thumbs", {
		data: {'childs': thumbs_list, 'id': id, "start" : from, "max_count" : cnt, "path" : path}, // TODO with server cache no need of thumbs_list, id
		success: function(res, bla, request){
			set_active_section("tt_thumbs_form"); // TOGSCT
			if(from==0) clear_detail();
			$('#tt_thumbs_section').append(res)
			path_to_detail_selection(); // select recs/thumbs depending on selected folders
			show_panels();
			// FIRE
			var remain = request.getResponseHeader("remain");
			show_hide_id(remain, ["tt_more_thumbs_div"]);
			if(remain)
				$('#tt_more_thumbs').data("from", from+cnt).data("count", cnt).data("id", id);
			if(on_show_plain)
				on_show_plain();
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("show_thumbs");
			if(found_count>page_size) show_info(lpp("$found_n_files$", found_count)); found_count=0; // FIND_COUNT TODO: uses a function of archive.js ; need inject some function instead
		}
	}))
}
function more_thumbs_click(){show_thumbs_portion($('#tt_more_thumbs').data("from"), $('#tt_more_thumbs').data("count"), $('#tt_more_thumbs').data("id"));} 
// DETA show details as table
function show_table_portion(start = 0, first_time=true){ 
	wait_screen.add_operation("show_table");
	xhr = $.ajax(acid("show_details_table", {
		data: {"start" : start, "max_count" : page_size, "visible_columns" : JSON.stringify(visible_columns)},
		success: function(res, bla, request){
			if(res){
				clear_detail(); // TODO: moved from show_plain, not tested for table-view
				$(res).insertAfter("#tt_thumbs_form #tt_before_detail");
				set_active_section("tt_thumbs_form"); // TOGSCT
				$('#tt_thumbs_form .fh-header tr').addClass("mc_section_header"); // height/color
				show_panels();
				// FIXHEAD necessary only for DETA need call it after show_panels()
				ro_show_order('#tt_thumbs_form', "tt_detail", files_order);
				$(".td-tt_detail-date_mod").each( function(){ $(this).html( shrink_date( $(this).html() ) );  }  );
				fh_init_table( $('#tt_thumbs_form') );
				// make_clickable( on_row_select, on_row_active);  // SEL_SYNC  commented 26.02; now should work that call in init()
				if(on_show_plain)
					on_show_plain(); // 22/11/19 add user callback; used to show attachment image
				$("#tt_thumbs_form .fh-header").addClass("tt_demo_hidden"); // DEHO
				path_to_detail_selection(); // select recs/thumbs depending on selected folders
			}
			if(first_time){
				var count = request.getResponseHeader("count"); // total count; server returns only portion
				$("#tt_more_files_div").find("#tt_pager").remove();
				var max = Math.trunc( parseInt(count)/page_size + 0.99999);
				if(max>1) // if need pager
					$("#tt_thumbs_form").append( create_counter("tt_pager", show_page, 1, max, 1) );
			}
		},
		complete: function(xhr, stat){ // TODO: guess need move some stuff to 'success:'
			wait_screen.remove_operation("show_table"); 
		}
	}))
}

function show_details(file_id){
	if(client_show_details_func){
		client_show_details_func(file_id);
		return;
	}
	//window.open(table_tree_path + 'show_file_details.php?id='+file_id + t, "File details"); // here better use files table (default) (not some view)
	//document.getElementById('tt_preview_body').src = table_tree_path + 'show_file_details.php?id='+file_id; // show in same tab but in another frame
	$("#tt_preview_body").html( call_php_sync(contr_path, {"action": "print_preview", "id": file_id, "table": table_tree}).resp_text ) ;
}

//--------------------------------------------------- ESECT OPEN / FIND ----------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT SELECTION  -------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT SEL_CACHE ---------------------------------------------------------------------
/* DEF SEL_CACHE 31.12.19 ; problems at the moment:
	- if folder selected and show next page - files of next page not selected (in detail);
	- page selection not saved (if show next page)
  to resolve that - need add selection cache; need save selection independently on shown items (page) ; 
  also convenient to save folder content in cache (or else need re-query... or use selection cache?
  NOTE: if a file is present in detail - that means exists its immediate parent folder in explorer
*/
var si_list = {}; // list of all selected ids; map: path -> [ids] ; this struct allows to also use it as cache of ids for a path (not yet opened) ; paths have endslashe - it allows to easily find if one path contains another
// NOTE: is async ; to use it's result - need pass callback
function si_add_path(path,callback=null){
	xhr = $.ajax(acid("find_path_ids", {
		data: {'path': path, 'cond' : table_where}, // need it in recursive search; NOTE: in normal search it's better to take info from file cache
		success: function(res, bla, request){
			stat = JSON.parse(res);
			if( (typeof stat)==='object')
				merge_object( si_list, stat );
			if(callback)
				callback();
		}
	}))
}
// remove path and all subpaths
function si_remove_path(path){
	//path = append_slash(path);
	var paths = Object.keys(si_list); // pre-select keys, while object will be modified
	for(i=0;i<paths.length;i++)
		if( paths[i].startsWith(path) )
			delete si_list[paths[i]];
}	
function si_add_id(path, id){
	//path = append_slash(path);
	id = id.toString();
	if( !(path in si_list) ) 
		si_list[path] = [];
	if( !si_list[path].includes(id) )
		si_list[path].push(id);
}

function si_remove_id(path, id){
	id = id.toString();
	//path = append_slash(path);
	if( !(path in si_list) ) throw "bug, path missing in si";
	si_list[path].splice( si_list[path].indexOf(id), 1 );
}
function si_reset(){ si_list = {}; }
function si_find_all(){
	var res = [];
	for(let path in si_list)
		for(i=0;i<si_list[path].length;i++)
			res.push( si_list[path][i] );
	return res;
}
function si_get_path(path){ /*path = append_slash(path);*/ return path in si_list? si_list[path] : []; } // normally path always present

//--------------------------------------------------------- SUBSECT SELECTION BASIC ---------------------------------------------------------------------

// returns lists of selected files folders {paths:, files:} ; performs also exclusion of selected sub-paths
function find_selection(){
	/*if($('#tt_explore_form .tree-elem:checked').length == 0 && 
		$('#tt_thumbs_form .data-row.selected').length == 0 &&
		$('#tt_thumbs_form .thumb.selected').length == 0 ){ // SELREC
		return {"paths":[],"files":[]};
	} it was used just for speed, commented while tree-elem not works in space */
	// building unique list of paths; 
	// build list of all paths
	var all = [];
	// $('#tt_explore_form .tree-file:checked').each( function(index){ all.push( get_data($(this), 'path') ) }) ; commented 16.01.20 ; now path is only path (PATH/NAME) and besides may be empty for files in root dir; so need use sel cache instead
	$('#tt_explore_form .tree-dir:checked').each( function(index){ 
		if(!get_cont( $(this) ).hasClass("incomplete") )  // INC_CORR  folders are not added if incomplete (only internal files will be added)
			all.push( get_data($(this), 'path') ) })
		
	// TODO: donno if next code to exclude doubles (files inside selected folders) is necessary (now has 'incomplete' class)
	all.sort();
	var unique = [];
	var unique_prev = '';
	for(i=0;i<all.length;i++)
		if( unique_prev.length && all[i].startsWith( unique_prev ) 
			&& unique_prev[unique_prev.length-1]=='/' ) // need also check that prev elem is folder; or else may happen one file name contains other (and will be omitted); TODO: not a good way to check if elem is a folder; may happen that paths will be passed without endslash
			continue;
		else
			unique.push(unique_prev = all[i]);
	// select all elems of fil/dir class
	var sel_paths = [];
	var sel_files = [];
	$('#tt_explore_form .tree-dir:checked').each( function(index){ var path = get_data($(this), 'path'); if(unique.indexOf(path)>=0) sel_paths.push( path ); }) // TODO: DEF PTI Path To Id - use path_id instead of path;
	$('#tt_explore_form .tree-file:checked').each( function(index){ var path = get_data($(this), 'path'); if(unique.indexOf(path)>=0) sel_files.push( get_data($(this), 'id') ) })


	// TODO 1: properly do not understand... why need all, why need unique, why need check if sel_paths/sel_files is in unique... the XXX could have sense if eg show_files = false and then select ids from table and then include only those of selected paths...


	// new 15.11.19 DEF SELREC: add selected recs from table TODO: not checks unique (maybe not necc)
	// when a folder selected - sel think selects only recs of current page (besides, no recs shown/selected if folder yet closed); in general case - if a folder is selected - should add to selection only the folder, not files, which may be incomplete
	/* A
	$('#tt_thumbs_form .data-row.selected').each( function(index){ 
		var path = add_slash( $(this).data('path'));  // rec data-path - is only path without file name;
		var id = $(this).data('id');
		if(all.indexOf(path)<0 && sel_files.indexOf(id)<0) // rec path isn't in sel folders and id isn't in sel files
			sel_files.push( $(this).data('id'));
	}); */
	// new: using si 3.1.20 (instead of A)
	for(let path in si_list){
		var ins = false; for(i=0;i<sel_paths.length;i++) if( path.startsWith(sel_paths[i]) ){ins=true;break;} if(ins)continue;// omit file if under some sel path
		for(i=0;i<si_list[path].length;i++)
			if( sel_files.indexOf( si_list[path][i] )<0) // rec path isn't in sel folders and id isn't yet in sel files
				sel_files.push(si_list[path][i]);
	}
	//
	return {"paths": sel_paths, "files": sel_files};
}

// all child elements of selected/deselected element are set to the same (new) state
// selection logic: if some elem is unselected - all chain of its parents is unselected
function update_item1(elem){
	var path = get_data(elem, "path");
	var id = get_data(elem, "id");
	var selected = elem.prop('checked');
 	update_item(id, path, selected, is_dir(elem), get_cont(elem));
}
// the actual action for the onselect event
// NOTE: when no files shown and the target is a file - can't pass target tree-elem, instead find and pass the parent folder (parent_cont)
// used also for SEL_SYNC detail -> tree (called from on_row_select
// NOTE: seems only one of cont/parent_cont is not null: is path? - cont!=null else parent_cont != null
function update_item(id, path, selected, isdir, cont=null, parent_cont=null){
	if(cont)
		set_childs_selected(cont, selected);
	// SEL_CACHE 1.1.20
	if( isdir ){
		if(selected)
			si_add_path(path, path_to_detail_selection); // ajax! thus can call path_to_detail_selection only as callback
		else{
			si_remove_path(path);
			path_to_detail_selection($(this));   // SEL_SYNC TREE-DETAIL 
		}
		
	}else{
		if(selected)
			si_add_id(path, id);
		else
			si_remove_id(path, id);
		// SEL_SYNC TREE-DETAIL 
		var det = get_id_detail(id);
		set_detail_select(det, selected); // quick way to sync - only change one elem
	}
	// NOTE: moved it after sel cache, parent sel should be updated after sel cache is set
	if(cont){
		update_parent_selection(cont);		
	}else if(parent_cont)
		update_parent_selection(parent_cont, false);		
	if( on_select ) // client callback; now used only for SELIN NOTE: could call it from set_childs_selected - but sometimes it's just extra work (when all childs of selected parent are set selected)
		on_select( find_selection() );
}
// set all childs of given cont to give state
function set_childs_selected(cont, selected, call_onchange=true){
	cont.find('.tree-elem').each(function( index ) { // this selects checkbox of the container and its childs
		if(index!=0){ // this is to avoid changing state of the parent-cont itself, which may be undesirable (in open_dir_recursive)
			$(this).prop('checked',selected); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
			$(this).prop("indeterminate", false); // only this was necessary to solve SEL_ANIMALS
			//$(this).trigger("change"); // onchange isn't envoked when state changed by js, so call it here; commented while onchange is for single elem click; besides not always necessary
		}
	});
}

// find_parent false allows to update selection of passed elem (not of parent); used (maybe temp) in on_row_select
function update_parent_selection(cont, find_parent=true){
	if(!cont) return; // used by on_row_select
	// if( cont.hasClass("incomplete") ) return; // INC parents remain always unselected (only may select manually)    DEF INC_CORR - correction: instead of keep folders 'incomplete' always de-selected - do not add them at all (in find_selection); when a folder selected - all files in it will be selected (and added); thus have same logic as in 'search minus' and other similar; thus can't select whole folder (including files not satisf. cond), which yet may be necessary. for this - need use 'search plus' mode
	var par = find_parent? get_parent(cont) : cont;
	if(!par.length) return;
	// var re = $('#tt_explore_root_item');	if(!par.length)	if(cont[0]==re[0]) // top level reached	return;	else	par = re; thought it would resolve the SEL_ANIMALS, but nope (it's updating of the parent not item itself (no need to update root container))
	// A: check selection state of all immediate childs (files/folders)
	// NOTE: with SELECTION this is used only to check dirs; TODO: when SELECTION tested - need remove checking files from here (use .tree-cont.tree-dir seems)
	var all_sel = true;
	var all_desel = true;
	par.children('.tree-cont').each( function(){
		var elem = get_elem( $(this) );
		if(is_dir(elem)){ // 10.01.20; found out that counting files here makes bug: tree elem hasn't yet changed its state, so disinforms; besides, files are counted in "C"
			var sel = elem.prop('checked')
			var ind = elem.prop('indeterminate')
			all_sel = all_sel && sel && !ind; // here actually ind === false
			all_desel = all_desel && !sel && !ind;
		}
	} );

	// C NEW: need also count selected recs (when HIDEFILES) 1. find all selected 2. filter those of curr fold (by idea table shows only active folder)
	// NOTE: by idea this func is called only when 'par' is already opened, thus has file cache
	// NOTE: used only to check immediate files (not folders); TODO: may instead check all selection files of path/* - in this case do not need check dir selection state ( A ).. but thus will need to find path/* childs for each path elem (slow)
	var cache_files = [];
	if( get_file_cache_arr(par, cache_files) ){
		var cont_sel = si_get_path( get_data(par, "path") ); // NOTE: so both cache files and selection cache represent only immediate childs
		all_sel = all_sel && cont_sel.length==cache_files.length;
		all_desel = all_desel && cont_sel.length==0;
	}

	// set found selection and recurse to parent
	var par_elem = get_elem(par);
	par_elem.prop('checked',all_sel); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
	par_elem.prop('indeterminate', !all_sel && !all_desel); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
	update_parent_selection( par );
}

function select_all(state=1){ // this would be much easier if having always root element TODO:
	$("#tt_thumbs_form").find(".thumb").not(".mc_root").each(function(){
		var elem = $(this);
		if(state) elem.addClass("selected"); else elem.removeClass("selected");
		on_row_select(state, elem.data("id"), elem.data("path"));
	});
}

//--------------------------------------------------------- SUBSECT SEL_SYNC --------------------------------------------------------
// DEF SEL_SYNC synchronize what's selected/deselected in table view with tree view
// at the moment: is update tree explorer and called update_item, that is: 1. sync thumb->tree 2. call tree.onchange
function set_detail_select(elem, selected=true){
	if(selected)
		elem.addClass('selected');
	else
		elem.removeClass('selected');
}
// 25.12.19 made to sync selection: sel folders -> sel recs; at least when files not shown in explorer need select 'manually' all recs which paths are inside selected paths
// TODO: guess need realize it also for thumbs while they also are shown in portions
// elem is passed from folder onchange - need deselect files of this folder if it gets unchecked (may be other details selected not of this folder)
// NOTE: seems elem was passed only if elem is file, while in update_child_selection is passed only for file
function path_to_detail_selection(elem=null){
	if(tree_hidden) return; // added 16.06.22; this func duplicates and breaks the work of make_clickable
	var detail_class = detail_view=="thumbs"? ".thumb" : ".data-row";
	// X new 28.01.20 ; need first deselect all, or else sync not works on deselect sms in tree
	$("#tt_thumbs_form").find(detail_class + ".selected").removeClass("selected"); // DEAL
	// if folder unchecked - uncheck all files
		// if folder unchecked - uncheck all files TODO 1: useless, while already was desel in DEAL
	if(elem && !elem.prop("checked") ){
		var path = get_data(elem, "path");
		$("#tt_thumbs_form").find(detail_class + ".selected").each(function(){
			if( $(this).data("path").startsWith( path ) )
				$(this).removeClass("selected");
		});
	}
	var sel = find_selection(); // guess func called many times; maybe save res in cache TODO:
	var sel_paths = sel.paths; // have end slash
	for(i=0;i<sel_paths.length;i++)
		$("#tt_thumbs_form").find(detail_class).each(function(){
			if( $(this).data("path").startsWith( sel_paths[i] ) )
				$(this).addClass("selected");
		});
	// new 3.1.20 count also sel files cache
	$("#tt_thumbs_form").find(detail_class).each(function(){
		var path = $(this).data("path");
		var id = $(this).data("id").toString();
		if( path in si_list && si_list[path].includes(id) )
			$(this).addClass("selected");
	});
	// TODO: quickfix : SELALL if click '.' folder to select all - it gets deselected in 'X' (comment: donno what is 'X'; the code makes the thumb root elem (curr dir elem?)  selected if all not root elems are selected
	if( $("#tt_thumbs_form").find(detail_class).not(".mc_root").length == $("#tt_thumbs_form").find(detail_class + ".selected").not(".mc_root").length )
		$("#tt_thumbs_form .mc_root").addClass("selected");
}
//--------------------------------------------------- ESECT SELECTION  -------------------------------------------------------------------------------


// --------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT INIT -------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------------------

//$(document).ready(function(){ // all the rest of the file
// TODO: passing search fields here is now useless, while need same fields both in 'build form request' and in 'find' request; see get_filter_fields in contr/main.php; thus at the moment need change get_filter_fields in contr/<project.php>
function init_table_tree(holder, search_fields_html='' ){ // sets handlers
	var xhr = ''; // ajax request; need var to be able to abort it TODO: requests may be nested;

	// html
	var resp = call_php_sync(contr_path, {'action' : 'render'}, 'POST'); 
	$(holder).html(resp.resp_text);
	if(detail_view=="thumbs"){
		$("#tt_thumbs_header,#tt_thumbs_section").removeClass("hidden");
	}
	make_clickable( null, on_row_active, "#tt_thumbs_form", detail_view=="thumbs"? ".thumb" : ".clickable-row");  // SEL_SYNC
	his_init(); // call manually while here html is added by js and may be added before automatic call (when yet no elems added)

	// search fields
	if(search_fields_html!=""){
		$('#tt_search_form').prepend(search_fields_html);
		ff_init("tt_search_form", find_files_click , false); // false means do not search on select/date change 
		$('#tt_search_btn').click( find_files_click );
	}
	// tips
	//$("#sf_path").data("tip", "path_filter"); // TODO: not works! (js works) this only sets data-tip=..
	var sfp = document.getElementById("sf_path");
	if(sfp) sfp.dataset.tip = "path_filter";
	set_tips(); // TODO: archive func  TIPS

	/// click of the link Esplora cartelle
	$('#tt_explore_btn').on('click', function(){open_root_dir();}); // note: wrap in func to avoid pass event obj as param 
	$('#tt_show_search_btn').on('click', show_search_panel); // TODO: added quickfix to set panel top
	$('#tt_search_close_btn').on('click', hide_search_panel); // note: wrap in func to avoid pass event obj as param 
	//
	// open/close item
	//$('#tt_explore_form').on('click','.tree-item-dir',dir_click);
	$('#tt_explore_form').on('click','.tree-item-dir',dir_click);   // DEF DBLOPEN  first click on a dir (not yet current) only selects it; second - switches state; thus dbl click on non current element switches its state
	// logic of selecting
	$('#tt_explore_form').on('click','.tree-elem', on_select_item); // TODO: better onchange?
	// SHOW DETAILS 
	$('#tt_explore_form').on('click','.tree-item-file',function(e){
		e.preventDefault();
		var file_id = get_data($(this), 'id');
		show_details(file_id);
	})
	/* TODO: instead of this: select made on checkbox; active made on thumb click
	$('#tt_thumbs_form').on('click','.file-ref',function(e){
		e.preventDefault();
		var file_id = get_thumb_cont($(this)).data('id');
		show_details(file_id);
	}) */
	$('#tt_explore_form').on('click', '.download', function(e){ // TODO: not used in archive
		e.stopPropagation(); // avoid call of tree-item handler
		//$.post(table_tree_path + 'contr/download.php', {'path': get_data($(this), 'path')})
	})
	$('#tt_search_cancel_btn').on('click',function(){  // TODO: same button does two different things - clears form and stops request;
		if(xhr && xhr.readyState!=4)
			xhr.abort(); // TODO: at the moment it may be empty
		ff_clear( $('#tt_search_form') );
		open_root_dir();
	})
	$('#tt_search_clear_btn').on('click',function(){  
		ff_clear( $('#tt_search_form') );
	})
	//
	// thumb of file under cursor  IMG_HINT 
	$('#tt_explore_form').on('mouseenter','.tree-item-file',function(e){
		var thumb = call_php_sync(contr_path, {'action': 'file_thumb', 'id': get_data( $(this), 'id'), 'quiet':1} );
		img_hint_show(thumb.resp_text, e.pageX, e.pageY);
	});
	$('#tt_explore_form').on('mouseleave','.tree-item-file',function(e){
		img_hint_hide();
	});

	/* DEF TODO BUG DOUBLE_SEL don'tunderstand why sel logic is both here in tt and in make_clickable (called from here) */
	// DEF SELALL - stuff to select all recs (checkbox in header) TODO: make same for thumbs?
	$("#tt_thumbs_form").on("click", ".th-tt_detail-RES_checked", function(){
		$(this).toggleClass("selected");
		var sel = $(this).hasClass("selected");
		$("#tt_thumbs_form .fh-body tr").each( function(){
			if(sel) $(this).addClass("selected"); else $(this).removeClass("selected");
			on_row_select(sel, $(this).data("id"), $(this).data("path") );
		});
	} ); 

	// hide instrument panel 
	//$("#tt_explore_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS Hidable Instrument Panel
	//$("#tt_search_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS
	// this not works, focus is on some inner elems instead // $("#tt_left_header").focusout(function(){ hide_id('tt_left_header'); });  document.getElementById('tt_left_header').focus(); // HIS

	//spinner = new Spinner(); moved to wait_screen
	 
	//PUMA  this is necessary to show popup (now is done by ctrl-left click); if use - need also add checks opened/closed 
	var popup_div = create_popup_div("tt_popup_div"); // id is only necessary to add css
	init_popup(popup_div, "mc_file", set_pu_items);
	init_popup(popup_div, "mc_dir", set_pu_items); // SELREC
	init_popup(popup_div, "ttc_emb_pm_detail", set_pu_items, true); // in MOMO pm is called on special icon click (embedded popup menu fro detail) 
	tt_add_popup_item(lp("close_all_folders"), close_dir_recursive, false, true, false, "mc_tree_only");
	tt_add_popup_item(lp("open_all_folders"), open_dir_recursive, false, true, false, "mc_tree_only");
	tt_add_popup_item(lp("search_folder"), show_folder_search, false, true); // FILTERPATH add button
	
	// RECSUR clear search condition when toggle button unpressed
	$('#tt_find_recursive').on("change", function(){ 
		if(!$("#tt_find_recursive").prop("checked")) set_where();
	});
	// allow unset both radio buttons
	add_untoggle( $("#tt_search_modes") );
	// FIORD sorting by table header click
	$("#tt_thumbs_form").on("click", ".mc_row_order", function(){row_order_click(this);});
	// TABCOL
	tabcol_init();
	// TOGSCT buttons < >
	$(".mc_togsect").each( function(){
		var b = $(this); 
		var ts = b.data("ts");
		b.click( function(){ set_active_section(ts); }	);
	} );
	// ARROW_MOVE
	$(".mc_tt_section").on("click", "*", function(){
		var section = $(this).closest(".mc_tt_section");
		$(".mc_tt_section").removeClass("mc_focused"); section.addClass("mc_focused");
	}); // need manually track which section is  focused

}

//--------------------------------------------------- ESECT INIT -------------------------------------------------------------------------------

