<?php




        require_once(dirname(__FILE__)."/db.php");
	// create zip with given set of files; files have relative path and are under $start_dir;
	// to add all files of start_dir - pass $files=array(), $paths=array("") (default)
	function tt_create_files_zip($start_dir, $paths=array(""), $files=array(), $zip_name=""){ // TODO pass where possible zip_name to avoid another copy
		$files_all = tt_find_selection($start_dir, $paths, $files, "id,path,name", "path" );
		log\info("creating zip, files: ", sizeof($files_all));
		// create link and get id
		$code = generate_random_string();
		//db\execute("insert into ziplinks (user_id, code) values($user_id, '$code')"); $zip_name = zip_path.$link_id.".zip";
		// create zip
		if(!$zip_name)
			$zip_name = temp_path.generate_random_string().".zip"; // now this file is temp, hope no collisions NOTE: some clients expect zip to be exactly in temp_path (download.php) to control if zip was created (or original was returned)
		log\debug($zip_name);
		$zip = new ZipArchive; // apt-get install php5.6-zip
		if(! $zip->open($zip_name, ZipArchive::CREATE | ZipArchive::OVERWRITE)) 
			throw new Exception("create zip fail"); // TODO: this may happen if file is busy (possible in ic3)
		set_time_limit(0);
		foreach($files_all as $file){
			$path_rel = $file["path"].$file["name"];
			//$source_path = trar_src($path_rel);  // DEF ONMERGE stuff which is to be corrected when make one general version; this is commented while trar used only in ic now
			// $source_path = get_source_path();   better, but need use it also for thumbs
			$source_path = source_path;

			$excl = strlen($source_path.$start_dir); // need exclude eg source_path/workspace/ws_name/
			$path = $source_path.$path_rel;
			$zpath = substr($path, $excl);
			log\debug("added $path $zpath");
			if( is_file($path) ) // TODO 1: trar throws if not exists, so this not nec
				$zip->addFile($path, $zpath);
			else
				log\error("file not found: '$path'");
		}
		if(!$zip->close())
			throw new Exception("failed to write zip");
		return $zip_name;
	}

	function tt_create_zip($start_dir_db, $files_all, $zip_name="", $start_dir=""){ // TODO pass where possible zip_name to avoid another copy
		log\info("creating zip, files: ", sizeof($files_all));
		// create link and get id
		$code = generate_random_string();
		//db\execute("insert into ziplinks (user_id, code) values($user_id, '$code')"); $zip_name = zip_path.$link_id.".zip";
		// create zip
		if(!$zip_name)
			$zip_name = temp_path.generate_random_string().".zip"; // now this file is temp, hope no collisions NOTE: some clients expect zip to be exactly in temp_path (download.php) to control if zip was created (or original was returned)
		log\debug($zip_name);
		$zip = new ZipArchive; // apt-get install php5.6-zip
		if(! $zip->open($zip_name, ZipArchive::CREATE | ZipArchive::OVERWRITE)) 
			throw new Exception("create zip fail"); // TODO: this may happen if file is busy (possible in ic3)
		set_time_limit(0);
		foreach($files_all as $file){
			$path_rel = $file["path"].$file["name"];
			//$source_path = trar_src($path_rel);  // DEF ONMERGE stuff which is to be corrected when make one general version; this is commented while trar used only in ic now
			// $source_path = get_source_path();   better, but need use it also for thumbs
			$source_path = source_path.$start_dir;

			$excl = strlen($source_path.$start_dir_db); // need exclude eg source_path/workspace/ws_name/
			$path = $source_path.$path_rel; // real root path for all files
			$zpath = substr($path, $excl);
			log\debug("added $path $zpath");
			if( is_file($path) ) // TODO 1: trar throws if not exists, so this not nec
				$zip->addFile($path, $zpath);
			else
				log\error("file not found: '$path'");
		}
		if(!$zip->close())
			throw new Exception("failed to write zip");
		return $zip_name;
	}
?>
