<?php
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."utils/utils.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path.table_tree_path_rel."model/db.php");   // table_files
	require_once(proj_path.table_tree_path_rel."view/preview.php");    
	require_once(proj_path."view/lang.php");

	$id = $_GET['id'];
	$table = get_or_def($_GET, 'table', $table_files);

	if($table=="files_lost") 
		$detail_captions["date_lost"] = "data perso";

	$params = db\select_record($table, implode(",", array_keys($detail_captions)), "id=$id");

	// shortcut variables (used in html)
	$name = 	$params['name'];
	$state_str = 	get_or_def($params, "online", 1)==1? "online": "offline";
	$state_img = 	get_or_def($params, "online", 1)==1? "green.png": "yellow.png";

?>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="description" content="">
		<meta name="author" content="Alex Nosurov" >
		
		<title><?php echo project_name; ?></title>

		<meta name="viewport" content="width=device-width, initial-scale=1">
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"> <!-- TODO: this is necessary for close cross; why local not works? -->
		<link href =	"<?php echo bootstrap_path; ?>css/bootstrap.css" rel="stylesheet">
		<script src=	"<?php echo jquery_path; ?>js/jquery-2.1.4.min.js"></script>
		<script src =	"<?php echo bootstrap_path; ?>js/bootstrap.min.js"></script>
		<link href = 	"css/style.css" rel="stylesheet">
		<!-- Custom styles for this template -->
		<style type="text/css">
			div div{padding: 15px;}
		</style>
		<link href="../css/main.php" rel="stylesheet"> <!-- TODO: temp, better use embeded div to show preview -->
	</head>
	<body>
		<div style="width: 100%; display: flex; flex-direction: column; align-items: stretch;">
		<div style = "padding: 20px;">
			<div id = 'caption' class="hidden">
				<h2> Dettagli file <?php echo $name; ?>&nbsp;<img src = "img/<?php echo $state_img;?>" alt = "<?php echo $state_str;?>"></img></h2>
			</div>
			<div id = 'image' >
				<?php echo print_thumb($params, "medium"); ?>
			</div>
			<div class = "table-responsive">
				<table class = "table table-condensed">
				<tbody>
				<?php echo lpp_html(print_params($params)) ;?>
				</tbody>
				</table>
			</div>
			<!-- used only when det shown in another wind; need hide if shown embedded 
			<button id="btn-close" class = "btn btn-danger" type = "button" onClick = "window.close()" class="hidden">
				<span class = "glyphicon glyphicon-remove"></span>
				Chiudi
			</button>-->
		</div>
		</div>
	</body>
</html>

