 
function get_dialog_html(){
	var res = '';
	res += '  <div class="modal-dialog">\n';
	res += '    <!-- Modal content-->\n';
	res += '    <div class="modal-content">\n';
	res += '      <div class="modal-header">\n';
	res += '	<button type="button" class="close" data-dismiss="modal">&times;</button>\n';
	res += '	<h4 class="modal-title" id=\'modal-dialog-header\'>Modal Header</h4>\n';
	res += '      </div>\n';
	res += '      <div class="modal-body">\n';
	res += '	<p id=\'modal-dialog-text\'>Some text in the modal.</p>\n';
	res += '      </div>\n';
	res += '      <div class="modal-footer">\n';
	res += '	<button type="button" class="btn btn-default" data-dismiss="modal" id="modal-dialog-ok"     onclick="getElementById(\'modal-dialog-result\').innerHTML=\'1\'">OK</button>\n';
	res += '	<button type="button"  id=\'ttt\'     onclick="getElementById(\'modal-dialog-result\').innerHTML=\'1\'">OK</button>\n';
	res += '	<button type="button" class="btn btn-default" data-dismiss="modal" id="modal-dialog-cancel" onclick="getElementById(\'modal-dialog-result\').innerHTML=\'0\'">Cancel</button>\n';
	res += '      </div>\n';
	res += '    </div>\n';
	res += '  </div>\n';
	res += '  <div id="modal-dialog-result" class="hidden"></div>\n';
	console.log(res);
	return res;
}

function show_dialog(text, caption){
	// find dialog
	var dd = document.getElementById('modal-dialog');
	// create if not exists
	if(!dd){
		var dd = document.createElement('DIV');
		dd.setAttribute('id', 'modal-dialog');
		dd.setAttribute('class', 'modal fade');
		dd.setAttribute('role', 'dialog');
		document.getElementsByTagName('body')[0].appendChild(dd);
		$('#modal-dialog').append( get_dialog_html() );
	}
	// customize
	$('#modal-dialog-header').html(caption);
	$('#modal-dialog-text').html(text);
	$('#modal-dialog-result').html('');
	// show
	$('#modal-dialog').modal('show'); 
	// result TODO: this not works! the dialog is not modal in fact! instead need use confirm() of js (alert/prompt)
	if(  $('#modal-dialog-result').html()=='1' )
		return true;
	return false;
}

function round(val, digits){ 
	var m = Math.pow(10, digits);
	return Math.round(val*m)/m;
}
function size_to_human(size){
	var minus = "";
	if(size<0){
		size = -size;
		minus = "-";
	}
	if(size<1024)
		return minus + round(size, 2) +' bytes';
	if((size/=1024)<1024)
		return minus + round(size, 2) +' KB';
	if((size/=1024)<1024)
		return minus + round(size, 2) +' MB';
	if((size/=1024)<1024)
		return minus + round(size, 2) +' GB';
	return minus + round(size/=1024, 2) +' TB';
}
//
function call_php_sync(script, params=null, method='POST'){
	var result = {'resp_text' : '', 'resp_code' : '0'};
	/*xhr=*/$.ajax({
		async: false,
		type: method,
		url: script,
		data: params,
		global: false, // to avoid duplicate error (to avoid passing further to func set by $(document).ajaxError)
		success: function(res){	
			result.resp_text = res; },
		error: function(j,errorS,p){ 
			result.resp_code = 1;
			if(p=="no_user") // LOGONEXP
				show_login();
		}
	})
	return result;
}
// returns true if a begins with b
function begins_with(a, b){ 
	return a.length >= b.length && a.substring(0, b.length)==b;
}

// TABLES
// functions which scans a table and for the given field (found by class) replaces contents with images;
// list of possible values in 'values', corresponding images/hints provided
function find_index(arr,val){	for(i=0;i<arr.length;i++) if(arr[i]==val) return i; return -1; }
function insert_images(rows, field_class, values, image_dir, images, hints){
	rows.each( function(){
		var row = $(this);
		row.children('td').each( function(){
			if( $(this).hasClass(field_class) ){
				$(this).addClass('td-image'); // sets padding to 2
				var value = $(this).html();	
				var ind = find_index( values, value ); // value is in html; find its index in values array
				if(ind >= 0) // if values exists in the list (should always exist) - replace it with image
					if( images[ind]!='' ) // may pass empty string to not insert image; note - if insert empty image - it's still visible when table rec selected
						$(this).html("<img title='" + hints[ind] + "' src='" + image_dir + images[ind] + "' alt='" + value + "'>" );
					else
						$(this).html(""); 
			}
		})
	});
}
// how use: 
// assign value with:   $('#your_counter_id uc_value').val( initial_counter_value );
// create and add  with: $('your counter parent').append( create_counter('your_counter_id', your_counter_click_handler) );
function create_counter_orig(id, callback, val=3, max=5, min=1){
	// create div-container
	var dc = $("<div class='uc_counter' id='" + id + "' data-min="+min+" data-max="+max+" >" + 
		"<button class='uc_start'>|&lt;</button>    <button class='uc_lt'>&lt;</button>" + // buttons |<  <
		"<input class='uc_value' type='text' value=" + val + " style='width: 40px;'></input>/<input style='width: 40px;' readonly value='" + max + "'></input>" +  // value/maxvalue
		"<button class='uc_gt'>&gt;</button><button class='uc_finish'>&gt;|</button></div>");  // buttons > >|
	dc.children('.uc_lt').on('click', function(){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var min = p.data('min'); val--; if(val>=min) {p.children('.uc_value').val(val); if(callback) callback(val);} });
	dc.children('.uc_gt').on('click', function(){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var max = p.data('max'); val++; if(val<=max) {p.children('.uc_value').val(val); if(callback) callback(val);} });
	dc.find(".uc_value").on("keypress", function(e){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var min = p.data('min'); var max = p.data('max'); if(e.which==13 && val>=min && val<=max) if(callback) callback(val); } );
	dc.children('.uc_start').on('click', function(){ var p = $(this).parent(); var val = p.data('min'); p.children('.uc_value').val(val); if(callback) callback(val); });
	dc.children('.uc_finish').on('click', function(){var p = $(this).parent(); var val = p.data('max'); p.children('.uc_value').val(val); if(callback) callback(val); });
	return dc;
}
function create_counter(id, callback, val=3, max=5, min=1, cb_sps=null){
	// create div-container
	// DEF PAGE_SIZE
	var sps = "<div><select class='uc_ps'><option value=5>5</option><option value=10>10</option><option value=20>20</option><option value=30>30</option><option value=50>50</option><option value=75>75</option><option value=100>100</option></select></div>";
	var dc = $("<div class='uc_counter' id='" + id + "' data-min="+min+" data-max="+max+" >" + 
		"<i class='fas fa-step-backward uc_start'></i>    <i class='fas fa-chevron-left uc_lt'></i>" + // buttons |<  <
		"<input class='uc_value' type='text' value=" + val + "></input>/<input readonly value='" + max + "'></input>" +  // value/maxvalue
		"<i class='fas fa-chevron-right uc_gt'></i><i class='fas fa-step-forward uc_finish'></i></div>");  // buttons > >|
	dc.children('.uc_lt').on('click', function(){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var min = p.data('min'); val--; if(val>=min) {p.children('.uc_value').val(val); if(callback) callback(val);} });
	dc.children('.uc_gt').on('click', function(){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var max = p.data('max'); val++; if(val<=max) {p.children('.uc_value').val(val); if(callback) callback(val);} });
	dc.find(".uc_value").on("keypress", function(e){ var p = $(this).parent(); var val = p.children('.uc_value').val(); var min = p.data('min'); var max = p.data('max'); if(e.which==13 && val>=min && val<=max) if(callback) callback(val); } );
	dc.children('.uc_start').on('click', function(){ var p = $(this).parent(); var val = p.data('min'); p.children('.uc_value').val(val); if(callback) callback(val); });
	dc.children('.uc_finish').on('click', function(){var p = $(this).parent(); var val = p.data('max'); p.children('.uc_value').val(val); if(callback) callback(val); });
	if(cb_sps){ // PAGE_SIZE
		dc.append(sps);
		dc.find('.uc_ps').on('change', function(){   cb_sps( $(this).val() )   } );
	}
	return dc;
}
function set_counter(cnt, val=1, min=1, max=5){
	dc.data("min") = min;
	dc.data("max") = max;
	dc.find(".uc_value").val(val);
}
function get_counter_val(dc){
	return dc.children('.uc_value').val();
}
	

function now_to_name(with_time=false){ // creates name from curr date TODO: add time if necc
	var ms = [lp('JAN'),lp('FEB'),lp('MAR'),lp('APR'),lp('MAY'),lp('JUN'),lp('JUL'),lp('AUG'),lp('SEP'),lp('OCT'),lp('NOV'),lp('DEC')];
	//var ms = ['01','02','03','04','05','06','07','08','09','10','11','12'];
	var d = new Date();
	var tm = with_time? "_" + d.getHours() + d.getMinutes() : "";
	return (d.getFullYear()-2000) + ms[d.getMonth()]+d.getDate() + tm;
}
function today(){ // not used
	var today = new Date();
	var dd = today.getDate();
	var mm = today.getMonth()+1; //January is 0!
	var yyyy = today.getFullYear();

	if(dd<10) {	    dd = '0'+dd	    } 
        if(mm<10) {		mm = '0'+mm	} 
	return  dd + '/' + mm + '/' + yyyy;
}
function hide_id(id){$('#'+id).addClass("hidden");}
function show_id(id){$('#'+id).removeClass("hidden");}
function show_hide_id(visible, ids){ for(var i=0;i<ids.length;i++) if(visible) $('#'+ids[i]).removeClass("hidden") ;else $('#'+ids[i]).addClass("hidden");}
function able_id(enabled, ids){ for(var i=0;i<ids.length;i++) document.getElementById(ids[i]).disabled = !enabled;}

// appends select2 wrapper
function add_select2(id){
	if( $('#'+id).html() ) // if exists and not empty
		$('#'+id).select2({ 
			placeholder: $(this).data('placeholder'), // same as placeholder='...
			allowClear: true,
			val: ""
		});
}

function date_is_valid(date_str) {
	return !isNaN(new Date(date_str));
}


// DEF HIS hidable panel; allows to have a panel with hidable part which is shown/hidden by constantly visible element (.his_hider)
// struct: container with position=relative (to make position=absolute of its childs to work)
// 	two absolute pos childs: 
// 		filter - abs pos div which contains hider and hided
// 		body - abs pos div, has top=20px to make hider always visible
// usage: create div .his_parent containing the hidable part .his_hided; .his_hider is added by call of his_init()
function toggle_hided(state=false){
	var hider = $(".his_hider");
	var hided = $(".his_hided");
	if(state){
		hided.removeClass("hidden");
		hider.children(".his_imgup").removeClass("hidden");
		hider.children(".his_imgdown").addClass("hidden");}
	else{
		hided.addClass("hidden");
		hider.children(".his_imgup").addClass("hidden");
		hider.children(".his_imgdown").removeClass("hidden");}
}

function his_init(){
	// HIS add hider
	if( $(".his_panel .his_hider").length ) return;
	$(".his_panel").prepend('<div class="his_hider"> <img class="center his_imgdown hidden" src="img/down.png">  <img class="center his_imgup" src="img/up.png"> </div>');
	// HIS toggles filter visibility and hider img
	$(".his_hider").on("click", function(){ toggle_hided( $(".his_hided").hasClass("hidden")? true : false ); });
	$(".his_user_hider").on("click", toggle_hided); // NOTE: this in fact isn't used, while usually hide is initiated by search start which is initiated in some complex way; so instead need use call of toggle_hided()
}

function array_contains(arr,val){for(var i=0;i<arr.length;i++) if(arr[i]==val)return true;return false;} // arr.includes checks types, which may be undesirable

function dir_name(path){
	return path.substring(0, path.lastIndexOf("/") );
}

function add_untoggle(elem){
	elem.on('click', 'label', function(e) {
	    if ($(this).hasClass('active')) {
	      setTimeout(function() {
		$(this).find('input').prop('checked', false); // 8.11.19 found this commented and uncommented because otherwise input remains checked (which is used to check state)
		$(this).removeClass('active');
	      }.bind(this), 10);
	    }
	  });
}

// imitates an event; not checks if el is defined
function eventFire(el, etype){
  if (el.fireEvent) {
    el.fireEvent('on' + etype);
  } else {
    var evObj = document.createEvent('Events');
    evObj.initEvent(etype, true, false);
    el.dispatchEvent(evObj);
  }
}
function click_show(el){ 
	if( typeof el === 'undefined' ) return;
	eventFire(el,"click"); //imitate click
	el.scrollIntoView(); // bring to view port
}
//
// DEF FIXHEAD Fixed Header
// this should be called each time a table is added/refreshed (while on refresh the table is recreated); processes all fh-tables
// situation: at start heads have minimal widths (are shrinked automatically by bro); need: increase each header width: th.w=max(td.w); to set widht is used min-width prop TODO: if max(td.w) < th.w? 
function fh_init_table(table_div){
	// seems this expands th to hold its inner spans (th.w = summ(span.w) )
	table_div.find(".fh-header th").each( function(){ 
		var col_name = $(this).data("fhid");
		var w = 15; // TODO: quickfix; problem: th stucks out (probably because of using ::after) and make vertical line appear (when no scroll shown);
		$(this).find("span").each( function(){ w += parseInt($(this).css("width")); } ); // find sum len of all top level spans in header; this imposes certain struct on header DEF FHHS fh header span
		//table_div.find("td[data-fhid='" + col_name + "']").css("min-width", w + "px");
		table_div.find("td[data-fhid='" + col_name + "']").first().css("min-width", w + "px"); // seems it's enough to set min w only for the first rec  FH_FASTER
	});
	fh_on_resize(table_div);
}
function fh_init(){
	$(".fh-table").each( function(){ fh_init_table( $(this) ); });
}

/// FIXHEAD
// this func is to be called when a table is resized; cols are resized autom by bro, heads are adjusted here
// NOTE: if wanna restrict col width - enough to set max-width for data cells
function fh_on_resize(table_div){
	//table_div.find(".fh-header").css("max-width", table_div.find(".fh-body").width()); // 
	table_div.find(".fh-header").css("max-width", table_div.width()); //  20.09.21 replaced prev with this to avoid gap at right of header row (visible when data-table has scroller)
	var first_row = table_div.find(".fh-body tr").first(); // find some row (first)
	first_row.find("td").each( function(){ 
		var col_name = $(this).data("fhid");
		var w = $(this).css("width");
		//table_div.find("th[data-fhid='" + col_name + "']").css("width", w);
		table_div.find("th[data-fhid='" + col_name + "']").css("width", w);
	} );
}

// main part of func - imitation of link click;
// TODO: problem of this func is that it loads silently file (user has no feedback) and only after that imitates link click)
// use load_file_pro instead!
function load_file(url, data=null, method="GET", onload=null){ // https://nehalist.io/downloading-files-from-post-requests/
	var request = new XMLHttpRequest();
	request.open(method, url, true);
	request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
	request.responseType = 'blob';
	request.onload = function(a){  // save_file()
		if(request.status==200){
			var cd = request.getResponseHeader("content-disposition"); // eg: attachment; filename="image001_2.jpg"
			var mt = /="?([^"]*)"?$/.exec(cd);
			if(mt==null) return;
			blob = new Blob([request.response], {type: request.getResponseHeader("content-type")} );
			var link = document.createElement('a');
			link.href = window.URL.createObjectURL(blob);
			link.download = mt[1];
			document.body.appendChild(link);
			link.click();
			document.body.removeChild(link);
			if(onload!=null)
				onload();
		}else if(request.status==500){
			alert(lp("file_not_found")); // TODO: could find a way to get the error message
		}
	},
	request.onerror = function(a,b,c){  // not works
	}
	/*var form_data = new FormData();
	if(data)
		for ( var key in data) 
			form_data.append(key, JSON.stringify(data[key]));*/
	var postdata = ""; // NOTE: that is need form a GET-like string; which is then tranformed into POST 'key: value' format; if value is an obj - must be already jsoned
	if(data)
		for ( var key in data){
			if(postdata!="") postdata += "&";
			postdata += key + "=" + data[key];
		}
	//var postdata = data? JSON.stringify(data) : "";
	request.send(postdata);
	//window.open(url); return; // works
	//$.post(url, {"path" : path }, save_file); // not works, probably need set responseType
}

// send to printer some html elem
function print_elem(elem)
{
	var newWin=window.open('','Print-Window');
	newWin.document.open();
	newWin.document.write('<html><body onload="window.print()">'+elem.innerHTML+'</body></html>');
	newWin.document.close();
	setTimeout(function(){newWin.close();},10);
}

function shrink_date(src){
	if(!src) return "";
	var y_d = new Date(new Date().setDate(new Date().getDate()-1));
	y_d.setHours(0,0,0,0);
	var t_d = new Date();
	t_d.setHours(0,0,0,0);
	var d = new Date(src);
	if(isNaN(d)) // yyyy-dd-MM format not recognized by safari
		d = new Date(src.replace(/-/g, "/"));
	var dy = d.getFullYear(), dmo = d.getMonth()+1, dd = d.getDate(), dh = d.getHours(), dmi = d.getMinutes();
	if(dd<10) dd = "0" + dd;
	if(dmi<10) dmi = "0" + dmi;
	dy = dy.toString().substring(2,4);
	var d_d = d;
	d_d.setHours(0,0,0,0);

	var d_ds = "", d_ts = dh + ":" + dmi;
	if(d_d.getTime()==t_d.getTime()){
		d_ds = "oggi";
	}else if(d_d.getTime()==y_d.getTime()){
		d_ds = "ieri";
	}else{
		d_ds = dd + "/" + dmo + "/" + dy;
	}
	return d_ds + " " + d_ts;
}
function shrink_string(str, max_len=100){
	return str.length<=max_len? str : str.substring(0,max_len-3) + "...";
}

function intersect_arr(array1, array2){
	return array1.filter( function(val){ return array2.indexOf(val)!==-1; }  );
}

// merge two objects ; to dest are added all keys of src that not already present in it (or replaced if replace == true)
function merge_object(dest, src, replace=false){
	for( let elem in src)
		if( replace || !(elem in dest) )
			dest[elem] = src[elem];
}
// remove all keys in dest that present in src
function unmerge_object(dest, src){
	for( let elem in src)
		if(elem in dest)
			delete dest[elem];
}

function extract_path(path, with_end_slash=false){
	var ls = path.lastIndexOf("/");
	var res = ls>=0? path.substring(0, ls) : "";
	return with_end_slash? res + "/" : res;
}
function append_slash(path){ return path.endsWith("/")? path : path + "/"; }
function clear_select(id){
    var elements = document.getElementById(id).options;
    for(var i = 0; i < elements.length; i++){
      elements[i].selected = false;
    }
}
function find_obj_by_key(arr, val, key="id"){
	for(i=0;i<arr.length; i++)
		if( arr[i][key]==val )
			return arr[i];
	return null;
}
// iterates jquery array and extracts data to array
function get_data_arr(arr, data_name){
	var res=[]; arr.each( function(){ res.push( $(this).data(data_name) ); } );
	return res;
}
function render_ul(items, id=''){
	var ul = $("<ul id='" + id + "'></ul>");
	for(i=0;i<items.length;i++)
		ul.append( $("<li>"+items[i]+"</li>") );
	return ul;
}

function render_select(opts, id=''){ // opts - arr of obj {id,name}
	var sel = $("<select id='" + id + "'></select>");
	for(i=0;i<opts.length;i++)
		sel.append( $("<option value='" + opts[i]["id"] + "'>" + opts[i]["name"] + "</option>") );
	sel.val("");
	return sel;
}

function date_to_str(d=null){
	if(!d)
		d = new Date();
	var dd = String(d.getDate()).padStart(2, '0');
	var mm = String(d.getMonth() + 1).padStart(2, '0'); //January is 0!
	var yy = d.getFullYear().toString().substr(-2);
	var mi = String(d.getMinutes()).padStart(2, '0');
	var hh = String(d.getHours()).padStart(2, '0');
	return dd + '/' + mm + '/' + yy + " " + hh + ":" + mi;
}
// date diff in days
function date_diff(date1,date2){
	date1 = new Date(date1);
	date2 = new Date(date2);
	diffTime = Math.abs(date2 - date1);
	return diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24)); 
}
function collect_data(sel,name){
	var res=[];
	$(sel).each( function(){ res.push( $(this).data(name) ); } );
	return res;
}

function collect_val(sel){
	var res=[];
	$(sel).each( function(){ res.push( $(this).val() ); } );
	return res;
}
function validate_email(email){
	return /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(email);
}
// cookies
function setCookie(cname, cvalue, exdays) {
  var d = new Date();
  d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
  var expires = "expires="+d.toUTCString();
  document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function getCookie(cname) {
  var name = cname + "=";
  var ca = document.cookie.split(';');
  for(var i = 0; i < ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return "";
}
//




/* TABCOL
visible_columns: array: name, name... list of initiall visible columns
all_columns: object: {field_name: caption}
tabcol_click: backup to pass to popup menu as click handler; function(target(dummy), name, state); it should call this.set_column(name,state) and then re-paint table using this.get_visible_columns; thus this obj should be declared somewhere and used by this cb:
	tabcol.set_column(name, state);
	request(...  tabcol.get_visible_columns() ... )
col_class, parent_id: params needed to create popup: the class which an elem must have to show popup menu onclick and optionally the id of the container
*/
function TabCol(visible_columns, all_columns, tabcol_click, col_class="mc_field_capt", parent_id='', param){
	// param is used while donno how can get in callback the caller object (class) (in java func not knows its class/obj)
	// init
	this.visible_columns = visible_columns;  // initially visible columns
	this.all_columns = all_columns;  // initially visible columns
	var tc = create_popup_div();
	init_popup(tc, col_class, null, true, parent_id);
	var t = this;
	for( var i=0; i<all_columns.length; i++){
		var name = all_columns[i];
		add_popup_checkbox(tc, name, i, visible_columns.includes(name), 
			function(dummy, val, state){
				var name = t.all_columns[val];
				if(state)
					t.visible_columns.push(name);
				else
					for(var j=0;j<t.visible_columns.length;j++) 
						if(t.visible_columns[j]==name)
							{t.visible_columns.splice(j,1); break;}
				//
				tabcol_click(name, state, param);
		});
	}
	//
	this.get_visible_columns = function(){ return this.visible_columns;}
}

function TabCol1(visible_columns, all_columns, tabcol_click, col_class="mc_field_capt", parent_id='', param){
	// param is used while donno how can get in callback the caller object (class) (in java func not knows its class/obj)
	// init
	this.visible_columns = visible_columns;  // initially visible columns
	this.all_columns = all_columns;  // initially visible columns
	var tc = create_popup_div();
	init_popup(tc, col_class, null, true, parent_id);
	var t = this;
	for( var name in all_columns){
		var caption = all_columns[name];
		if(caption=="#") continue;
		if(caption.startsWith("#"))
			caption = caption.substring(1);
		add_popup_checkbox(tc, caption, name, visible_columns.includes(name), 
			function(dummy, name, state){
				if(state)
					t.visible_columns.push(name);
				else
					for(var j=0;j<t.visible_columns.length;j++) 
						if(t.visible_columns[j]==name)
							{t.visible_columns.splice(j,1); break;}
				//
				tabcol_click(name, state, param);
		});
	}
	//
	this.get_visible_columns = function(){ return this.visible_columns;}
}

function fullscreen(elem){
	if( elem.webkitRequestFullscreen )
		elem.webkitRequestFullscreen(); //chrom
	else if (elem.requestFullscreen )
		elem.requestFullscreen(); // firefox
}
function col_com_to_hex(c){ var h = parseInt(c).toString(16); return h.length==2? h : "0" + h; }
function rgb_to_hex(col){
	const rr = /rgb\((\d+),\s*(\d+),\s*(\d+)\)/;
	var m = col.match(rr);
	return m? "#" + col_com_to_hex(m[1]) + col_com_to_hex(m[2]) + col_com_to_hex(m[3]) : col;
}
// get square of dist from line p1-p2 to point x0
function dist_line_point2(x1,y1,x2,y2,x0,y0){
	var dx2x1 = x2-x1, dy2y1 = y2-y1;
	var ch = dx2x1*(y1-y0) - dy2y1*(x1-x0);
	return ( ch*ch ) / (dx2x1*dx2x1 + dy2y1*dy2y1) ;
}

// 13.10.21 donno maybe a duplication ; input: File file; passes upload file to give script to make upload
function upload_file(file, uri, cb=null) {
	const xhr = new XMLHttpRequest();
	const fd = new FormData();

	xhr.open("POST", uri, true);
	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4 && xhr.status == 200) {
			if(cb)
				cb();
		}
	};
	fd.append('myFile', file);
	// Initiate a multipart/form-data upload
	xhr.send(fd);
}
// DEF RADIO ; to realize logic of radio group - create cont.rb_cont with items .rb_item and call this to init
// also uses css from main.css for 'pressed' effect
function rb_init(sel=".rb_item"){
	$(sel).on("click",  function(){ 
		$(this).closest(".rb_cont").find(".rb_item").removeClass("selected");
		$(this).addClass("selected");
	} );
}
// set active elem manually
function rb_set_active(rb /*jq obj*/, item_sel){
	rb.find(".rb_item").removeClass("selected");
	rb.find(item_sel).addClass("selected");
}

function span_intersect( l1,r1,l2,r2 ){ return !(l2>r1 || l1>r2); }
function rect_intersect( t,r,b,l, t1,r1,b1,l1 ){ return span_intersect(l,r,l1,r1) && span_intersect(t,b,t1,b1); }
function create_empty_table(rows,cols){
	return ("<tr>" + "<td>".repeat(cols) + "</tr>").repeat(rows);
}
// eg have src=img and div=dest and need img keep proportions and keep max area in div and fit in div
function fit_rect(src_w, src_h, dest_w, dest_h){
	var kw = src_w/dest_w, kh = src_h/dest_h;
	if(kw>kh) return {w:dest_w, h:src_h/kw};
	return {w:src_w/kh, h:dest_h};
}
// img keeps aspect and occupies whole div; rest of img invisible
function fit_rect2(src_w, src_h, dest_w, dest_h){
	var kw = src_w/dest_w, kh = src_h/dest_h;
	// return w/h of src and offsets w/h
	if(kw>kh) return {w:src_w/kh, h:dest_h, dw: (src_w/kh-dest_w)/2, dh: 0};
	return {w:dest_w, h:src_h/kw, dw:0, dh: (src_h/kw-dest_h)/2};
}
function point_in_rect(x, y, t, r, b, l){ return l<=x && x<=r && t<=y && y<=b ; }
// copy key-vals from obj to data and vv
function get_data(cont){ return cont.data(); }
function set_data(cont, prm, clear=false){ 
	if(clear) $.each(cont.data(), function (i) {    cont.removeData(i); });
	for (const [key, value] of Object.entries(prm)) cont.data(key, value); 
}
function is_int(value) {
  return !isNaN(value) && 
         parseInt(Number(value)) == value && 
         !isNaN(parseInt(value, 10));
}
// DEF TABGEN tab generator; uses also css
// tabs: arr of obj: {name, classname, content (=html) }
function create_tabs(tabs){
	var cont = $("<div class = 'mc_tab_cont'> </div>");
	var header = $("<div class = 'mc_tab_header'> </div>");
	var body =   $("<div class = 'mc_tab_body'> </div>");

	for(var i = 0; i<tabs.length; i++){
		var cn = tabs[i].classname;
		var tn = $("<div class='mc_tab_name " + cn + "'>" + tabs[i].name + "</div>");
		tn.data("id", cn);
		tn.on("click", function(){
			var cn = $(this).data("id");
			cont.find(".mc_tab_name, .mc_tab_tab").removeClass("active"); cont.find("."+cn).addClass("active"); 
		} );
		if(i==0) tn.addClass("active");
		header.append(tn);
		var tb = $("<div class='mc_tab_tab " + tabs[i].classname + "'>" + tabs[i].content + "</div>");
		body.append(tb);
		if(i==0) tb.addClass("active");
	}
	return cont.append(header).append(body);
}

// js elem
function getGlobalPos(elem){
	const rect = elem.getBoundingClientRect();
	return {
		left: rect.left + window.scrollX,
		top: rect.top + window.scrollY
	};
}

function setElemPos(elem, pos){
	elem.css("left", pos.left);
	elem.css("top", pos.top);
}

function getMouseRelPos(target, clientX, clientY){
	var rect = target.getBoundingClientRect();
	return {left : clientX - rect.left, top : clientY - rect.top}
}
// ---- ALERT _----  TODO: maybe use md_ss
// 26.03.20 had to give tt_alert up while search panel (which holds it) is hidden normally; also other panels are shown/hidden dynamically, so hard to find some to hold it permanently; note: also search panel now hides upper screen part, so even can't use to container to show alert
function show_alert(msg, id="tt_alert"){
	alert(msg); return;
	var html = '<div class="alert alert-danger" role="alert">';
	html +='<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
	html +='<strong>' + lp('attention') + '!</strong><br>' + msg;
	html +='</div>';
	$('#' + id).html(html);
}
function clear_alert(id="tt_alert"){
	$('#' + id).html("");
}

function get_random_str(length=8) {
    var result           = '';
    var characters       = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for ( var i = 0; i < length; i++ ) {
      result += characters.charAt(Math.floor(Math.random() *
 charactersLength));
   }
   return result;
}
// creates html elem used to show/hid pass; inp is an input<type=text>
// example for stand search form (is a table):  $("#nu_pass").closest("tr").append( $("<td></td>").append( make_pass_toggle( $("#nu_pass"), lp("show"), lp("hide") ) ) );
function make_pass_toggle(inp, show="show", hide="hide"){
	var toggle = $("<i id='mi_show_pass' class='fas fa-eye'></i>");
	inp.prop("type", "password");
	toggle.prop("title", show).click( function(){ 
		var sh=$(this); if(sh.hasClass("fa-eye")){sh.removeClass("fa-eye");sh.addClass("fa-eye-slash");sh.prop("title", "hide"); inp.prop("type", "text");}else{sh.removeClass("fa-eye-slash");sh.addClass("fa-eye");sh.prop("title", "show"); inp.prop("type", "password");} 
	} );
	return toggle;
}
function clearSelection()
{
 if (window.getSelection) {window.getSelection().removeAllRanges();}
 else if (document.selection) {document.selection.empty();}
}
// given: array of paths; out: excluded inner paths: if for a p1 exists p2: p1=p2+p3 - p1 excluded
// uses most efficient algo
function remove_inner_paths(all){
	all.sort();
	var unique = [];
	var unique_prev = '';
	for(i=0;i<all.length;i++)
		if( unique_prev.length && all[i].startsWith( unique_prev ) 
			&& unique_prev[unique_prev.length-1]=='/' ) // need also check that prev elem is folder; or else may happen one file name contains other (and will be omitted); TODO: not a good way to check if elem is a folder; may happen that paths will be passed without endslash
			continue;
		else
			unique.push(unique_prev = all[i]);
	return unique;
}

function create_boxed_image(src, w=200, h=200){
	var img = new Image();
	img.classList.add("ap_detail_elem");
	img.src = src;
	img.onload = function(){
		var rect = fit_rect(this.width, this.height, w, h);
		$(this).css("width", rect.w);
		$(this).css("height", rect.h);
		// $(".lb_header").each(function(){ $(this).css("width", $(this).closest(".lb_div").find(".ap_detail_elem").css("width") ); } ); // this works ; was used instead of LONG_HEADER (hided not-fitting end of labels)
	}
	return img;
}

$(document).ready( function(){
	// HIS
	his_init();
	// FIXHEAD
	//$('#tt_task_table_div').resize( function(){  // TODO: this not works
	//fh_init(); // for static tables which are already loaded; for others - call this each time table is added
	$(window).resize( function(){
		$(".fh-table").each( function(){  fh_on_resize($(this)); } );
	});
});
