<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	/* DEF EXLINK seem links table was used when tested apap; now had to replace it with real links table which will contain dl links; so comment all this stuff related with test code; 
	// LINK sign in / sign up by link; must be called before inclusion of contr/login.php
	if(isset($_GET["id"]) && isset($_GET["link"])) 
		find_link_user($_GET["id"], $_GET["link"]); */
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"css/apap.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<style type="text/css">
			/* in apap md ss gets under canvas */
			#md_ss_div{
				z-index: 10000;
			}
		</style>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/apap.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<!-- MAIN -->
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<?php echo lang_html_load('html/apap.html' ); ?>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<!-- DPDF -->
		<script src="lib/h2c/h2c.js"></script>
		<script src="lib/h2c/h2cm.js"></script>
		<script type="text/javascript" src="https://unpkg.com/canvg@3.0.4/lib/umd.js"></script>
		<div  class="hidden">
			<div id='dpdf_opts'>
				<form id="ap_pdf_form" target="_blank" method="POST" action="model/upload_image.php">
					<input id="ap_pdf_input" form="ap_pdf_form" type="hidden" name="imgBase64">
					<select class='dpdf_size' name='dpdf_size' form="ap_pdf_form"> <option value='A4'>A4</option><option value='A3'>A3</option><option value='A2'>A2</option> </select>
					<select class='dpdf_orient' name='dpdf_orient' form="ap_pdf_form"> <option value='P'>vertical</option><option value='L'>horizontal</option> </select>
				</form>
			</div>
			<!-- LINK BACK mail params -->
			<div id = "ap_mp_div">
				<div><label>receiver</label></div>
				<div id="ap_mp_users"></div>
				<div><label>subject</label></div>
				<div> <input id="ap_mp_subj" value="subject rejected" disabled=true> </div>
				<div><label>body</label></div>
				<div> <textarea id="ap_mp_body"> </textarea></div>
			</div>
		</div>
		
		<script type="text/javascript">
			/*function load_pages(){
				var req = call_php_sync("contr/main.php", {action: "ap_pages", id: ap_id});
				var pages = JSON.parse(req.resp_text);
				for(var i=0;i<pages.length;i++){
					var img = new Image();
					var id = pages[i].id;
					//img.onload = function(){
						var img_div = $("<div class='ap_page_thumb' data-id='" + id + "'/>");
						$(".ap_pages").append(img_div);
						img_div.click( function(){ window.open( "apap.php?id=" + $(this).data("id") ); } );
						img_div.append(img);
					//}
					img.src = pages[i].url;
				}
			}*/
			function pin_create(){
				var pp = get_popup_point(); // coords relative to img
				apap.pin_create(pp.x, pp.y);
			}
			// TODO: check owner (=name now)
			function pin_delete(pin){ apap.pin_delete( pin.data("id") ); }
			function draw_delete(draw){ apap.draw_delete( draw.data("id") ); }
			// DPDF
			function download_pdf_dialog(){
				show_select_string(download_pdf, "pdf options", $("#dpdf_opts"));
			}
			function download_pdf(){
				wait_screen.add_operation("pdf");
				apap.scale_to_image( function(raw){
					/*
					document.getElementById("ap_pdf_input").value=raw;
					document.getElementById("ap_pdf_form").submit();
					document.getElementById("ap_pdf_input").value='';
					*/
					$.ajax({
						type: "POST",
						url: "model/save_pdf.php",
						data: {imgBase64: raw, dpdf_size: $(".dpdf_size").val(), dpdf_orient: $(".dpdf_orient").val(), width: apap.scale.width, height: apap.scale.height}
					}).done( function(o) {
						window.open(o, "_blank");
						//alert("Ok");
					}).complete( function(o) {
						wait_screen.remove_operation("pdf");
					});
				});
			}
			function reject_lbs(){
				wait_screen.add_operation("mail");
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					//"data": {action : "mail_to_owner", "app_id" : ap_id, "subject": $("#ap_mp_subj").val(), message: $("#ap_mp_body").val()},
					"data": {action : "reject_lbs", "app_id" : ap_id, "subject": $("#ap_mp_subj").val(), message: $("#ap_mp_body").val(), receivers: owner},
					"success": function(res, dummy, request){ 	opener_cb(); alert(lp("done"));		},
					"complete": function(){ 	wait_screen.remove_operation("mail");	}
				})
				set_action_buttons( "rejected" );
			}
			function approve_lbs(){
				wait_screen.add_operation("approving");
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "approve_lbs", "app_id" : ap_id},
					"success": function(res, dummy, request){ 	
						opener_cb();
						alert(lp("done"));		
						var app_info = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_app_info", app_id: ap_id}, 'POST').resp_text ); 
						set_action_buttons("approved", app_info.order_state);
					},
					"complete": function(){ 	wait_screen.remove_operation("approving");	}
				})
			}
			function set_modes(mode){ rb_set_active( $(".ap_modes"), ".ap_start_" + mode ); }
			var ap_id = <?php echo $_GET["id"]; ?>;
			var owner = <?php echo "'".db\select_field("approves","owner","id=".$_GET["id"])."'"; ?>;
			var user  = <?php echo "'".get_user_info("email")."'"; ?>;
			// approve/reject available until whole order approved
			function set_action_buttons(app_state, order_state="uploaded"){
				//if(ur_role.role!="GRAPHIC" || order_state!="uploaded") $(".ap_action").addClass("hidden");
				if(ur_role.role!="GRAPHIC") $(".ap_action").addClass("hidden");
				if(order_state=="approved") $(".ap_action").addClass("hidden");
				if(app_state=="draft" || app_state=="approved") $(".ap_approve").addClass("hidden");
				if(app_state=="rejected") $(".ap_approve").addClass("hidden"); // NOREAPP
				if(app_state=="draft" || app_state=="rejected") $(".ap_reject").addClass("hidden");
			}
			function opener_cb(){
				if (typeof window.opener!== "undefined")
					window.opener.apap_cb();
			}
			function set_title(app_info){
				var ord = "<a href='orders.php?id=" + app_info.order_id + "&cid=" + app_info.camp_id + "' title='open order page'>" + app_info.order_id + "</a>";
				$("#heading_left").html( app_info.name + " " + app_info.width + "x" + app_info.height + " (" + app_info.state + ", order " + ord + ")");
			}
			
			var apap;
			var lbs_name;
			$(document).ready( function(){
				// pen width selector
				for(var i = 2; i<=18; i+=2){
					var w = 6*Math.sqrt(i);
					$(".ap_set_pw").append( $("<div data-size='"+i+"' class='rb_item ap_pw'> <div style='height:"+i+"px;width:"+w+"px;'></div></div>") );
				}
				rb_init();
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				apap = new Apap(ap_id, set_modes);
				// popup
				var ap_menu = create_popup_div("ap_image_menu");
				init_popup(ap_menu, "ap_image");
				add_popup_item( ap_menu, "create pin", pin_create);
				var ap_menu_pin = create_popup_div("ap_pin_menu");
				init_popup(ap_menu_pin, "ap_pin_btn");
				add_popup_item( ap_menu_pin, "delete pin", pin_delete);
				$(".ap_start_draw").click( function(){ 
					apap.draw_start();
					puh("start_drawing");
				} ); // DRAW
				$(".ap_start_select").click( function(){ 
					apap.select_start();
					puh("start_selection");
				} ); // SELECT 
				$(".ap_start_move").click( function(){ 
					apap.move_start();
					puh("start_image_move");
				} ); // 
				$(".ap_delete_selection").click( function(){ apap.delete_selection();} ); // 
				$(".ap_save_btn").click( function(){ apap.save(); });
				$(".ap_start_note").click( function(){ 
					apap.start_note();
					puh("select_note_position");
				} ); // 
				//load_pages(); pages NOTE: not used now, all pdf have single page
				// ANYSCA
				$(".ap_scale_minus").click(function(){ var s = apap.getZoom(); apap.setZoom(Math.max(10,s-5)); });
				$(".ap_scale_plus").click(function(){ var s = apap.getZoom(); apap.setZoom(Math.min(100,s+5)); });
				$(".ap_scale_width").click(function(){ apap.zoom_to_screen(); });
				$(".ap_scale_num").on("keydown", function(e){ 
					var v = parseInt( $(this).val() );
					if(e.key=="Enter" && v>=10 && v<=100)
						apap.setZoom(v);
				});
				// 
				var app_info = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_app_info", app_id: ap_id}, 'POST').resp_text ); 
				if(!app_info){
					alert(lpp("image_not_found", ap_id));
					return;
				}
				set_title(app_info);
				$(".ap_reject").click( function(){
					$("#ap_mp_users").html(owner);
					show_select_string(reject_lbs, "Reject subject", $("#ap_mp_div"));
				});
				$(".ap_approve").click(approve_lbs);
				set_action_buttons( app_info.state, app_info.order_state );
				// warn not saved
				window.addEventListener("beforeunload", function (e) {
					var confirmationMessage = lp("changes_not_saved");
					if(!apap.changed) return null;
					(e || window.event).returnValue = confirmationMessage; //Gecko + IE
					return confirmationMessage; //Gecko + Webkit, Safari, Chrome etc.
				});
				// toggle
				$(".ap_toggle_pindraw_btn").click( function(){ 
					apap.toggle_pindraws($(this).hasClass("ap_on")); 
					$(this).toggleClass("ap_on");
					$(this).find("i").toggleClass("fa-window-maximize");$(this).find("i").toggleClass("fa-window-minimize"); 
				});
				window.onkeydown = function(e){
					e = e || window.event;
					var code = e.keyCode;
					var fe = document.activeElement;
					if( !(fe && $(fe).hasClass("ap_pin_txt")) && code==46)
						apap.delete_selection();
				};
			});
		</script>
	</body>
</html>
