-- MariaDB dump 10.19  Distrib 10.7.6-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: lightbox
-- ------------------------------------------------------
-- Server version	10.7.6-MariaDB-1:10.7.6+maria~deb11

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `cities`
--

DROP TABLE IF EXISTS `cities`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cities` (
  `name` varchar(50) DEFAULT NULL,
  `name_ascii` varchar(50) DEFAULT NULL,
  `lat` float DEFAULT NULL,
  `lng` float DEFAULT NULL,
  `country` varchar(50) DEFAULT NULL,
  `iso2` char(2) DEFAULT NULL,
  `iso3` char(3) DEFAULT NULL,
  `admin_name` varchar(50) DEFAULT NULL,
  `capital` char(10) DEFAULT '',
  `population` int(11) DEFAULT 0,
  `id` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cities`
--

LOCK TABLES `cities` WRITE;
/*!40000 ALTER TABLE `cities` DISABLE KEYS */;
INSERT INTO `cities` VALUES
('Tokyo','Tokyo',35.6897,139.692,'Japan','JP','JPN','Tōkyō','primary',37977000,1392685764),
('Jakarta','Jakarta',-6.2146,106.845,'Indonesia','ID','IDN','Jakarta','primary',34540000,1360771077),
('Delhi','Delhi',28.66,77.23,'India','IN','IND','Delhi','admin',29617000,1356872604),
('Mumbai','Mumbai',18.9667,72.8333,'India','IN','IND','Mahārāshtra','admin',23355000,1356226629),
('Manila','Manila',14.6,120.983,'Philippines','PH','PHL','Manila','primary',23088000,1608618140),
('Shanghai','Shanghai',31.1667,121.467,'China','CN','CHN','Shanghai','admin',22120000,1156073548),
('São Paulo','Sao Paulo',-23.5504,-46.6339,'Brazil','BR','BRA','São Paulo','admin',22046000,1076532519),
('Seoul','Seoul',37.56,126.99,'Korea, South','KR','KOR','Seoul','primary',21794000,1410836482),
('Mexico City','Mexico City',19.4333,-99.1333,'Mexico','MX','MEX','Ciudad de México','primary',20996000,1484247881),
('Guangzhou','Guangzhou',23.1288,113.259,'China','CN','CHN','Guangdong','admin',20902000,1156237133),
('Beijing','Beijing',39.905,116.391,'China','CN','CHN','Beijing','primary',19433000,1156228865),
('Cairo','Cairo',30.0561,31.2394,'Egypt','EG','EGY','Al Qāhirah','primary',19372000,1818253931),
('New York','New York',40.6943,-73.9249,'United States','US','USA','New York','',18713220,1840034016),
('Kolkāta','Kolkata',22.5411,88.3378,'India','IN','IND','West Bengal','admin',17560000,1356060520),
('Moscow','Moscow',55.7558,37.6178,'Russia','RU','RUS','Moskva','primary',17125000,1643318494),
('Bangkok','Bangkok',13.75,100.517,'Thailand','TH','THA','Krung Thep Maha Nakhon','primary',17066000,1764068610),
('Buenos Aires','Buenos Aires',-34.5997,-58.3819,'Argentina','AR','ARG','Buenos Aires, Ciudad Autónoma de','primary',16157000,1032717330),
('Shenzhen','Shenzhen',22.535,114.054,'China','CN','CHN','Guangdong','minor',15929000,1156158707),
('Dhaka','Dhaka',23.7289,90.3944,'Bangladesh','BD','BGD','Dhaka','primary',15443000,1050529279),
('Lagos','Lagos',6.45,3.4,'Nigeria','NG','NGA','Lagos','minor',15279000,1566593751),
('Istanbul','Istanbul',41.01,28.9603,'Turkey','TR','TUR','İstanbul','admin',15154000,1792756324),
('Ōsaka','Osaka',34.75,135.46,'Japan','JP','JPN','Ōsaka','admin',14977000,1392419823),
('Karachi','Karachi',24.86,67.01,'Pakistan','PK','PAK','Sindh','admin',14835000,1586129469),
('Bangalore','Bangalore',12.9699,77.598,'India','IN','IND','Karnātaka','admin',13707000,1356410365),
('Tehran','Tehran',35.7,51.4167,'Iran','IR','IRN','Tehrān','primary',13633000,1364305026),
('Kinshasa','Kinshasa',-4.3233,15.3081,'Congo (Kinshasa)','CD','COD','Kinshasa','primary',13528000,1180000363),
('Ho Chi Minh City','Ho Chi Minh City',10.8167,106.633,'Vietnam','VN','VNM','Hồ Chí Minh','admin',13312000,1704774326),
('Los Angeles','Los Angeles',34.1139,-118.407,'United States','US','USA','California','',12750807,1840020491),
('Rio de Janeiro','Rio de Janeiro',-22.9083,-43.1964,'Brazil','BR','BRA','Rio de Janeiro','admin',12272000,1076887657),
('Nanyang','Nanyang',32.9987,112.529,'China','CN','CHN','Henan','',12010000,1156192287),
('Baoding','Baoding',38.8671,115.484,'China','CN','CHN','Hebei','',11860000,1156256829),
('Chennai','Chennai',13.0825,80.275,'India','IN','IND','Tamil Nādu','admin',11324000,1356374944),
('Chengdu','Chengdu',30.66,104.063,'China','CN','CHN','Sichuan','admin',11309000,1156421555),
('Lahore','Lahore',31.5497,74.3436,'Pakistan','PK','PAK','Punjab','admin',11021000,1586801463),
('Paris','Paris',48.8566,2.3522,'France','FR','FRA','Île-de-France','primary',11020000,1250015082),
('London','London',51.5072,-0.1275,'United Kingdom','GB','GBR','London, City of','primary',10979000,1826645935),
('Linyi','Linyi',35.0606,118.342,'China','CN','CHN','Shandong','',10820000,1156086320),
('Tianjin','Tianjin',39.1467,117.206,'China','CN','CHN','Tianjin','admin',10800000,1156174046),
('Shijiazhuang','Shijiazhuang',38.0422,114.509,'China','CN','CHN','Hebei','admin',10784600,1156217541),
('Zhoukou','Zhoukou',33.625,114.642,'China','CN','CHN','Henan','minor',9901000,1156272098),
('Lima','Lima',-12.05,-77.0333,'Peru','PE','PER','Lima','primary',9848000,1604728603),
('Hyderābād','Hyderabad',17.3667,78.4667,'India','IN','IND','Telangana','admin',9746000,1356871768),
('Handan','Handan',36.6116,114.489,'China','CN','CHN','Hebei','minor',9549700,1156957080),
('Bogotá','Bogota',4.6126,-74.0705,'Colombia','CO','COL','Bogotá','primary',9464000,1170483426),
('Weifang','Weifang',36.7167,119.1,'China','CN','CHN','Shandong','',9373000,1156912965),
('Nagoya','Nagoya',35.1167,136.933,'Japan','JP','JPN','Aichi','admin',9113000,1392407472),
('Wuhan','Wuhan',30.5872,114.288,'China','CN','CHN','Hubei','admin',8962000,1156117184),
('Heze','Heze',35.2333,115.433,'China','CN','CHN','Shandong','minor',8750000,1156225008),
('Ganzhou','Ganzhou',25.8292,114.934,'China','CN','CHN','Jiangxi','minor',8677600,1156832475),
('Tongshan','Tongshan',34.261,117.186,'China','CN','CHN','Jiangsu','minor',8669000,1156241678),
('Chicago','Chicago',41.8373,-87.6862,'United States','US','USA','Illinois','',8604203,1840000494),
('Luanda','Luanda',-8.8383,13.2344,'Angola','AO','AGO','Luanda','primary',8417000,1024949724),
('Changsha','Changsha',28.1987,112.971,'China','CN','CHN','Hunan','admin',8394500,1156961497),
('Fuyang','Fuyang',32.8986,115.804,'China','CN','CHN','Anhui','',8360000,1156248008),
('Kuala Lumpur','Kuala Lumpur',3.1478,101.695,'Malaysia','MY','MYS','Kuala Lumpur','primary',8285000,1458988644),
('Jining','Jining',35.4,116.567,'China','CN','CHN','Shandong','',8023000,1156504601),
('Dongguan','Dongguan',23.0475,113.749,'China','CN','CHN','Guangdong','minor',7981000,1156478242),
('Jinan','Jinan',36.6667,116.983,'China','CN','CHN','Shandong','admin',7967400,1156972469),
('Foshan','Foshan',23.0292,113.106,'China','CN','CHN','Guangdong','minor',7905700,1156738403),
('Hanoi','Hanoi',21.0245,105.841,'Vietnam','VN','VNM','Hà Nội','primary',7785000,1704413791),
('Pune','Pune',18.5196,73.8553,'India','IN','IND','Mahārāshtra','',7764000,1356081074),
('Chongqing','Chongqing',29.5628,106.553,'China','CN','CHN','Chongqing','admin',7739000,1156936556),
('Changchun','Changchun',43.9,125.2,'China','CN','CHN','Jilin','admin',7674439,1156078103),
('Zhumadian','Zhumadian',32.9773,114.025,'China','CN','CHN','Henan','',7640000,1156184822),
('Ningbo','Ningbo',29.875,121.549,'China','CN','CHN','Zhejiang','minor',7639000,1156170787),
('Cangzhou','Cangzhou',38.3037,116.845,'China','CN','CHN','Hebei','',7544300,1156698069),
('Nanjing','Nanjing',32.05,118.767,'China','CN','CHN','Jiangsu','admin',7496000,1156644065),
('Hefei','Hefei',31.8639,117.281,'China','CN','CHN','Anhui','admin',7457027,1156332710),
('Ahmedabad','Ahmedabad',23.03,72.58,'India','IN','IND','Gujarāt','minor',7410000,1356304381),
('Hong Kong','Hong Kong',22.305,114.185,'Hong Kong','HK','HKG','','primary',7347000,1344982653),
('Zhanjiang','Zhanjiang',21.1967,110.403,'China','CN','CHN','Guangdong','minor',7332000,1156502170),
('Shaoyang','Shaoyang',27.2418,111.473,'China','CN','CHN','Hunan','',7302400,1156310366),
('Hengyang','Hengyang',26.8968,112.586,'China','CN','CHN','Hunan','',7300600,1156696884),
('Khartoum','Khartoum',15.6031,32.5265,'Sudan','SD','SDN','Khartoum','primary',7282000,1729268475),
('Nantong','Nantong',31.9829,120.887,'China','CN','CHN','Jiangsu','minor',7282835,1156045365),
('Yancheng','Yancheng',33.3936,120.134,'China','CN','CHN','Jiangsu','minor',7260240,1156995410),
('Nanning','Nanning',22.8192,108.315,'China','CN','CHN','Guangxi','admin',7153300,1156605439),
('Xi’an','Xi\'an',34.2667,108.9,'China','CN','CHN','Shaanxi','admin',7135000,1156244079),
('Shenyang','Shenyang',41.8039,123.426,'China','CN','CHN','Liaoning','admin',7105000,1156309382),
('Tangshan','Tangshan',39.6292,118.174,'China','CN','CHN','Hebei','',7100000,1156904299),
('Santiago','Santiago',-33.45,-70.6667,'Chile','CL','CHL','Región Metropolitana','primary',7007000,1152554349),
('Zhengzhou','Zhengzhou',34.7492,113.66,'China','CN','CHN','Henan','admin',7005000,1156183137),
('Shangqiu','Shangqiu',34.4259,115.647,'China','CN','CHN','Henan','',7000000,1156805441),
('Yantai','Yantai',37.3997,121.266,'China','CN','CHN','Shandong','',6968202,1156932948),
('Riyadh','Riyadh',24.65,46.71,'Saudi Arabia','SA','SAU','Ar Riyāḑ','primary',6881000,1682999334),
('Dar es Salaam','Dar es Salaam',-6.8,39.2833,'Tanzania','TZ','TZA','Dar es Salaam','primary',6698000,1834843853),
('Xinyang','Xinyang',32.1264,114.067,'China','CN','CHN','Henan','',6634000,1156273453),
('Shangrao','Shangrao',28.4419,117.963,'China','CN','CHN','Jiangxi','minor',6579714,1156405492),
('Luoyang','Luoyang',34.6587,112.424,'China','CN','CHN','Henan','',6549941,1156069315),
('Bijie','Bijie',27.3019,105.286,'China','CN','CHN','Guizhou','',6537498,1156018927),
('Quanzhou','Quanzhou',24.9139,118.586,'China','CN','CHN','Fujian','minor',6480000,1156829655),
('Hangzhou','Hangzhou',30.25,120.168,'China','CN','CHN','Zhejiang','admin',6446000,1156275243),
('Miami','Miami',25.7839,-80.2102,'United States','US','USA','Florida','',6445545,1840015149),
('Huanggang','Huanggang',30.45,114.875,'China','CN','CHN','Hubei','minor',6333000,1156200037),
('Maoming','Maoming',21.6618,110.918,'China','CN','CHN','Guangdong','minor',6313200,1156568722),
('Kunming','Kunming',25.0433,102.706,'China','CN','CHN','Yunnan','admin',6250000,1156477539),
('Nanchong','Nanchong',30.7991,106.078,'China','CN','CHN','Sichuan','minor',6183000,1156762337),
('Zunyi','Zunyi',27.705,106.934,'China','CN','CHN','Guizhou','',6127009,1156539782),
('Jieyang','Jieyang',23.5533,116.365,'China','CN','CHN','Guangdong','minor',6089400,1156260378),
('Lu’an','Lu\'an',31.7542,116.508,'China','CN','CHN','Anhui','minor',6090000,1156499624),
('Yichun','Yichun',27.8041,114.383,'China','CN','CHN','Jiangxi','minor',6048700,1156229590),
('Madrid','Madrid',40.4167,-3.7167,'Spain','ES','ESP','Madrid','primary',6026000,1724616994),
('Changde','Changde',29.0397,111.684,'China','CN','CHN','Hunan','minor',6011000,1156449091),
('Taizhou','Taizhou',28.6583,121.422,'China','CN','CHN','Zhejiang','minor',5968838,1156322307),
('Liaocheng','Liaocheng',36.45,115.983,'China','CN','CHN','Shandong','minor',5955300,1156006600),
('Qujing','Qujing',25.5102,103.803,'China','CN','CHN','Yunnan','',5855055,1156747998),
('Sūrat','Surat',21.17,72.83,'India','IN','IND','Gujarāt','',5807000,1356758738),
('Baghdad','Baghdad',33.35,44.4167,'Iraq','IQ','IRQ','Baghdād','primary',5796000,1368596238),
('Qingdao','Qingdao',36.1167,120.4,'China','CN','CHN','Shandong','minor',5775000,1156112588),
('Singapore','Singapore',1.3,103.8,'Singapore','SG','SGP','Central Singapore','primary',5745000,1702341327),
('Dallas','Dallas',32.7936,-96.7662,'United States','US','USA','Texas','',5743938,1840019440),
('Dazhou','Dazhou',31.2152,107.495,'China','CN','CHN','Sichuan','minor',5693000,1156834076),
('Suzhou','Suzhou',33.6333,116.968,'China','CN','CHN','Anhui','',5690000,1156871297),
('Xiangyang','Xiangyang',32.0654,112.153,'China','CN','CHN','Hubei','minor',5680000,1156107325),
('Philadelphia','Philadelphia',40.0077,-75.1339,'United States','US','USA','Pennsylvania','',5649300,1840000673),
('Giza','Giza',29.987,31.2118,'Egypt','EG','EGY','Al Jīzah','admin',5598402,1818925479),
('Nairobi','Nairobi',-1.2864,36.8172,'Kenya','KE','KEN','Nairobi City','primary',5545000,1404000661),
('Nangandao','Nangandao',35.2992,113.885,'China','CN','CHN','Henan','minor',5516000,1156127660),
('Ankara','Ankara',39.93,32.85,'Turkey','TR','TUR','Ankara','primary',5503985,1792572891),
('Tai’an','Tai\'an',36.2001,117.081,'China','CN','CHN','Shandong','',5499000,1156095188),
('Yulin','Yulin',22.6293,110.151,'China','CN','CHN','Guangxi','',5487368,1156901312),
('Dezhou','Dezhou',37.4513,116.311,'China','CN','CHN','Shandong','minor',5470000,1156524080),
('Houston','Houston',29.7863,-95.3889,'United States','US','USA','Texas','',5464251,1840020925),
('Atlanta','Atlanta',33.7627,-84.4224,'United States','US','USA','Georgia','admin',5449398,1840013660),
('Yongzhou','Yongzhou',26.4515,111.595,'China','CN','CHN','Hunan','',5446100,1156694479),
('Rangoon','Rangoon',16.8,96.15,'Myanmar','MM','MMR','Yangon','primary',5430000,1104616656),
('Toronto','Toronto',43.7417,-79.3733,'Canada','CA','CAN','Ontario','',5429524,1124279679),
('Suihua','Suihua',46.6384,126.981,'China','CN','CHN','Heilongjiang','minor',5420000,1156235493),
('Washington','Washington',38.9047,-77.0163,'United States','US','USA','District of Columbia','primary',5379184,1840006060),
('Qiqihar','Qiqihar',47.3398,123.951,'China','CN','CHN','Heilongjiang','minor',5367003,1156775905),
('Jinhua','Jinhua',29.1046,119.649,'China','CN','CHN','Zhejiang','minor',5361572,1156547188),
('Saint Petersburg','Saint Petersburg',59.95,30.3167,'Russia','RU','RUS','Sankt-Peterburg','admin',5351935,1643616350),
('Shantou','Shantou',23.3735,116.694,'China','CN','CHN','Guangdong','minor',5319028,1156457499),
('Sydney','Sydney',-33.865,151.209,'Australia','AU','AUS','New South Wales','admin',5312163,1036074917),
('Weinan','Weinan',34.4996,109.468,'China','CN','CHN','Shaanxi','minor',5300000,1156903687),
('Suqian','Suqian',33.9331,118.283,'China','CN','CHN','Jiangsu','',5290000,1156212349),
('Guadalajara','Guadalajara',20.6767,-103.348,'Mexico','MX','MEX','Jalisco','admin',5253000,1484950208),
('Suzhou','Suzhou',31.304,120.616,'China','CN','CHN','Jiangsu','minor',5250000,1156029196),
('Fuzhou','Fuzhou',26.0769,119.292,'China','CN','CHN','Fujian','admin',5245000,1156188037),
('Zhaotong','Zhaotong',27.3328,103.714,'China','CN','CHN','Yunnan','',5213521,1156924687),
('Pudong','Pudong',31.2231,121.54,'China','CN','CHN','Shanghai','minor',5187200,1156644508),
('Belo Horizonte','Belo Horizonte',-19.9281,-43.9419,'Brazil','BR','BRA','Minas Gerais','admin',5159000,1076967355),
('Zhangzhou','Zhangzhou',24.5093,117.661,'China','CN','CHN','Fujian','minor',5140000,1156241637),
('Bozhou','Bozhou',33.8626,115.774,'China','CN','CHN','Anhui','',5100000,1156356860),
('Melbourne','Melbourne',-37.8136,144.963,'Australia','AU','AUS','Victoria','admin',5078193,1036533631),
('Nanchang','Nanchang',28.6842,115.887,'China','CN','CHN','Jiangxi','admin',5042565,1156198892),
('Xianyang','Xianyang',34.35,108.717,'China','CN','CHN','Shaanxi','minor',5040000,1156120117),
('Taizhou','Taizhou',32.4831,119.9,'China','CN','CHN','Jiangsu','minor',5031000,1156119229),
('Surabaya','Surabaya',-7.2458,112.738,'Indonesia','ID','IDN','Jawa Timur','admin',4975000,1360484663),
('Abidjan','Abidjan',5.3364,-4.0267,'Côte D’Ivoire','CI','CIV','Abidjan','primary',4980000,1384207980),
('Huaihua','Huaihua',27.5494,109.959,'China','CN','CHN','Hunan','',4983300,1156353465),
('Ji’an','Ji\'an',27.1172,114.979,'China','CN','CHN','Jiangxi','minor',4956600,1156278215),
('Mianyang','Mianyang',31.4669,104.739,'China','CN','CHN','Sichuan','minor',4945000,1156417758),
('Xiaoganzhan','Xiaoganzhan',30.9273,113.911,'China','CN','CHN','Hubei','',4921000,1156002290),
('Shaoxing','Shaoxing',30,120.583,'China','CN','CHN','Zhejiang','minor',4912239,1156893449),
('Alexandria','Alexandria',31.2,29.9167,'Egypt','EG','EGY','Al Iskandarīyah','admin',4870000,1818695837),
('Yuncheng','Yuncheng',35.0304,110.998,'China','CN','CHN','Shanxi','',4860000,1156705644),
('Pingdingshan','Pingdingshan',33.735,113.3,'China','CN','CHN','Henan','',4838000,1156735124),
('Huizhou','Huizhou',23.1115,114.415,'China','CN','CHN','Guangdong','minor',4830000,1156203268),
('Huai’an','Huai\'an',33.5,119.133,'China','CN','CHN','Jiangsu','',4799889,1156634228),
('Xinpu','Xinpu',34.5906,119.18,'China','CN','CHN','Jiangsu','minor',4790000,1156035381),
('Chenzhou','Chenzhou',25.7989,113.027,'China','CN','CHN','Hunan','minor',4754600,1156291915),
('Guilin','Guilin',25.2667,110.283,'China','CN','CHN','Guangxi','minor',4747963,1156235364),
('Jiujiang','Jiujiang',29.7048,116.002,'China','CN','CHN','Jiangxi','minor',4728778,1156206041),
('Anqing','Anqing',30.5,117.033,'China','CN','CHN','Anhui','minor',4723000,1156238875),
('Boston','Boston',42.3188,-71.0846,'United States','US','USA','Massachusetts','admin',4688346,1840000455),
('Huanglongsi','Huanglongsi',34.7936,114.34,'China','CN','CHN','Henan','',4676159,1156198356),
('Jiangmen','Jiangmen',22.5833,113.083,'China','CN','CHN','Guangdong','minor',4630300,1156105613),
('Changzhou','Changzhou',31.8122,119.969,'China','CN','CHN','Jiangsu','minor',4592431,1156185511),
('Barcelona','Barcelona',41.3825,2.1769,'Spain','ES','ESP','Catalonia','admin',4588000,1724594040),
('Wuxi','Wuxi',31.5667,120.283,'China','CN','CHN','Jiangsu','minor',4580000,1156019650),
('Zibo','Zibo',36.7831,118.05,'China','CN','CHN','Shandong','',4530597,1156381094),
('Jiaxing','Jiaxing',30.7522,120.75,'China','CN','CHN','Zhejiang','minor',4501657,1156491661),
('Dalian','Dalian',38.9,121.6,'China','CN','CHN','Liaoning','',4480000,1156175472),
('Hengshui','Hengshui',37.7348,115.686,'China','CN','CHN','Hebei','',4472000,1156803028),
('Harbin','Harbin',45.75,126.633,'China','CN','CHN','Heilongjiang','admin',4458000,1156241528),
('Yangzhou','Yangzhou',32.3912,119.436,'China','CN','CHN','Jiangsu','',4459000,1156818601),
('Yibin','Yibin',28.7596,104.64,'China','CN','CHN','Sichuan','minor',4456000,1156107603),
('Johannesburg','Johannesburg',-26.2044,28.0416,'South Africa','ZA','ZAF','Gauteng','admin',4434827,1710550792),
('Yiyang','Yiyang',28.5833,112.333,'China','CN','CHN','Hunan','',4420700,1156218615),
('Meizhou','Meizhou',24.2998,116.119,'China','CN','CHN','Guangdong','minor',4378800,1156361028),
('Chifeng','Chifeng',42.2663,118.922,'China','CN','CHN','Inner Mongolia','minor',4376600,1156277458),
('Casablanca','Casablanca',33.5992,-7.62,'Morocco','MA','MAR','Casablanca-Settat','admin',4370000,1504175315),
('Guiyang','Guiyang',26.5794,106.708,'China','CN','CHN','Guizhou','admin',4365000,1156932620),
('Langfang','Langfang',39.5196,116.701,'China','CN','CHN','Hebei','',4358839,1156109017),
('Zhangjiakou','Zhangjiakou',40.8108,114.881,'China','CN','CHN','Hebei','',4345491,1156800221),
('İzmir','Izmir',38.4127,27.1384,'Turkey','TR','TUR','İzmir','admin',4320519,1792725579),
('Linfen','Linfen',36.0812,111.509,'China','CN','CHN','Shanxi','',4316610,1156416074),
('Wenzhou','Wenzhou',27.9991,120.656,'China','CN','CHN','Zhejiang','',4310000,1156188829),
('Monterrey','Monterrey',25.6667,-100.3,'Mexico','MX','MEX','Nuevo León','admin',4295000,1484559591),
('Luzhou','Luzhou',28.8918,105.441,'China','CN','CHN','Sichuan','minor',4291000,1156582079),
('Jiangguanchi','Jiangguanchi',34.0244,113.82,'China','CN','CHN','Henan','minor',4289000,1156235735),
('Neijiang','Neijiang',29.5872,105.063,'China','CN','CHN','Sichuan','minor',4238000,1156516335),
('Phoenix','Phoenix',33.5722,-112.089,'United States','US','USA','Arizona','admin',4219697,1840020568),
('Yanjiang','Yanjiang',30.1256,104.64,'China','CN','CHN','Sichuan','minor',4217000,1156217114),
('Zhaoqing','Zhaoqing',23.05,112.467,'China','CN','CHN','Guangdong','minor',4151700,1156170144),
('Xiaoxita','Xiaoxita',30.7083,111.28,'China','CN','CHN','Hubei','minor',4137900,1156764447),
('Guigang','Guigang',23.0961,109.609,'China','CN','CHN','Guangxi','',4118808,1156895251),
('Xiamen','Xiamen',24.4797,118.082,'China','CN','CHN','Fujian','minor',4110000,1156212809),
('Chuzhou','Chuzhou',32.3062,118.312,'China','CN','CHN','Anhui','',4110000,1156036420),
('Fuzhou','Fuzhou',27.9814,116.358,'China','CN','CHN','Jiangxi','',4047200,1156915325),
('Zhuzhou','Zhuzhou',27.8407,113.147,'China','CN','CHN','Hunan','minor',4028500,1156041962),
('Amman','Amman',31.95,35.9333,'Jordan','JO','JOR','Al ‘Āşimah','primary',4007526,1400522593),
('Jeddah','Jeddah',21.5428,39.1728,'Saudi Arabia','SA','SAU','Makkah al Mukarramah','',3976000,1682926944),
('Loudi','Loudi',27.7378,111.997,'China','CN','CHN','Hunan','',3941300,1156010654),
('Deyang','Deyang',31.1289,104.395,'China','CN','CHN','Sichuan','minor',3877000,1156127147),
('Qingyuan','Qingyuan',23.6842,113.051,'China','CN','CHN','Guangdong','minor',3874000,1156135890),
('Wuhu','Wuhu',31.334,118.362,'China','CN','CHN','Anhui','minor',3842100,1156315512),
('Hechi','Hechi',23.0965,109.609,'China','CN','CHN','Guangxi','',3830000,1156868701),
('Seattle','Seattle',47.6211,-122.324,'United States','US','USA','Washington','',3789215,1840021117),
('Binzhou','Binzhou',37.3806,118.012,'China','CN','CHN','Shandong','',3779200,1156564962),
('Yokohama','Yokohama',35.4333,139.633,'Japan','JP','JPN','Kanagawa','admin',3757630,1392118339),
('Liuzhou','Liuzhou',24.3264,109.428,'China','CN','CHN','Guangxi','minor',3758704,1156360785),
('Baojishi','Baojishi',34.3609,107.175,'China','CN','CHN','Shaanxi','',3738700,1156101096),
('Guang’an','Guang\'an',30.4673,106.634,'China','CN','CHN','Sichuan','minor',3723000,1156377302),
('Hanzhong','Hanzhong',33.0794,107.026,'China','CN','CHN','Shaanxi','',3700000,1156382678),
('Kabul','Kabul',34.5328,69.1658,'Afghanistan','AF','AFG','Kābul','primary',3678034,1004993580),
('Zaozhuang','Zaozhuang',34.8667,117.55,'China','CN','CHN','Shandong','',3650000,1156796454),
('Berlin','Berlin',52.5167,13.3833,'Germany','DE','DEU','Berlin','primary',3644826,1276451290),
('Anshan','Anshan',41.1066,122.99,'China','CN','CHN','Liaoning','',3645884,1156901825),
('Lanzhou','Lanzhou',36.0617,103.832,'China','CN','CHN','Gansu','admin',3616163,1156280566),
('Chengde','Chengde',40.9739,117.932,'China','CN','CHN','Hebei','',3610000,1156197800),
('San Francisco','San Francisco',37.7562,-122.443,'United States','US','USA','California','',3592294,1840021543),
('Puyang','Puyang',35.7639,115.03,'China','CN','CHN','Henan','minor',3580000,1156431924),
('Suining','Suining',30.5098,105.574,'China','CN','CHN','Sichuan','minor',3556000,1156655650),
('Jiaozuo','Jiaozuo',35.229,113.23,'China','CN','CHN','Henan','',3540101,1156157854),
('Bengbu','Bengbu',32.9354,117.353,'China','CN','CHN','Anhui','',3525000,1156440668),
('Montréal','Montreal',45.5089,-73.5617,'Canada','CA','CAN','Quebec','',3519595,1124586170),
('Detroit','Detroit',42.3834,-83.1024,'United States','US','USA','Michigan','',3506126,1840003971),
('Baicheng','Baicheng',23.901,106.619,'China','CN','CHN','Guangxi','minor',3466758,1156981113),
('Busan','Busan',35.1,129.04,'Korea, South','KR','KOR','Busan','admin',3453198,1410601465),
('Algiers','Algiers',36.7764,3.0586,'Algeria','DZ','DZA','Alger','primary',3415811,1012973369),
('Qincheng','Qincheng',34.5809,105.731,'China','CN','CHN','Gansu','minor',3400000,1156104017),
('Taiyuan','Taiyuan',37.8733,112.543,'China','CN','CHN','Shanxi','admin',3398000,1156632014),
('Shiyan','Shiyan',32.6351,110.775,'China','CN','CHN','Hubei','minor',3398000,1156383921),
('Lucknow','Lucknow',26.847,80.947,'India','IN','IND','Uttar Pradesh','admin',3382000,1356891790),
('Chaoyang','Chaoyang',41.5757,120.449,'China','CN','CHN','Liaoning','',3370000,1156706927),
('Hechi','Hechi',24.6928,108.085,'China','CN','CHN','Guangxi','',3369251,1156167204),
('Leshan','Leshan',29.5854,103.757,'China','CN','CHN','Sichuan','',3364000,1156203130),
('Yulinshi','Yulinshi',38.2655,109.739,'China','CN','CHN','Shaanxi','',3328000,1156280672),
('Siping','Siping',43.1715,124.364,'China','CN','CHN','Jilin','',3300000,1156063295),
('Zhongshan','Zhongshan',22.5333,113.35,'China','CN','CHN','Guangdong','minor',3260000,1156579621),
('Changzhi','Changzhi',36.1953,113.097,'China','CN','CHN','Shanxi','minor',3230000,1156057944),
('San Diego','San Diego',32.8312,-117.122,'United States','US','USA','California','',3220118,1840021990),
('Faisalabad','Faisalabad',31.418,73.079,'Pakistan','PK','PAK','Punjab','minor',3203846,1586323916),
('Santa Cruz','Santa Cruz',-17.7892,-63.1975,'Bolivia','BO','BOL','Santa Cruz','admin',3151676,1068129363),
('Qinhuangdao','Qinhuangdao',39.9398,119.588,'China','CN','CHN','Hebei','',3146300,1156091093),
('Bazhou','Bazhou',31.8576,106.756,'China','CN','CHN','Sichuan','minor',3134000,1156271365),
('Zhenjiang','Zhenjiang',32.2109,119.455,'China','CN','CHN','Jiangsu','minor',3113384,1156934125),
('Ürümqi','Urumqi',43.8225,87.6125,'China','CN','CHN','Xinjiang','admin',3112559,1156051276),
('Tongliao','Tongliao',43.6172,122.264,'China','CN','CHN','Inner Mongolia','minor',3094600,1156358686),
('Heyuan','Heyuan',23.7503,114.692,'China','CN','CHN','Guangdong','minor',3093900,1156665165),
('Tongren','Tongren',27.7233,109.188,'China','CN','CHN','Guizhou','',3093204,1156803442),
('Qinzhou','Qinzhou',21.95,108.617,'China','CN','CHN','Guangxi','minor',3079721,1156106602),
('Jaipur','Jaipur',26.9167,75.8667,'India','IN','IND','Rājasthān','admin',3073350,1356293537),
('Xinzhou','Xinzhou',38.4178,112.723,'China','CN','CHN','Shanxi','minor',3067501,1156617534),
('Addis Ababa','Addis Ababa',9.0272,38.7369,'Ethiopia','ET','ETH','Ādīs Ābeba','primary',3041002,1231824991),
('Meishan','Meishan',30.0575,103.838,'China','CN','CHN','Sichuan','',3020000,1156185501),
('Brasília','Brasilia',-15.7939,-47.8828,'Brazil','BR','BRA','Distrito Federal','primary',3015268,1076144436),
('Mashhad','Mashhad',36.3069,59.6042,'Iran','IR','IRN','Khorāsān-e Raẕavī','admin',3001184,1364123206),
('Jinzhou','Jinzhou',41.1144,121.129,'China','CN','CHN','Liaoning','',3000000,1156157151),
('Tieling','Tieling',42.2841,123.837,'China','CN','CHN','Liaoning','',3000000,1156089994),
('Shaoguan','Shaoguan',24.8011,113.593,'China','CN','CHN','Guangdong','minor',2997600,1156617066),
('Kuwait City','Kuwait City',29.375,47.98,'Kuwait','KW','KWT','Al ‘Āşimah','primary',2989000,1414102075),
('Shanwei','Shanwei',22.7664,115.333,'China','CN','CHN','Guangdong','minor',2993600,1156939010),
('Minneapolis','Minneapolis',44.9635,-93.2678,'United States','US','USA','Minnesota','',2977172,1840007830),
('Kyiv','Kyiv',50.45,30.5236,'Ukraine','UA','UKR','Kyyiv, Misto','primary',2963199,1804382913),
('Sanaa','Sanaa',15.35,44.2,'Yemen','YE','YEM','Amānat al ‘Āşimah','primary',2957000,1887750814),
('Quezon City','Quezon City',14.6333,121.033,'Philippines','PH','PHL','Quezon','admin',2936116,1608974097),
('Dingxi','Dingxi',35.5806,104.626,'China','CN','CHN','Gansu','minor',2930000,1156518274),
('Incheon','Incheon',37.4639,126.649,'Korea, South','KR','KOR','Incheon','admin',2913024,1410160313),
('Bursa','Bursa',40.1833,29.0667,'Turkey','TR','TUR','Bursa','admin',2901396,1792903330),
('Ningde','Ningde',26.6667,119.517,'China','CN','CHN','Fujian','minor',2910000,1156909802),
('Tampa','Tampa',27.9942,-82.4451,'United States','US','USA','Florida','',2908063,1840015982),
('Daqing','Daqing',46.5979,125.008,'China','CN','CHN','Heilongjiang','',2904532,1156403962),
('Birmingham','Birmingham',52.48,-1.9025,'United Kingdom','GB','GBR','Birmingham','',2897303,1826423213),
('Putian','Putian',25.4394,119.01,'China','CN','CHN','Fujian','minor',2900000,1156811601),
('Huzhou','Huzhou',30.8695,120.096,'China','CN','CHN','Zhejiang','minor',2893542,1156335543),
('Salvador','Salvador',-12.9708,-38.5108,'Brazil','BR','BRA','Bahia','admin',2886698,1076923789),
('Wuzhou','Wuzhou',23.4833,111.317,'China','CN','CHN','Guangxi','minor',2882200,1156620133),
('Xiangtan','Xiangtan',27.8431,112.923,'China','CN','CHN','Hunan','',2881500,1156195684),
('Denver','Denver',39.7621,-104.876,'United States','US','USA','Colorado','admin',2876625,1840018789),
('Rome','Rome',41.8931,12.4828,'Italy','IT','ITA','Lazio','primary',2872800,1380382862),
('La Paz','La Paz',-16.4942,-68.1475,'Bolivia','BO','BOL','La Paz','primary',2867504,1068000064),
('Pyongyang','Pyongyang',39.03,125.73,'Korea, North','KP','PRK','P’yŏngyang','primary',2863000,1408738594),
('Kano','Kano',12,8.5167,'Nigeria','NG','NGA','Kano','admin',2828861,1566422868),
('Taichung','Taichung',24.15,120.667,'Taiwan','TW','TWN','Taichung','admin',2803894,1158689622),
('Omdurman','Omdurman',15.6835,32.4629,'Sudan','SD','SDN','Khartoum','',2805396,1729912179),
('Zigong','Zigong',29.3498,104.765,'China','CN','CHN','Sichuan','',2800000,1156023354),
('Mudanjiang','Mudanjiang',44.5861,129.6,'China','CN','CHN','Heilongjiang','minor',2790000,1156249698),
('Huludao','Huludao',40.7094,120.838,'China','CN','CHN','Liaoning','minor',2787000,1156580218),
('Kaohsiung','Kaohsiung',22.6167,120.3,'Taiwan','TW','TWN','Kaohsiung','admin',2773533,1158331334),
('Guayaquil','Guayaquil',-2.1833,-79.8833,'Ecuador','EC','ECU','Guayas','admin',2723665,1218802178),
('Rizhao','Rizhao',35.4164,119.433,'China','CN','CHN','Shandong','minor',2720000,1156032841),
('Manchester','Manchester',53.4794,-2.2453,'United Kingdom','GB','GBR','Manchester','',2705000,1826246335),
('Cawnpore','Cawnpore',26.4725,80.3311,'India','IN','IND','Uttar Pradesh','',2701324,1356575238),
('Baotou','Baotou',40.6562,109.835,'China','CN','CHN','Inner Mongolia','',2700000,1156032751),
('Taipei','Taipei',25.0478,121.532,'Taiwan','TW','TWN','Taipei','primary',2684567,1158881289),
('Nanping','Nanping',26.6448,118.173,'China','CN','CHN','Fujian','minor',2690000,1156927445),
('Chaozhou','Chaozhou',23.67,116.63,'China','CN','CHN','Guangdong','minor',2656600,1156549118),
('Longyan','Longyan',25.0881,117.024,'China','CN','CHN','Fujian','minor',2640000,1156012979),
('Ibadan','Ibadan',7.3964,3.9167,'Nigeria','NG','NGA','Oyo','admin',2628000,1566366407),
('Hohhot','Hohhot',40.8151,111.663,'China','CN','CHN','Inner Mongolia','admin',2635000,1156210167),
('Antananarivo','Antananarivo',-18.9386,47.5214,'Madagascar','MG','MDG','Antananarivo','primary',2610000,1450978461),
('Longba','Longba',33.535,105.349,'China','CN','CHN','Gansu','',2614000,1156633259),
('Weihai','Weihai',37.5,122.1,'China','CN','CHN','Shandong','minor',2596753,1156473300),
('Chattogram','Chattogram',22.335,91.8325,'Bangladesh','BD','BGD','Chittagong','admin',2581643,1050830722),
('Santo Domingo','Santo Domingo',18.4764,-69.8933,'Dominican Republic','DO','DOM','Ozama','primary',2581827,1214636202),
('Xuanzhou','Xuanzhou',30.9475,118.752,'China','CN','CHN','Anhui','',2580000,1156424311),
('Sanming','Sanming',26.2658,117.63,'China','CN','CHN','Fujian','minor',2580000,1156294429),
('Brooklyn','Brooklyn',40.6501,-73.9496,'United States','US','USA','New York','',2559903,1840034030),
('Yangjiang','Yangjiang',21.8556,111.963,'China','CN','CHN','Guangdong','minor',2555600,1156123172),
('Medellín','Medellin',6.2447,-75.5748,'Colombia','CO','COL','Antioquia','admin',2529403,1170680389),
('Yunfu','Yunfu',22.9242,112.035,'China','CN','CHN','Guangdong','minor',2526900,1156057251),
('Brisbane','Brisbane',-27.4678,153.028,'Australia','AU','AUS','Queensland','admin',2514184,1036192929),
('Baoshan','Baoshan',25.1211,99.169,'China','CN','CHN','Yunnan','',2506491,1156546994),
('Dubai','Dubai',25.2697,55.3094,'United Arab Emirates','AE','ARE','Dubayy','admin',2502715,1784736618),
('Luohe','Luohe',33.583,114.011,'China','CN','CHN','Henan','minor',2500000,1156330876),
('Qinbaling','Qinbaling',35.7278,107.64,'China','CN','CHN','Gansu','',2500000,1156032582),
('Mirzāpur','Mirzapur',25.15,82.58,'India','IN','IND','Uttar Pradesh','',2496970,1356427908),
('Guangyuan','Guangyuan',32.4353,105.84,'China','CN','CHN','Sichuan','',2484122,1156084562),
('Cali','Cali',3.44,-76.5197,'Colombia','CO','COL','Valle del Cauca','admin',2471474,1170417589),
('Huangshi','Huangshi',30.2018,115.033,'China','CN','CHN','Hubei','minor',2471700,1156234290),
('Daegu','Daegu',35.8667,128.6,'Korea, South','KR','KOR','Daegu','admin',2461002,1410095252),
('Fortaleza','Fortaleza',-3.7275,-38.5275,'Brazil','BR','BRA','Ceará','admin',2452185,1076567885),
('Guatemala City','Guatemala City',14.6099,-90.5252,'Guatemala','GT','GTM','Guatemala','primary',2450212,1320197916),
('Yaoundé','Yaounde',3.8578,11.5181,'Cameroon','CM','CMR','Centre','primary',2440462,1120298240),
('Douala','Douala',4.05,9.7,'Cameroon','CM','CMR','Littoral','admin',2446945,1120494607),
('Jilin','Jilin',43.85,126.55,'China','CN','CHN','Jilin','',2396000,1156646448),
('Lianshan','Lianshan',40.7503,120.83,'China','CN','CHN','Liaoning','minor',2426000,1156046704),
('Lincang','Lincang',23.8864,100.087,'China','CN','CHN','Yunnan','',2429497,1156044130),
('Antalya','Antalya',36.9081,30.6956,'Turkey','TR','TUR','Antalya','admin',2426356,1792988434),
('Tashkent','Tashkent',41.3,69.2667,'Uzbekistan','UZ','UZB','Toshkent','primary',2424100,1860331871),
('Bandung','Bandung',-6.95,107.567,'Indonesia','ID','IDN','Jawa Barat','admin',2394873,1360313023),
('Nāgpur','Nagpur',21.1539,79.0831,'India','IN','IND','Mahārāshtra','',2405665,1356365743),
('Huainan','Huainan',32.4831,117.016,'China','CN','CHN','Anhui','',2409000,1156877299),
('Dandong','Dandong',40.1167,124.383,'China','CN','CHN','Liaoning','',2400000,1156178316),
('Shangzhou','Shangzhou',33.868,109.924,'China','CN','CHN','Shaanxi','',2400000,1156091241),
('Bekasi','Bekasi',-6.2333,107,'Indonesia','ID','IDN','Jawa Barat','',2381053,1360006015),
('Ghāziābād','Ghaziabad',28.6667,77.4167,'India','IN','IND','Uttar Pradesh','',2381452,1356691871),
('Tijuana','Tijuana',32.525,-117.033,'Mexico','MX','MEX','Baja California','minor',2384609,1484708778),
('Jiamusi','Jiamusi',46.8081,130.365,'China','CN','CHN','Heilongjiang','minor',2360000,1156350864),
('Accra','Accra',5.6037,-0.187,'Ghana','GH','GHA','Greater Accra','primary',2291352,1288299415),
('Yuxi','Yuxi',24.3495,102.543,'China','CN','CHN','Yunnan','minor',2303518,1156682309),
('Anshun','Anshun',26.2456,105.934,'China','CN','CHN','Guizhou','',2297612,1156415948),
('Vancouver','Vancouver',49.25,-123.1,'Canada','CA','CAN','British Columbia','',2264823,1124825478),
('Tangerang','Tangerang',-6.1783,106.632,'Indonesia','ID','IDN','Jawa Barat','',2237006,1360002844),
('Konya','Konya',37.8714,32.4847,'Turkey','TR','TUR','Konya','admin',2232374,1792014004),
('Queens','Queens',40.7498,-73.7976,'United States','US','USA','New York','',2230722,1840034002),
('Yingkou','Yingkou',40.6653,122.23,'China','CN','CHN','Liaoning','minor',2220000,1156257074),
('Adana','Adana',37,35.325,'Turkey','TR','TUR','Adana','admin',2220125,1792783772),
('Medan','Medan',3.6667,98.6667,'Indonesia','ID','IDN','Sumatera Utara','admin',2210625,1360543171),
('Sanmenxia','Sanmenxia',34.7736,111.195,'China','CN','CHN','Henan','',2213000,1156529682),
('Indore','Indore',22.7206,75.8472,'India','IN','IND','Madhya Pradesh','',2201927,1356402812),
('Ma’anshan','Ma\'anshan',31.7135,118.36,'China','CN','CHN','Anhui','minor',2202899,1156847452),
('Pingliang','Pingliang',35.5412,106.682,'China','CN','CHN','Gansu','minor',2190000,1156216904),
('Quzhou','Quzhou',28.9545,118.876,'China','CN','CHN','Zhejiang','',2185000,1156180376),
('Baku','Baku',40.3667,49.8352,'Azerbaijan','AZ','AZE','Bakı','primary',2181800,1031946365),
('Gaoping','Gaoping',30.7804,106.13,'China','CN','CHN','Sichuan','minor',2174000,1156522457),
('Huaibei','Huaibei',33.9562,116.789,'China','CN','CHN','Anhui','',2158000,1156142626),
('Xining','Xining',36.6239,101.779,'China','CN','CHN','Qinghai','admin',2154000,1156081448),
('Harare','Harare',-17.8292,31.0522,'Zimbabwe','ZW','ZWE','Harare','primary',2150000,1716196799),
('Yan’an','Yan\'an',36.5952,109.486,'China','CN','CHN','Shaanxi','',2150000,1156546342),
('Havana','Havana',23.1367,-82.3589,'Cuba','CU','CUB','La Habana','primary',2141652,1192752771),
('Phnom Penh','Phnom Penh',11.5696,104.921,'Cambodia','KH','KHM','Phnom Penh','primary',2129371,1116260534),
('Fukuoka','Fukuoka',33.6,130.417,'Japan','JP','JPN','Fukuoka','admin',2128000,1392576294),
('Mogadishu','Mogadishu',2.0408,45.3425,'Somalia','SO','SOM','Banaadir','primary',2120000,1706893395),
('Jincheng','Jincheng',35.4906,112.848,'China','CN','CHN','Shanxi','minor',2120000,1156163376),
('Puning','Puning',23.2993,116.159,'China','CN','CHN','Guangdong','',2118200,1156756494),
('Lishui','Lishui',28.45,119.917,'China','CN','CHN','Zhejiang','minor',2116957,1156858793),
('Qingyang','Qingyang',24.8141,118.579,'China','CN','CHN','Fujian','minor',2111000,1156273372),
('Riverside','Riverside',33.9381,-117.395,'United States','US','USA','California','',2107852,1840020551),
('Baltimore','Baltimore',39.3051,-76.6144,'United States','US','USA','Maryland','',2106068,1840001592),
('Haiphong','Haiphong',20.8,106.667,'Vietnam','VN','VNM','Hải Phòng','admin',2103500,1704000623),
('Las Vegas','Las Vegas',36.2333,-115.265,'United States','US','USA','Nevada','',2104198,1840020364),
('Laibin','Laibin',23.7333,109.233,'China','CN','CHN','Guangxi','',2099711,1156925734),
('Rawalpindi','Rawalpindi',33.6007,73.0679,'Pakistan','PK','PAK','Punjab','minor',2098231,1586344001),
('Kumasi','Kumasi',6.6833,-1.6167,'Ghana','GH','GHA','Ashanti','admin',2069350,1288181103),
('Portland','Portland',45.5372,-122.65,'United States','US','USA','Oregon','',2074775,1840019941),
('Vadodara','Vadodara',22.3,73.2,'India','IN','IND','Gujarāt','',2065771,1356705249),
('Perth','Perth',-31.9522,115.859,'Australia','AU','AUS','Western Australia','admin',2059484,1036178956),
('San Antonio','San Antonio',29.4658,-98.5253,'United States','US','USA','Texas','',2049293,1840022220),
('Vishākhapatnam','Vishakhapatnam',17.7333,83.3167,'India','IN','IND','Andhra Pradesh','',2035922,1356692563),
('Gujranwala','Gujranwala',32.15,74.1833,'Pakistan','PK','PAK','Punjab','minor',2027001,1586400472),
('Gaziantep','Gaziantep',37.0667,37.3833,'Turkey','TR','TUR','Gaziantep','admin',2028563,1792911843),
('Fushun','Fushun',41.8708,123.892,'China','CN','CHN','Liaoning','',2024000,1156857743),
('St. Louis','St. Louis',38.6358,-90.2451,'United States','US','USA','Missouri','',2024074,1840001651),
('Bamako','Bamako',12.6458,-7.9922,'Mali','ML','MLI','Bamako','primary',2009109,1466965925),
('Quito','Quito',-0.2186,-78.5097,'Ecuador','EC','ECU','Pichincha','primary',2011388,1218441993),
('Minsk','Minsk',53.9022,27.5618,'Belarus','BY','BLR','Minsk','primary',2009786,1112348503),
('Pingxiang','Pingxiang',27.6333,113.85,'China','CN','CHN','Jiangxi','minor',2001027,1156066465),
('Chongzuo','Chongzuo',22.4167,107.367,'China','CN','CHN','Guangxi','minor',1994285,1156438670),
('Şanlıurfa','Sanliurfa',37.1583,38.7917,'Turkey','TR','TUR','Şanlıurfa','admin',1985753,1792937570),
('Kananga','Kananga',-5.897,22.4488,'Congo (Kinshasa)','CD','COD','Kasaï Central','admin',1971704,1180172460),
('Peshawar','Peshawar',34,71.5,'Pakistan','PK','PAK','Khyber Pakhtunkhwa','admin',1970042,1586851102),
('Sapporo','Sapporo',43.0621,141.354,'Japan','JP','JPN','Hokkaidō','admin',1961690,1392000195),
('Hezhou','Hezhou',24.4164,111.548,'China','CN','CHN','Guangxi','minor',1954072,1156459799),
('Jixi','Jixi',45.2937,130.965,'China','CN','CHN','Heilongjiang','minor',1950000,1156393765),
('Caracas','Caracas',10.5,-66.9333,'Venezuela','VE','VEN','Distrito Capital','primary',1943901,1862748204),
('Fuxin','Fuxin',42.0127,121.649,'China','CN','CHN','Liaoning','',1930000,1156141954),
('Aleppo','Aleppo',36.2,37.15,'Syria','SY','SYR','Ḩalab','admin',1916781,1760366651),
('Almaty','Almaty',43.25,76.9,'Kazakhstan','KZ','KAZ','Almaty','',1916822,1398351701),
('Dayr az Zawr','Dayr az Zawr',35.3333,40.15,'Syria','SY','SYR','Dayr az Zawr','admin',1918000,1760792603),
('Vienna','Vienna',48.2083,16.3731,'Austria','AT','AUT','Wien','primary',1911191,1040261752),
('Leeds','Leeds',53.7997,-1.5492,'United Kingdom','GB','GBR','Leeds','',1901934,1826343963),
('Sacramento','Sacramento',38.5667,-121.468,'United States','US','USA','California','admin',1898019,1840021491),
('Blantyre','Blantyre',-15.7861,35.0058,'Malawi','MW','MWI','Blantyre','admin',1895973,1454145012),
('Tainan','Tainan',22.9833,120.183,'Taiwan','TW','TWN','Tainan','admin',1883831,1158061376),
('Zhuhai','Zhuhai',22.2769,113.568,'China','CN','CHN','Guangdong','minor',1891100,1156722242),
('Bucharest','Bucharest',44.4,26.0833,'Romania','RO','ROU','Bucureşti','primary',1883425,1642414442),
('Wuwei','Wuwei',37.9278,102.633,'China','CN','CHN','Gansu','minor',1890000,1156760291),
('Bhopāl','Bhopal',23.25,77.4167,'India','IN','IND','Madhya Pradesh','admin',1883381,1356734039),
('Curitiba','Curitiba',-25.4297,-49.2719,'Brazil','BR','BRA','Paraná','admin',1879355,1076701712),
('Multan','Multan',30.1978,71.4711,'Pakistan','PK','PAK','Punjab','minor',1871843,1586256291),
('Xiping','Xiping',40.08,113.3,'China','CN','CHN','Shanxi','minor',1873000,1156898522),
('Asunción','Asuncion',-25.3,-57.6333,'Paraguay','PY','PRY','Asunción','primary',1870000,1600057911),
('Saidu Sharif','Saidu Sharif',34.75,72.3572,'Pakistan','PK','PAK','Khyber Pakhtunkhwa','minor',1860310,1586619596),
('Hamburg','Hamburg',53.55,10,'Germany','DE','DEU','Hamburg','admin',1841179,1276041799),
('Meru','Meru',0.05,37.65,'Kenya','KE','KEN','Meru','admin',1833000,1404588252),
('Brazzaville','Brazzaville',-4.2667,15.2833,'Congo (Brazzaville)','CG','COG','Brazzaville','primary',1827000,1178340306),
('Orlando','Orlando',28.4772,-81.3369,'United States','US','USA','Florida','',1822394,1840015099),
('Mersin','Mersin',36.8,34.6167,'Turkey','TR','TUR','Mersin','admin',1814468,1792520282),
('Kyōto','Kyoto',35.0111,135.767,'Japan','JP','JPN','Kyōto','admin',1805000,1392622735),
('Manaus','Manaus',-3.1,-60.0167,'Brazil','BR','BRA','Amazonas','admin',1802014,1076607274),
('Liaoyang','Liaoyang',41.2643,123.177,'China','CN','CHN','Liaoning','',1800000,1156202749),
('Baiyin','Baiyin',36.5448,104.177,'China','CN','CHN','Gansu','minor',1799000,1156140738),
('San Jose','San Jose',37.3019,-121.849,'United States','US','USA','California','',1798103,1840021570),
('Warsaw','Warsaw',52.2167,21.0333,'Poland','PL','POL','Mazowieckie','primary',1790658,1616024847),
('Shengli','Shengli',37.45,118.467,'China','CN','CHN','Shandong','minor',1790000,1156672254),
('Lubumbashi','Lubumbashi',-11.6697,27.4581,'Congo (Kinshasa)','CD','COD','Haut-Katanga','admin',1786397,1180506234),
('Haikou','Haikou',20.02,110.32,'China','CN','CHN','Hainan','admin',1776141,1156183327),
('Damascus','Damascus',33.5131,36.2919,'Syria','SY','SYR','Dimashq','primary',1754000,1760685964),
('Shuyangzha','Shuyangzha',34.1299,118.773,'China','CN','CHN','Jiangsu','',1770000,1156051957),
('Brussels','Brussels',50.8333,4.3333,'Belgium','BE','BEL','Brussels-Capital Region','primary',1743000,1056469830),
('Eşfahān','Esfahan',32.6447,51.6675,'Iran','IR','IRN','Eşfahān','admin',1756126,1364023865),
('Budapest','Budapest',47.4983,19.0408,'Hungary','HU','HUN','Budapest','primary',1752286,1348611435),
('Heihe','Heihe',50.2458,127.489,'China','CN','CHN','Heilongjiang','minor',1750000,1156339225),
('Lusaka','Lusaka',-15.4167,28.2833,'Zambia','ZM','ZMB','Lusaka','primary',1742979,1894157390),
('Hyderabad City','Hyderabad City',25.3792,68.3683,'Pakistan','PK','PAK','Sindh','minor',1732693,1586185019),
('Diyarbakır','Diyarbakir',37.9108,40.2367,'Turkey','TR','TUR','Diyarbakır','admin',1732396,1792536241),
('Chinchvad','Chinchvad',18.6278,73.8131,'India','IN','IND','Mahārāshtra','',1729320,1356475483),
('Shuozhou','Shuozhou',39.3408,112.429,'China','CN','CHN','Shanxi','minor',1714857,1156227167),
('Cleveland','Cleveland',41.4767,-81.6804,'United States','US','USA','Ohio','',1710093,1840000596),
('Pittsburgh','Pittsburgh',40.4396,-79.9762,'United States','US','USA','Pennsylvania','',1703266,1840001254),
('Patna','Patna',25.61,85.1414,'India','IN','IND','Bihār','admin',1684222,1356821429),
('Mosul','Mosul',36.3667,43.1167,'Iraq','IQ','IRQ','Nīnawá','admin',1694000,1368194914),
('Austin','Austin',30.3004,-97.7522,'United States','US','USA','Texas','admin',1687311,1840019590),
('Sanzhou','Sanzhou',30.82,108.4,'China','CN','CHN','Chongqing','',1680000,1156025536),
('Mecca','Mecca',21.4225,39.8261,'Saudi Arabia','SA','SAU','Makkah al Mukarramah','admin',1675368,1682169241),
('Conakry','Conakry',9.5092,-13.7122,'Guinea','GN','GIN','Conakry','primary',1667864,1324568159),
('Kampala','Kampala',0.3136,32.5811,'Uganda','UG','UGA','Kampala','primary',1659600,1800406299),
('Ecatepec','Ecatepec',19.6097,-99.06,'Mexico','MX','MEX','México','minor',1656107,1484003694),
('Cincinnati','Cincinnati',39.1413,-84.5061,'United States','US','USA','Ohio','',1662691,1840003814),
('Makassar','Makassar',-5.1331,119.414,'Indonesia','ID','IDN','Sulawesi Selatan','admin',1651146,1360051337),
('Yushan','Yushan',31.3867,120.977,'China','CN','CHN','Jiangsu','minor',1651200,1156245000),
('Ludhiāna','Ludhiana',30.9083,75.8486,'India','IN','IND','Punjab','',1649000,1356929498),
('Newcastle','Newcastle',55.0077,-1.6578,'United Kingdom','GB','GBR','Newcastle upon Tyne','',1650000,1826292220),
('Depok','Depok',-6.394,106.823,'Indonesia','ID','IDN','Jawa Barat','',1631951,1360962899),
('Zhongli','Zhongli',24.965,121.217,'Taiwan','TW','TWN','Taoyuan','',1632616,1158025380),
('Kansas City','Kansas City',39.1239,-94.5541,'United States','US','USA','Missouri','',1636715,1840008535),
('Ouagadougou','Ouagadougou',12.3572,-1.5353,'Burkina Faso','BF','BFA','Centre','primary',1626950,1854029208),
('Davao','Davao',7.0667,125.6,'Philippines','PH','PHL','Davao','admin',1632991,1608906877),
('Manhattan','Manhattan',40.7834,-73.9662,'United States','US','USA','New York','',1628706,1840034000),
('Semarang','Semarang',-6.9667,110.417,'Indonesia','ID','IDN','Jawa Tengah','admin',1621384,1360745537),
('Yinchuan','Yinchuan',38.4795,106.225,'China','CN','CHN','Ningxia','admin',1616000,1156359072),
('Caloocan City','Caloocan City',14.65,120.967,'Philippines','PH','PHL','Caloocan','admin',1583978,1608897690),
('Novosibirsk','Novosibirsk',55.0333,82.9167,'Russia','RU','RUS','Novosibirskaya Oblast’','admin',1602915,1643399240),
('Chengtangcun','Chengtangcun',35.0833,117.15,'China','CN','CHN','Shandong','',1603659,1156883901),
('Āgra','Agra',27.18,78.02,'India','IN','IND','Uttar Pradesh','',1585705,1356187395),
('Karaj','Karaj',35.8327,50.9915,'Iran','IR','IRN','Alborz','admin',1592492,1364258511),
('Indianapolis','Indianapolis',39.7771,-86.1458,'United States','US','USA','Indiana','admin',1588961,1840030084),
('Jingdezhen','Jingdezhen',29.2942,117.204,'China','CN','CHN','Jiangxi','minor',1587477,1156038165),
('Puebla','Puebla',19.0333,-98.1833,'Mexico','MX','MEX','Puebla','admin',1576259,1484416394),
('Kalyān','Kalyan',19.2502,73.1602,'India','IN','IND','Mahārāshtra','',1576614,1356172246),
('Madurai','Madurai',9.9197,78.1194,'India','IN','IND','Tamil Nādu','minor',1561129,1356257289),
('Benxi','Benxi',41.292,123.761,'China','CN','CHN','Liaoning','',1567000,1156097909),
('Jamshedpur','Jamshedpur',22.8,86.1833,'India','IN','IND','Jharkhand','',1558000,1356501259),
('Recife','Recife',-8.0539,-34.8808,'Brazil','BR','BRA','Pernambuco','admin',1555039,1076137337),
('Columbus','Columbus',39.9862,-82.985,'United States','US','USA','Ohio','admin',1562009,1840003760),
('Tabrīz','Tabriz',38.0833,46.2833,'Iran','IR','IRN','Āz̄arbāyjān-e Sharqī','admin',1558693,1364141756),
('Maracaibo','Maracaibo',10.6333,-71.6333,'Venezuela','VE','VEN','Zulia','admin',1551539,1862072711),
('Zhangjiajie','Zhangjiajie',29.1255,110.484,'China','CN','CHN','Hunan','minor',1549200,1156072884),
('Beihai','Beihai',21.4667,109.1,'China','CN','CHN','Guangxi','',1539251,1156421449),
('Shuangyashan','Shuangyashan',46.6388,131.154,'China','CN','CHN','Heilongjiang','',1530000,1156245904),
('Kōbe','Kobe',34.6913,135.183,'Japan','JP','JPN','Hyōgo','admin',1513193,1392978082),
('Charlotte','Charlotte',35.208,-80.8304,'United States','US','USA','North Carolina','',1512923,1840014557),
('Yucheng','Yucheng',29.9888,103.001,'China','CN','CHN','Sichuan','minor',1512000,1156817119),
('Changshu','Changshu',31.65,120.733,'China','CN','CHN','Jiangsu','',1510100,1156901538),
('Lianjiang','Lianjiang',21.6146,110.279,'China','CN','CHN','Guangdong','',1509400,1156944106),
('Ximeicun','Ximeicun',24.9633,118.381,'China','CN','CHN','Fujian','',1508000,1156173813),
('Jianguang','Jianguang',28.1958,115.783,'China','CN','CHN','Jiangxi','',1507402,1156545200),
('Madīnat as Sādis min Uktūbar','Madinat as Sadis min Uktubar',29.9361,30.9269,'Egypt','EG','EGY','Al Jīzah','',1500000,1818735651),
('Xushan','Xushan',30.1697,121.267,'China','CN','CHN','Zhejiang','minor',1502000,1156046916),
('Belém','Belem',-1.4558,-48.5039,'Brazil','BR','BRA','Pará','admin',1499641,1076646823),
('Guiping','Guiping',23.4,110.083,'China','CN','CHN','Guangxi','minor',1496904,1156165517),
('Leizhou','Leizhou',20.9147,110.081,'China','CN','CHN','Guangdong','',1494700,1156863840),
('Gwangju','Gwangju',35.1667,126.917,'Korea, South','KR','KOR','Gwangju','admin',1490092,1410000087),
('Nāsik','Nasik',20,73.7833,'India','IN','IND','Mahārāshtra','',1486053,1356562598),
('Porto Alegre','Porto Alegre',-30.0328,-51.23,'Brazil','BR','BRA','Rio Grande do Sul','admin',1484941,1076658221),
('Valencia','Valencia',10.1667,-68,'Venezuela','VE','VEN','Carabobo','admin',1484430,1862309871),
('Onitsha','Onitsha',6.1667,6.7833,'Nigeria','NG','NGA','Anambra','minor',1483000,1566593483),
('Virginia Beach','Virginia Beach',36.7335,-76.0435,'United States','US','USA','Virginia','',1478868,1840003871),
('Daejeon','Daejeon',36.351,127.385,'Korea, South','KR','KOR','Daejeon','admin',1475221,1410993875),
('Munich','Munich',48.1372,11.5755,'Germany','DE','DEU','Bavaria','admin',1471508,1276692352),
('Auckland','Auckland',-36.85,174.783,'New Zealand','NZ','NZL','Auckland','admin',1470100,1554435911),
('Yekaterinburg','Yekaterinburg',56.8356,60.6128,'Russia','RU','RUS','Sverdlovskaya Oblast’','admin',1468833,1643582706),
('Huangshan','Huangshan',29.7132,118.315,'China','CN','CHN','Anhui','minor',1470000,1156527426),
('Huazhou','Huazhou',32.6889,112.045,'China','CN','CHN','Henan','minor',1468061,1156796734),
('Shīrāz','Shiraz',29.61,52.5425,'Iran','IR','IRN','Fārs','admin',1460665,1364432238),
('Pizhou','Pizhou',34.3422,118.01,'China','CN','CHN','Jiangsu','',1458038,1156114238),
('Palembang','Palembang',-2.9833,104.764,'Indonesia','ID','IDN','Sumatera Selatan','admin',1452456,1360902897),
('León de los Aldama','Leon de los Aldama',21.1167,-101.683,'Mexico','MX','MEX','Guanajuato','minor',1454793,1484811199),
('El Kelaa des Srarhna','El Kelaa des Srarhna',32.05,-7.4,'Morocco','MA','MAR','Marrakech-Safi','',1450021,1504846488),
('Kharkiv','Kharkiv',50,36.2292,'Ukraine','UA','UKR','Kharkivs’ka Oblast’','admin',1446107,1804588111),
('Kawanakajima','Kawanakajima',35.53,139.705,'Japan','JP','JPN','Kanagawa','',1437266,1392879600),
('Yangshe','Yangshe',31.8775,120.551,'China','CN','CHN','Jiangsu','minor',1432044,1156203000),
('Chizhou','Chizhou',30.6583,117.485,'China','CN','CHN','Anhui','minor',1430000,1156131504),
('Guyuan','Guyuan',36.008,106.278,'China','CN','CHN','Ningxia','',1426000,1156817541),
('Rui’an','Rui\'an',27.778,120.653,'China','CN','CHN','Zhejiang','',1424667,1156993705),
('Birstall','Birstall',52.6736,-1.12,'United Kingdom','GB','GBR','Leicester','',1424216,1826141026),
('Muscat','Muscat',23.6139,58.5922,'Oman','OM','OMN','Masqaţ','primary',1421409,1512035506),
('Hebi','Hebi',35.7497,114.289,'China','CN','CHN','Henan','',1419000,1156114258),
('Bronx','Bronx',40.8501,-73.8662,'United States','US','USA','New York','',1418207,1840033999),
('Gaozhou','Gaozhou',21.9135,110.848,'China','CN','CHN','Guangdong','',1414100,1156785303),
('The Hague','The Hague',52.0767,4.2986,'Netherlands','NL','NLD','Zuid-Holland','primary',1406000,1528799905),
('Owerri','Owerri',5.4833,7.0333,'Nigeria','NG','NGA','Imo','admin',1401873,1566679132),
('Sharjah','Sharjah',25.3575,55.3919,'United Arab Emirates','AE','ARE','Ash Shāriqah','admin',1400000,1784152993),
('Farīdābād','Faridabad',28.4333,77.3167,'India','IN','IND','Haryāna','',1394000,1356013205),
('Ulaanbaatar','Ulaanbaatar',47.9203,106.917,'Mongolia','MN','MNG','Ulaanbaatar','primary',1396288,1496024767),
('Goiânia','Goiania',-16.6806,-49.2564,'Brazil','BR','BRA','Goiás','admin',1393575,1076034054),
('Kayseri','Kayseri',38.7333,35.4833,'Turkey','TR','TUR','Kayseri','admin',1389680,1792945815),
('Yueqing','Yueqing',28.1188,120.962,'China','CN','CHN','Zhejiang','',1389332,1156900058),
('Belgrade','Belgrade',44.8167,20.4667,'Serbia','RS','SRB','Beograd','primary',1378682,1688374696),
('Pingdu','Pingdu',36.7833,119.956,'China','CN','CHN','Shandong','',1378900,1156157078),
('Milan','Milan',45.4669,9.19,'Italy','IT','ITA','Lombardy','admin',1366180,1380724377),
('Aurangābād','Aurangabad',19.88,75.32,'India','IN','IND','Mahārāshtra','',1371330,1356840670),
('Yutan','Yutan',28.3147,112.554,'China','CN','CHN','Hunan','minor',1368117,1156592042),
('Wenling','Wenling',28.3797,121.372,'China','CN','CHN','Zhejiang','',1366794,1156052493),
('Milwaukee','Milwaukee',43.0642,-87.9673,'United States','US','USA','Wisconsin','',1365787,1840003046),
('Sofia','Sofia',42.6979,23.3217,'Bulgaria','BG','BGR','Sofia-Grad','primary',1355142,1100762037),
('Adelaide','Adelaide',-34.9289,138.601,'Australia','AU','AUS','South Australia','admin',1345777,1036538171),
('Prague','Prague',50.0833,14.4167,'Czechia','CZ','CZE','Praha, Hlavní Město','primary',1335084,1203744823),
('Samsun','Samsun',41.2867,36.33,'Turkey','TR','TUR','Samsun','admin',1335716,1792169057),
('Rājkot','Rajkot',22.2969,70.7984,'India','IN','IND','Gujarāt','',1335397,1356317190),
('Liangshi','Liangshi',27.2578,111.735,'China','CN','CHN','Hunan','',1335900,1156366507),
('Khulna','Khulna',22.8167,89.55,'Bangladesh','BD','BGD','Khulna','admin',1311100,1050667339),
('Córdoba','Cordoba',-31.4167,-64.1833,'Argentina','AR','ARG','Córdoba','admin',1329604,1032803249),
('Guarulhos','Guarulhos',-23.4667,-46.5333,'Brazil','BR','BRA','São Paulo','',1324781,1076730420),
('Juárez','Juarez',31.7386,-106.487,'Mexico','MX','MEX','Chihuahua','minor',1321004,1484840083),
('Saitama','Saitama',35.8617,139.645,'Japan','JP','JPN','Saitama','admin',1320571,1392017719),
('Montevideo','Montevideo',-34.8667,-56.1667,'Uruguay','UY','URY','Montevideo','primary',1319108,1858107000),
('Mbuji-Mayi','Mbuji-Mayi',-6.1209,23.5967,'Congo (Kinshasa)','CD','COD','Kasaï Oriental','admin',1295000,1180399586),
('Fuqing','Fuqing',25.7232,119.373,'China','CN','CHN','Fujian','minor',1316000,1156893569),
('Xintai','Xintai',35.91,117.78,'China','CN','CHN','Shandong','',1315942,1156761230),
('Doha','Doha',25.3,51.5333,'Qatar','QA','QAT','Ad Dawḩah','primary',1312947,1634459660),
('Hiroshima','Hiroshima',34.4,132.45,'Japan','JP','JPN','Hiroshima','admin',1306589,1392373695),
('Meerut','Meerut',28.99,77.7,'India','IN','IND','Uttar Pradesh','',1305429,1356390476),
('Yushu','Yushu',44.8249,126.545,'China','CN','CHN','Jilin','',1304436,1156326773),
('Rongcheng','Rongcheng',26.2312,104.097,'China','CN','CHN','Yunnan','',1302891,1156122888),
('Huazhou','Huazhou',21.654,110.629,'China','CN','CHN','Guangdong','',1302100,1156282637),
('Yangquan','Yangquan',37.8576,113.576,'China','CN','CHN','Shanxi','minor',1300000,1156157844),
('Haicheng','Haicheng',40.8523,122.747,'China','CN','CHN','Liaoning','minor',1293877,1156052713),
('Yingtan','Yingtan',28.2333,117,'China','CN','CHN','Jiangxi','',1288615,1156301061),
('Huaiyin','Huaiyin',33.58,119.03,'China','CN','CHN','Jiangsu','',1264000,1156662372),
('Wuzhong','Wuzhong',37.9874,106.192,'China','CN','CHN','Ningxia','minor',1284000,1156139322),
('Barranquilla','Barranquilla',10.9639,-74.7964,'Colombia','CO','COL','Atlántico','admin',1274250,1170179113),
('Jabalpur','Jabalpur',23.1667,79.9333,'India','IN','IND','Madhya Pradesh','',1267564,1356115460),
('Thāne','Thane',19.18,72.9633,'India','IN','IND','Mahārāshtra','',1261517,1356681152),
('Zhangye','Zhangye',38.9355,100.455,'China','CN','CHN','Gansu','minor',1270000,1156180353),
('Rucheng','Rucheng',32.3852,120.563,'China','CN','CHN','Jiangsu','minor',1267066,1156323529),
('Nizhniy Novgorod','Nizhniy Novgorod',56.3269,44.0075,'Russia','RU','RUS','Nizhegorodskaya Oblast’','admin',1264075,1643012126),
('Comayagüela','Comayaguela',14.0833,-87.2167,'Honduras','HN','HND','Francisco Morazán','',1250000,1340762485),
('Shaoyang','Shaoyang',32.9387,119.84,'China','CN','CHN','Jiangsu','minor',1253548,1156668366),
('Dhanbād','Dhanbad',23.7928,86.435,'India','IN','IND','Jharkhand','',1246000,1356103392),
('Yichun','Yichun',47.7235,128.889,'China','CN','CHN','Heilongjiang','minor',1250000,1156757274),
('Laiwu','Laiwu',36.1833,117.667,'China','CN','CHN','Shandong','',1248636,1156207332),
('Jingling','Jingling',30.6667,113.167,'China','CN','CHN','Hubei','',1247400,1156060544),
('Kazan','Kazan',55.7908,49.1144,'Russia','RU','RUS','Tatarstan','admin',1243500,1643101260),
('Dayan','Dayan',26.8808,100.221,'China','CN','CHN','Yunnan','',1244769,1156828380),
('Suwon','Suwon',37.2858,127.01,'Korea, South','KR','KOR','Gyeonggi','admin',1234300,1410679777),
('Jiangyin','Jiangyin',31.9087,120.265,'China','CN','CHN','Jiangsu','',1241045,1156033234),
('Yongcheng','Yongcheng',33.9317,116.446,'China','CN','CHN','Henan','',1240382,1156841802),
('Calgary','Calgary',51.05,-114.067,'Canada','CA','CAN','Alberta','',1239220,1124690423),
('Cần Thơ','Can Tho',10.0333,105.783,'Vietnam','VN','VNM','Cần Thơ','admin',1237300,1704783472),
('Abuja','Abuja',9.0556,7.4914,'Nigeria','NG','NGA','Federal Capital Territory','primary',1235880,1566342270),
('Yiwu','Yiwu',29.3081,120.07,'China','CN','CHN','Zhejiang','minor',1234015,1156078044),
('Mandalay','Mandalay',21.9769,96.0869,'Myanmar','MM','MMR','Mandalay','admin',1225546,1104468217),
('Beidao','Beidao',34.6,105.92,'China','CN','CHN','Gansu','minor',1225000,1156137209),
('Al Başrah','Al Basrah',30.4889,47.81,'Iraq','IQ','IRQ','Al Başrah','admin',1225793,1368714645),
('Shuangshui','Shuangshui',26.5944,104.833,'China','CN','CHN','Guizhou','',1221000,1156070389),
('Vila Velha','Vila Velha',3.2167,-51.2167,'Brazil','BR','BRA','Amapá','',1209091,1076575691),
('Allahābād','Allahabad',25.455,81.84,'India','IN','IND','Uttar Pradesh','',1201000,1356718332),
('Vārānasi','Varanasi',25.3189,83.0128,'India','IN','IND','Uttar Pradesh','',1198491,1356145782),
('Chelyabinsk','Chelyabinsk',55.15,61.4,'Russia','RU','RUS','Chelyabinskaya Oblast’','admin',1202371,1643224011),
('Mombasa','Mombasa',-4.05,39.6667,'Kenya','KE','KEN','Mombasa','admin',1200000,1404512373),
('Providence','Providence',41.823,-71.4187,'United States','US','USA','Rhode Island','admin',1203230,1840003289),
('Qom','Qom',34.6461,50.8789,'Iran','IR','IRN','Qom','admin',1201158,1364701633),
('Maiduguri','Maiduguri',11.8333,13.15,'Nigeria','NG','NGA','Borno','admin',1197497,1566540296),
('Maputo','Maputo',-25.9153,32.5764,'Mozambique','MZ','MOZ','Maputo','primary',1191613,1508074843),
('Rosario','Rosario',-32.9575,-60.6394,'Argentina','AR','ARG','Santa Fe','minor',1193605,1032770677),
('Benin City','Benin City',6.3176,5.6145,'Nigeria','NG','NGA','Edo','admin',1190000,1566080151),
('Xinyu','Xinyu',27.795,114.924,'China','CN','CHN','Jiangxi','minor',1186700,1156138735),
('Pikine','Pikine',14.75,-17.4,'Senegal','SN','SEN','Dakar','',1170791,1686165071),
('Ahvāz','Ahvaz',31.3203,48.6692,'Iran','IR','IRN','Khūzestān','admin',1184788,1364350188),
('Dublin','Dublin',53.3497,-6.2603,'Ireland','IE','IRL','Dublin','primary',1173179,1372595407),
('Jacksonville','Jacksonville',30.3322,-81.6749,'United States','US','USA','Florida','',1181496,1840015031),
('Medina','Medina',24.4667,39.6,'Saudi Arabia','SA','SAU','Al Madīnah al Munawwarah','admin',1180770,1682345785),
('Srīnagar','Srinagar',34.0911,74.8061,'India','IN','IND','Jammu and Kashmīr','admin',1180570,1356442950),
('Omsk','Omsk',54.9667,73.3833,'Russia','RU','RUS','Omskaya Oblast’','admin',1178391,1643360863),
('Cilacap','Cilacap',-7.7167,109.017,'Indonesia','ID','IDN','Jawa Tengah','minor',1174964,1360503809),
('Bandar Lampung','Bandar Lampung',-5.4294,105.262,'Indonesia','ID','IDN','Lampung','admin',1166761,1360243491),
('Samara','Samara',53.1833,50.1167,'Russia','RU','RUS','Samarskaya Oblast’','admin',1169719,1643205757),
('Guankou','Guankou',28.1417,113.625,'China','CN','CHN','Hunan','minor',1168056,1156249346),
('Ulsan','Ulsan',35.55,129.317,'Korea, South','KR','KOR','Ulsan','admin',1166033,1410134602),
('Dingzhou','Dingzhou',38.5158,114.984,'China','CN','CHN','Hebei','',1165182,1156656582),
('Campinas','Campinas',-22.9009,-47.0573,'Brazil','BR','BRA','São Paulo','',1164098,1076145766),
('Lianyuan','Lianyuan',27.6961,111.666,'China','CN','CHN','Hunan','minor',1162928,1156490109),
('Rongcheng','Rongcheng',29.8239,112.902,'China','CN','CHN','Hubei','minor',1162770,1156102432),
('Kaiyuan','Kaiyuan',36.0656,113.815,'China','CN','CHN','Henan','minor',1160000,1156441554),
('Nay Pyi Taw','Nay Pyi Taw',19.7475,96.115,'Myanmar','MM','MMR','Nay Pyi Taw','primary',1160242,1104838105),
('Dakar','Dakar',14.7319,-17.4572,'Senegal','SN','SEN','Dakar','primary',1146053,1686604760),
('Zhuji','Zhuji',29.7169,120.231,'China','CN','CHN','Zhejiang','minor',1157938,1156504227),
('Kigali','Kigali',-1.9536,30.0606,'Rwanda','RW','RWA','Kigali','primary',1156663,1646923541),
('Zapopan','Zapopan',20.7167,-103.4,'Mexico','MX','MEX','Jalisco','minor',1155790,1484198680),
('Leiyang','Leiyang',26.4179,112.846,'China','CN','CHN','Hunan','minor',1151554,1156057789),
('Santiago','Santiago',19.45,-70.7,'Dominican Republic','DO','DOM','Cibao Norte','admin',1142947,1214985348),
('Dadukou','Dadukou',26.5849,101.715,'China','CN','CHN','Sichuan','minor',1144000,1156901342),
('Xiantao','Xiantao',30.3833,113.4,'China','CN','CHN','Hubei','',1140100,1156216927),
('Amritsar','Amritsar',31.6167,74.85,'India','IN','IND','Punjab','',1132383,1356926507),
('Callao','Callao',-12.0611,-77.1333,'Peru','PE','PER','Callao','admin',1129854,1604422141),
('Alīgarh','Aligarh',27.88,78.08,'India','IN','IND','Uttar Pradesh','',1131160,1356076391),
('Yingchuan','Yingchuan',34.1511,113.473,'China','CN','CHN','Henan','minor',1131896,1156748426),
('Tegucigalpa','Tegucigalpa',14.0942,-87.2067,'Honduras','HN','HND','Francisco Morazán','primary',1126534,1340344059),
('Ciudad Nezahualcóyotl','Ciudad Nezahualcoyotl',19.41,-99.03,'Mexico','MX','MEX','México','',1109363,1484016661),
('Tripoli','Tripoli',32.8752,13.1875,'Libya','LY','LBY','Ţarābulus','primary',1126000,1434201852),
('Rostov','Rostov',47.2333,39.7167,'Russia','RU','RUS','Rostovskaya Oblast’','admin',1125299,1643013518),
('Nezahualcóyotl','Nezahualcoyotl',19.4,-98.9889,'Mexico','MX','MEX','México','minor',1110565,1484074285),
('Bhiwandi','Bhiwandi',19.3,73.0667,'India','IN','IND','Mahārāshtra','',1125898,1356763571),
('Zhoushan','Zhoushan',30.0162,122.099,'China','CN','CHN','Zhejiang','minor',1121261,1156200283),
('Tbilisi','Tbilisi',41.7225,44.7925,'Georgia','GE','GEO','Tbilisi','primary',1118035,1268203191),
('Ufa','Ufa',54.7333,55.9667,'Russia','RU','RUS','Bashkortostan','admin',1115560,1643722928),
('Fès','Fes',34.0433,-5.0033,'Morocco','MA','MAR','Fès-Meknès','admin',1112072,1504861997),
('Sevilla','Sevilla',37.39,-5.99,'Spain','ES','ESP','Andalusia','admin',1107000,1724991838),
('Mexicali','Mexicali',32.6633,-115.468,'Mexico','MX','MEX','Baja California','admin',1102342,1484788702),
('Biên Hòa','Bien Hoa',10.9277,106.868,'Vietnam','VN','VNM','Đồng Nai','admin',1104000,1704863046),
('Gwalior','Gwalior',26.215,78.1931,'India','IN','IND','Madhya Pradesh','',1101981,1356363967),
('Ankang','Ankang',32.6877,109.023,'China','CN','CHN','Shaanxi','',1100000,1156255711),
('Ikare','Ikare',7.5304,5.76,'Nigeria','NG','NGA','Ondo','minor',1099931,1566683694),
('Huambo','Huambo',-12.7667,15.7333,'Angola','AO','AGO','Huambo','admin',1100000,1024079828),
('Hegang','Hegang',47.3139,130.277,'China','CN','CHN','Heilongjiang','minor',1100000,1156541759),
('Salt Lake City','Salt Lake City',40.7777,-111.931,'United States','US','USA','Utah','admin',1098526,1840021383),
('Bhilai','Bhilai',21.2167,81.4333,'India','IN','IND','Chhattīsgarh','',1097000,1356071083),
('Yuyao','Yuyao',30.0372,121.155,'China','CN','CHN','Zhejiang','',1095000,1156221984),
('N’Djamena','N\'Djamena',12.11,15.05,'Chad','TD','TCD','Ville de N’Djaména','primary',1092066,1148708596),
('Hanchuan','Hanchuan',30.652,113.827,'China','CN','CHN','Hubei','',1092700,1156149248),
('Gongzhuling','Gongzhuling',43.5036,124.809,'China','CN','CHN','Jilin','',1092692,1156696810),
('Irbid','Irbid',32.5556,35.85,'Jordan','JO','JOR','Irbid','admin',1088100,1400221568),
('Hāora','Haora',22.59,88.31,'India','IN','IND','West Bengal','',1077075,1356986516),
('Cologne','Cologne',50.9422,6.9578,'Germany','DE','DEU','North Rhine-Westphalia','',1085664,1276015998),
('Krasnoyarsk','Krasnoyarsk',56.0167,92.8667,'Russia','RU','RUS','Krasnoyarskiy Kray','admin',1083865,1643544975),
('Yicheng','Yicheng',31.3697,119.824,'China','CN','CHN','Jiangsu','minor',1082929,1156292419),
('São Gonçalo','Sao Goncalo',-22.8269,-43.0539,'Brazil','BR','BRA','Rio de Janeiro','',1077687,1076485783),
('Nashville','Nashville',36.1715,-86.7843,'United States','US','USA','Tennessee','admin',1081903,1840036155),
('Yerevan','Yerevan',40.1814,44.5144,'Armenia','AM','ARG','Yerevan','primary',1075800,1051074169),
('Rānchi','Ranchi',23.3556,85.3347,'India','IN','IND','Jharkhand','admin',1073440,1356110588),
('Nur-Sultan','Nur-Sultan',51.1333,71.4333,'Kazakhstan','KZ','KAZ','Astana','primary',1078362,1398516045),
('Nouakchott','Nouakchott',18.0858,-15.9785,'Mauritania','MR','MRT','','primary',1077169,1478414984),
('Vereeniging','Vereeniging',-26.6736,27.9319,'South Africa','ZA','ZAF','Gauteng','',1074000,1710271883),
('Richmond','Richmond',37.5295,-77.4756,'United States','US','USA','Virginia','admin',1075798,1840001698),
('São Luís','Sao Luis',-2.53,-44.3028,'Brazil','BR','BRA','Maranhão','admin',1073893,1076819308),
('San Pedro Sula','San Pedro Sula',15.5,-88.0333,'Honduras','HN','HND','Cortés','admin',1073824,1340568412),
('Taixing','Taixing',32.1724,120.014,'China','CN','CHN','Jiangsu','minor',1073921,1156331200),
('Memphis','Memphis',35.1046,-89.9773,'United States','US','USA','Tennessee','',1066967,1840015457),
('Goyang','Goyang',37.6564,126.835,'Korea, South','KR','KOR','Gyeonggi','minor',1061929,1410511255),
('Bezwāda','Bezwada',16.5167,80.6167,'India','IN','IND','Andhra Pradesh','',1048240,1356807575),
('Edmonton','Edmonton',53.5344,-113.49,'Canada','CA','CAN','Alberta','',1062643,1124290735),
('Mizhou','Mizhou',35.99,119.38,'China','CN','CHN','Shandong','minor',1060000,1156935002),
('Tunis','Tunis',36.8008,10.18,'Tunisia','TN','TUN','Tunis','primary',1056247,1788742103),
('Xishan','Xishan',27.6609,113.495,'China','CN','CHN','Hunan','minor',1060000,1156155575),
('Ezhou','Ezhou',30.3972,114.884,'China','CN','CHN','Hubei','minor',1059700,1156414637),
('Barquisimeto','Barquisimeto',10.0678,-69.3467,'Venezuela','VE','VEN','Lara','admin',1059092,1862860739),
('Sendai','Sendai',38.2683,140.869,'Japan','JP','JPN','Miyagi','admin',1058070,1392457903),
('Voronezh','Voronezh',51.6717,39.2106,'Russia','RU','RUS','Voronezhskaya Oblast’','admin',1047549,1643811064),
('Perm','Perm',58.0139,56.2489,'Russia','RU','RUS','Permskiy Kray','admin',1048005,1643294442),
('Changwon','Changwon',35.2281,128.681,'Korea, South','KR','KOR','Gyeongnam','admin',1046054,1410592618),
('Zhongwei','Zhongwei',37.5139,105.188,'China','CN','CHN','Ningxia','minor',1046000,1156956616),
('Shouguang','Shouguang',36.8833,118.733,'China','CN','CHN','Shandong','',1039205,1156787809),
('Bogor','Bogor',-6.6,106.8,'Indonesia','ID','IDN','Jawa Barat','',1030720,1360771925),
('Raleigh','Raleigh',35.8325,-78.6435,'United States','US','USA','North Carolina','admin',1038738,1840014497),
('Cartagena','Cartagena',10.4236,-75.5253,'Colombia','CO','COL','Bolívar','admin',1036412,1170886102),
('Chandīgarh','Chandigarh',30.7353,76.7911,'India','IN','IND','Chandīgarh','admin',1026459,1356739179),
('Bishkek','Bishkek',42.8667,74.5667,'Kyrgyzstan','KG','KGZ','Bishkek','primary',1027200,1417191971),
('Matola','Matola',-25.9667,32.4667,'Mozambique','MZ','MOZ','Maputo','',1032197,1508768577),
('Ogbomoso','Ogbomoso',8.1333,4.25,'Nigeria','NG','NGA','Oyo','minor',1032000,1566373448),
('Ashgabat','Ashgabat',37.95,58.3833,'Turkmenistan','TM','TKM','Ahal','primary',1031992,1795049992),
('Maceió','Maceio',-9.6658,-35.735,'Brazil','BR','BRA','Alagoas','admin',1029129,1076440479),
('Niamey','Niamey',13.5086,2.1111,'Niger','NE','NER','Niamey','primary',1026848,1562932886),
('Managua','Managua',12.15,-86.2667,'Nicaragua','NI','NIC','Managua','primary',1028808,1558296252),
('Patam','Patam',1.0678,104.017,'Indonesia','ID','IDN','Kepulauan Riau','',1029808,1360893799),
('Tekirdağ','Tekirdag',40.9833,27.5167,'Turkey','TR','TUR','Tekirdağ','admin',1029927,1792519395),
('Shubrā al Khaymah','Shubra al Khaymah',30.1286,31.2422,'Egypt','EG','EGY','Al Qalyūbīyah','',1025569,1818909612),
('Linhai','Linhai',28.8523,121.141,'China','CN','CHN','Zhejiang','',1028813,1156451663),
('Monrovia','Monrovia',6.3106,-10.8047,'Liberia','LR','LBR','Montserrado','primary',1021762,1430477826),
('Wafangdian','Wafangdian',39.6271,121.997,'China','CN','CHN','Liaoning','',1024876,1156476417),
('Zhongxiang','Zhongxiang',31.169,112.585,'China','CN','CHN','Hubei','',1022514,1156631720),
('Odesa','Odesa',46.4775,30.7326,'Ukraine','UA','UKR','Odes’ka Oblast’','admin',1017699,1804178102),
('Shymkent','Shymkent',42.3,69.6,'Kazakhstan','KZ','KAZ','Ongtüstik Qazaqstan','admin',1018974,1398791401),
('New Orleans','New Orleans',30.0687,-89.9288,'United States','US','USA','Louisiana','',1020886,1840001839),
('Thủ Đức','Thu Duc',10.8199,106.791,'Vietnam','VN','VNM','Hồ Chí Minh','minor',1013795,1704361621),
('Volgograd','Volgograd',48.7086,44.5147,'Russia','RU','RUS','Volgogradskaya Oblast’','admin',1015586,1643577201),
('Port-au-Prince','Port-au-Prince',18.5425,-72.3386,'Haiti','HT','HTI','Ouest','primary',987310,1332401940),
('Islamabad','Islamabad',33.6989,73.0369,'Pakistan','PK','PAK','Islāmābād','primary',1014825,1586306717),
('Mysore','Mysore',12.3086,76.6531,'India','IN','IND','Karnātaka','',1014227,1356779323),
('Xinyi','Xinyi',22.3559,110.937,'China','CN','CHN','Guangdong','',1013900,1156936644),
('Kathmandu','Kathmandu',27.7167,85.3667,'Nepal','NP','NPL','Bāgmatī','primary',975453,1524589448),
('Raipur','Raipur',21.2379,81.6337,'India','IN','IND','Chhattīsgarh','admin',1010087,1356374983),
('Nice','Nice',43.7034,7.2663,'France','FR','FRA','Provence-Alpes-Côte d’Azur','minor',1006402,1250774553),
('Arequipa','Arequipa',-16.3988,-71.5369,'Peru','PE','PER','Arequipa','admin',1008290,1604723954),
('Port Harcourt','Port Harcourt',4.75,7,'Nigeria','NG','NGA','Rivers','admin',1005904,1566070649),
('Louisville','Louisville',38.1663,-85.6485,'United States','US','USA','Kentucky','',1005654,1840030815),
('Zaoyang','Zaoyang',32.1287,112.758,'China','CN','CHN','Hubei','',1004741,1156197076),
('Shuizhai','Shuizhai',33.4433,114.899,'China','CN','CHN','Henan','',1003698,1156462734),
('Dnipro','Dnipro',48.45,34.9833,'Ukraine','UA','UKR','Dnipropetrovs’ka Oblast’','admin',1002111,1804152933),
('Kota','Kota',25.18,75.83,'India','IN','IND','Rājasthān','',1001694,1356820310),
('Quetta','Quetta',30.192,67.007,'Pakistan','PK','PAK','Balochistān','admin',1001205,1586556108),
('Abu Dhabi','Abu Dhabi',24.4781,54.3686,'United Arab Emirates','AE','ARE','Abū Z̧aby','primary',1000000,1784176710),
('Stockholm','Stockholm',59.3294,18.0686,'Sweden','SE','SWE','Stockholm','primary',972647,1752425602),
('Ottawa','Ottawa',45.4247,-75.695,'Canada','CA','CAN','Ontario','',989567,1124399363),
('Asmara','Asmara',15.3333,38.9167,'Eritrea','ER','ERI','Ma’ākel','primary',963000,1232791236),
('Freetown','Freetown',8.4833,-13.2331,'Sierra Leone','SL','SLE','Western Area','primary',951000,1694085071),
('Jerusalem','Jerusalem',31.7833,35.2167,'Israel','IL','ISR','Southern','primary',919438,1376261644),
('Bangui','Bangui',4.3732,18.5628,'Central African Republic','CF','CAF','Bangui','primary',889231,1140080881),
('Panama City','Panama City',9,-79.5,'Panama','PA','PAN','Panamá','primary',880691,1591672475),
('Amsterdam','Amsterdam',52.3667,4.8833,'Netherlands','NL','NLD','Noord-Holland','primary',862965,1528355309),
('Lomé','Lome',6.1319,1.2228,'Togo','TG','TGO','Maritime','primary',837437,1768409132),
('Libreville','Libreville',0.3901,9.4544,'Gabon','GA','GAB','Estuaire','primary',797003,1266952885),
('Zagreb','Zagreb',45.8,15.95,'Croatia','HR','HRV','Zagreb, Grad','primary',790017,1191233290),
('Dushanbe','Dushanbe',38.5731,68.7864,'Tajikistan','TJ','TJK','Dushanbe','primary',778500,1762930616),
('Lilongwe','Lilongwe',-13.9833,33.7833,'Malawi','MW','MWI','Lilongwe','primary',781538,1454688499),
('Cotonou','Cotonou',6.4,2.52,'Benin','BJ','BEN','Littoral','primary',762000,1204955174),
('Vientiane','Vientiane',17.9667,102.6,'Laos','LA','LAO','Viangchan','primary',760000,1418732714),
('Colombo','Colombo',6.9167,79.8333,'Sri Lanka','LK','LKA','Western','primary',752993,1144251314),
('Pretoria','Pretoria',-25.7464,28.1881,'South Africa','ZA','ZAF','Gauteng','primary',741651,1710176249),
('Winnipeg','Winnipeg',49.8844,-97.1464,'Canada','CA','CAN','Manitoba','',705244,1124224963),
('Quebec City','Quebec City',46.8139,-71.2081,'Canada','CA','CAN','Quebec','',705103,1124823933),
('Oslo','Oslo',59.9111,10.7528,'Norway','NO','NOR','Oslo','primary',693494,1578324706),
('Athens','Athens',37.9842,23.7281,'Greece','GR','GRC','Attikí','primary',664046,1300715560),
('Bujumbura','Bujumbura',-3.3825,29.3611,'Burundi','BI','BDI','Bujumbura Mairie','primary',658859,1108101689),
('Helsinki','Helsinki',60.1756,24.9342,'Finland','FI','FIN','Uusimaa','primary',642045,1246177997),
('Skopje','Skopje',41.9833,21.4333,'Macedonia','MK','MKD','Skopje','primary',640000,1807600615),
('Chisinau','Chisinau',47.0228,28.8353,'Moldova','MD','MDA','Chişinău','primary',639000,1498011437),
('Riga','Riga',56.9475,24.1069,'Latvia','LV','LVA','Rīga','primary',614618,1428586192),
('Copenhagen','Copenhagen',55.6761,12.5689,'Denmark','DK','DNK','Hovedstaden','primary',602481,1208763942),
('Kingston','Kingston',17.9714,-76.7931,'Jamaica','JM','JAM','Kingston','primary',580000,1388709177),
('Rabat','Rabat',34.0253,-6.8361,'Morocco','MA','MAR','Rabat-Salé-Kénitra','primary',572717,1504023252),
('Vilnius','Vilnius',54.6833,25.2833,'Lithuania','LT','LTU','Vilniaus Miestas','primary',574147,1440887149),
('San Salvador','San Salvador',13.6989,-89.1914,'El Salvador','SV','SLV','San Salvador','primary',567698,1222647454),
('Djibouti','Djibouti',11.595,43.1481,'Djibouti','DJ','DJI','Djibouti','primary',562000,1262028958),
('Lisbon','Lisbon',38.7452,-9.1604,'Portugal','PT','PRT','Lisboa','primary',506654,1620619017),
('Kitchener','Kitchener',43.4186,-80.4728,'Canada','CA','CAN','Ontario','',470015,1124158530),
('Tallinn','Tallinn',59.4372,24.745,'Estonia','EE','EST','Harjumaa','primary',438341,1233260021),
('Cape Town','Cape Town',-33.925,18.425,'South Africa','ZA','ZAF','Western Cape','primary',433688,1710680650),
('Bratislava','Bratislava',48.1447,17.1128,'Slovakia','SK','SVK','Bratislavský','primary',429564,1703195001),
('Tirana','Tirana',41.33,19.82,'Albania','AL','ALB','Tiranë','primary',418495,1008162156),
('Canberra','Canberra',-35.2931,149.127,'Australia','AU','AUS','Australian Capital Territory','primary',426704,1036142029),
('Wellington','Wellington',-41.2889,174.777,'New Zealand','NZ','NZL','Wellington','primary',418500,1554772152),
('Beirut','Beirut',33.8869,35.5131,'Lebanon','LB','LBN','Beyrouth','primary',361366,1422847713),
('Dodoma','Dodoma',-6.1835,35.746,'Tanzania','TZ','TZA','Dodoma','primary',410956,1834288497),
('Halifax','Halifax',44.6475,-63.5906,'Canada','CA','CAN','Nova Scotia','',403131,1124130981),
('Bissau','Bissau',11.8592,-15.5956,'Guinea-Bissau','GW','GNB','Bissau','primary',395954,1624168850),
('Juba','Juba',4.85,31.6,'South Sudan','SS','SSD','Central Equatoria','primary',372410,1728444337),
('Port Moresby','Port Moresby',-9.4789,147.149,'Papua New Guinea','PG','PNG','National Capital','primary',364125,1598685395),
('Yamoussoukro','Yamoussoukro',6.8161,-5.2742,'Côte D’Ivoire','CI','CIV','Yamoussoukro','primary',355573,1384683557),
('Victoria','Victoria',48.4283,-123.365,'Canada','CA','CAN','British Columbia','',335696,1124147219),
('Maseru','Maseru',-29.31,27.48,'Lesotho','LS','LSO','Maseru','primary',330790,1426977668),
('Nicosia','Nicosia',35.1725,33.365,'Cyprus','CY','CYP','Lefkosía','primary',330000,1196944155),
('Windhoek','Windhoek',-22.57,17.0836,'Namibia','NA','NAM','Khomas','primary',322500,1516802003),
('Porto-Novo','Porto-Novo',6.4833,2.6167,'Benin','BJ','BEN','Ouémé','primary',300000,1204172060),
('Sucre','Sucre',-19.0431,-65.2592,'Bolivia','BO','BOL','Chuquisaca','primary',300000,1068823873),
('San José','San Jose',9.9333,-84.0833,'Costa Rica','CR','CRI','San José','primary',288054,1188749877),
('Ljubljana','Ljubljana',46.05,14.5167,'Slovenia','SI','SVN','Ljubljana','primary',286745,1705917455),
('Sarajevo','Sarajevo',43.8667,18.4167,'Bosnia And Herzegovina','BA','BIH','Bosnia and Herzegovina, Federation of','primary',275524,1070966777),
('Nassau','Nassau',25.0667,-77.3333,'Bahamas, The','BS','BHS','','primary',274400,1044318561),
('Bloemfontein','Bloemfontein',-29.1,26.2167,'South Africa','ZA','ZAF','Free State','primary',256185,1710495933),
('Fort-de-France','Fort-de-France',14.6104,-61.08,'Martinique','MQ','MTQ','','primary',253995,1474969110),
('Gaborone','Gaborone',-24.6569,25.9086,'Botswana','BW','BWA','Gaborone','primary',231626,1072756768),
('Paramaribo','Paramaribo',5.8667,-55.1667,'Suriname','SR','SUR','Paramaribo','primary',223757,1740518660),
('Dili','Dili',-8.5586,125.574,'Timor-Leste','TL','TLS','Díli','primary',222323,1626308942),
('Pristina','Pristina',42.6667,21.1667,'Kosovo','XK','XKS','Prishtinë','primary',204725,1901760068),
('Georgetown','Georgetown',6.7833,-58.1667,'Guyana','GY','GUY','Demerara-Mahaica','primary',200500,1328160906),
('Malabo','Malabo',3.7521,8.7737,'Equatorial Guinea','GQ','GNQ','Bioko Norte','primary',187302,1226861333),
('Gibraltar','Gibraltar',36.1324,-5.3781,'Gibraltar','GI','GIB','','primary',187083,1292385245),
('Saint-Denis','Saint-Denis',-20.8789,55.4481,'Reunion','RE','REU','','primary',190047,1638024662),
('Male','Male',4.175,73.5083,'Maldives','MV','MDV','Maale','primary',133019,1462441685),
('Podgorica','Podgorica',42.4397,19.2661,'Montenegro','ME','MNE','Podgorica','primary',174515,1499454516),
('Manama','Manama',26.225,50.5775,'Bahrain','BH','BHR','Al ‘Āşimah','primary',157474,1048989486),
('Port Louis','Port Louis',-20.1667,57.5,'Mauritius','MU','MUS','Port Louis','primary',149194,1480131261),
('Willemstad','Willemstad',12.108,-68.935,'Curaçao','CW','CUW','','primary',150000,1531000000),
('New Delhi','New Delhi',28.7,77.2,'India','IN','IND','Delhi','primary',142004,1356215164),
('Bern','Bern',46.948,7.4474,'Switzerland','CH','CHE','Bern','primary',133798,1756374318),
('Papeete','Papeete',-17.5334,-149.567,'French Polynesia','PF','PYF','Îles du Vent','primary',131695,1258907380),
('Reykjavík','Reykjavik',64.1475,-21.935,'Iceland','IS','ISL','','primary',128793,1352327190),
('Praia','Praia',14.9177,-23.5092,'Cabo Verde','CV','CPV','Praia','primary',127832,1132398770),
('Luxembourg','Luxembourg',49.6106,6.1328,'Luxembourg','LU','LUX','Luxembourg','primary',124509,1442262731),
('Sri Jayewardenepura Kotte','Sri Jayewardenepura Kotte',6.9,79.9164,'Sri Lanka','LK','LKA','Western','primary',115826,1144239330),
('Bridgetown','Bridgetown',13.0975,-59.6167,'Barbados','BB','BRB','Saint Michael','primary',110000,1052274244),
('Moroni','Moroni',-11.7036,43.2536,'Comoros','KM','COM','Grande Comore','primary',111329,1174793581),
('Thimphu','Thimphu',27.4833,89.6333,'Bhutan','BT','BTN','Thimphu','primary',104000,1064010361),
('Mbabane','Mbabane',-26.3208,31.1617,'Swaziland','SZ','SWZ','Hhohho','primary',94874,1748811945),
('Nouméa','Noumea',-22.2625,166.444,'New Caledonia','NC','NCL','Province Sud','primary',93060,1540958092),
('Honiara','Honiara',-9.4333,159.95,'Solomon Islands','SB','SLB','Honiara','primary',84520,1090737486),
('Suva','Suva',-18.1333,178.433,'Fiji','FJ','FJI','Rewa','primary',88271,1242615095),
('Castries','Castries',14.0167,-60.9833,'Saint Lucia','LC','LCA','Castries','primary',70000,1662922505),
('Cayenne','Cayenne',4.933,-52.33,'French Guiana','GF','GUF','','primary',61550,1254304969),
('São Tomé','Sao Tome',0.3333,6.7333,'Sao Tome And Principe','ST','STP','São Tomé','primary',56166,1678301324),
('Port-Vila','Port-Vila',-17.7333,168.317,'Vanuatu','VU','VUT','Shefa','primary',51437,1548805075),
('Hamilton','Hamilton',32.2942,-64.7839,'Bermuda','BM','BMU','Hamilton','primary',52320,1060000000),
('Bandar Seri Begawan','Bandar Seri Begawan',4.9167,114.917,'Brunei','BN','BRN','Brunei and Muara','primary',50000,1096465895),
('Monaco','Monaco',43.7396,7.4069,'Monaco','MC','MCO','','primary',36371,1492854256),
('Gitega','Gitega',-3.4264,29.9306,'Burundi','BI','BDI','Gitega','primary',41944,1108778000),
('Port of Spain','Port of Spain',10.6667,-61.5167,'Trinidad And Tobago','TT','TTO','Port of Spain','primary',37074,1780670676),
('Apia','Apia',-13.8333,-171.833,'Samoa','WS','WSM','Tuamasaga','primary',37708,1882489296),
('Douglas','Douglas',54.15,-4.4819,'Isle Of Man','IM','IMN','','primary',35854,1833688345),
('Oranjestad','Oranjestad',12.5186,-70.0358,'Aruba','AW','ABW','','primary',34980,1533513057),
('Saint Helier','Saint Helier',49.1833,-2.1167,'Jersey','JE','JEY','','primary',33522,1832490253),
('Vaduz','Vaduz',47.1415,9.5215,'Liechtenstein','LI','LIE','Vaduz','primary',36281,1438317747),
('Banjul','Banjul',13.4531,-16.5775,'Gambia, The','GM','GMB','Banjul','primary',31356,1270723713),
('Mamoudzou','Mamoudzou',-12.7871,45.275,'Mayotte','YT','MYT','','primary',32057,1175099654),
('Majuro','Majuro',7.0918,171.38,'Marshall Islands','MH','MHL','Majuro','primary',30000,1584000000),
('Tarawa','Tarawa',1.3382,173.018,'Kiribati','KI','KIR','','primary',28802,1296152641),
('George Town','George Town',19.2866,-81.3744,'Cayman Islands','KY','CYM','','primary',27704,1136159124),
('Victoria','Victoria',-4.6236,55.4544,'Seychelles','SC','SYC','English River','primary',26450,1690193579),
('Kingstown','Kingstown',13.1667,-61.2333,'Saint Vincent And The Grenadines','VC','VCT','Saint George','primary',25000,1670376659),
('Saint John’s','Saint John\'s',17.1211,-61.8447,'Antigua And Barbuda','AG','ATG','Saint John','primary',21926,1028912067),
('Nuku‘alofa','Nuku`alofa',-21.1347,-175.208,'Tonga','TO','TON','Tongatapu','primary',23221,1776737461),
('Andorra la Vella','Andorra la Vella',42.5,1.5,'Andorra','AD','AND','Andorra la Vella','primary',22151,1020828846),
('Nuuk','Nuuk',64.175,-51.7333,'Greenland','GL','GRL','Sermersooq','primary',18326,1304028354),
('Belmopan','Belmopan',17.25,-88.7675,'Belize','BZ','BLZ','Cayo','primary',17222,1084586375),
('Roseau','Roseau',15.3,-61.3833,'Dominica','DM','DMA','Saint George','primary',16582,1212060440),
('Basseterre','Basseterre',17.2983,-62.7342,'Saint Kitts And Nevis','KN','KNA','Saint George Basseterre','primary',13220,1659198919),
('Tórshavn','Torshavn',62,-6.7833,'Faroe Islands','FO','FRO','','primary',13326,1234904517),
('Pago Pago','Pago Pago',-14.274,-170.705,'American Samoa','AS','ASM','','primary',12576,1016976740),
('Valletta','Valletta',35.8978,14.5125,'Malta','MT','MLT','Valletta','primary',6444,1470574399);
/*!40000 ALTER TABLE `cities` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2022-10-28 10:19:26
