<?php
/*
 * jQuery File Upload Plugin PHP Example
 * https://github.com/blueimp/jQuery-File-Upload
 *
 * Copyright 2010, Sebastian Tschan
 * https://blueimp.net
 *
 * Licensed under the MIT license:
 * https://opensource.org/licenses/MIT
 */

error_reporting(E_ALL | E_STRICT);
require('UploadHandler.php');

// MH
require_once(dirname(__FILE__)."/../../../utils/log.php");
require_once(dirname(__FILE__)."/../../../utils/utils.php"); 
require_once(dirname(__FILE__)."/../../../model/errors.php"); 

try{
	set_fatal_off();  // MH
	$upload_handler = new UploadHandler();
}catch(Exception $e){ // MH
	log\error("upload error; POST dump: ", array_to_str($_POST), dump_stack() );
	register_error("upload error : ".$e->getMessage(), "upload", "upload", 4);
	echo json_encode($e->getMessage());
}

