var lang_tr = {};

function lp(name){ 
	if(!name) return "";
	var uc =  name.charAt(0)==name.charAt(0).toUpperCase(); name = name.toLowerCase();  // stuff to capitalize first letter: pass 'name' staring with 1st capital to have 1 capital in result
	var res = (name in lang_tr)? lang_tr[name] : name.replace(/_/g," "); 
	return uc? res.charAt(0).toUpperCase() + res.slice(1) : res;
}
// input: parametrized string like: 'bla $name$ ... $1$ .. $name2$ ... $2$ ...';  if a param is an integer - it's replaced with <param>th argument; that is func is to be called like: lpp("bla ...", par1, par2...)
// params may be even in translation; eg: found_files = 'found $1 files'; called like lpp("$found_files$", 5), translated like 'found 5 files'.
function lpp(str){
	while( true ){
		var reg = /\$(\w+)\$/g; // NOTE: TODO: if match is out of cycle - the second exec not works!
		var match = reg.exec(str);
		if(match){
			var val = match[1];
			str = str.replace("$" + val + "$", lp(val) );
		}else{ // this executed when all $xxx$ translated
			var reg1 = /\$(\d)/g; // for params: $1 ...
			var match1 = reg1.exec(str);
			if(match1){
				var val1 = match1[1];
				str = str.replace("$" + val1, arguments[val1]);
			}else
				break;
		}
	}
	return str;
}
function lang_change(t,e){
	var t = $(e.target);
	var code = t.data("lang");
	$.ajax({
		type: "POST",
		url: "contr/main.php",
		data: {"action": "lang_change", "lang": code},
		success: function(res){	
			window.location.reload();
		}

	})
}
function lang_get(){
	var lang_curr = call_php_sync("contr/main.php", {'action': 'lang_get'}); 
	return lang_curr.resp_text;
}
function lang_get_db(){
	var lang_curr = call_php_sync("contr/main.php", {'action': 'lang_get_db'}); 
	return lang_curr.resp_text;
}

function lang_create_menu(menu_class, handler=lang_change){
	var lm = create_popup_div();
	init_popup(lm, menu_class, null, true);
	var langs = call_php_sync("contr/main.php", {'action': 'lang_list'}); 
	var langs = JSON.parse(langs.resp_text);
	for(var i=0; i<langs.length; i++){
		var code = langs[i].code;
		add_popup_item( lm, "<img data-lang='"+code+"' src='" + langs[i].img + "' title='" + langs[i].name + "'>", handler);
	}
	return lm;
}

$(document).ready( function(){
	$.ajax({
		async: false,
		type: "POST",
		url: "contr/main.php",
		data: {"action": "lang_read"},
		success: function(res){	
			lang_tr = JSON.parse(res);
		}
	})
});

