/* 
	author: Alex
	21.09.21
	stuff imported from tt to manage a table

	workflow:
	init search: once on page create (oncreate); brief & full search panels

	show request: oncreate and onreq (user makes some search or changes order, also maybe on shown rows change)
	here need remove header/table/pager and re-add them

	show page: on paging; remove header/table and re-add

	TODO: new: on page size change (=onreq?)

	uses: 
		ff
		waitscreen
*/

class Tablo{
	table = ""; // actual table name
	alias = ""; // what is used to create eg class names; also contr may use it to identify search_fields/list_fields (which are same for several views)
	mainform = null;
	mainsel = "";
	// FIORD copied from TT
	//--------------------------------------------------------- SUBSECT FIORD ---------------------------------------------  
	rec_order; // TODO: check if works if ndef
	ro_extract(header){ // used to find out (possible new) order field; this singled out to be used by others, TODO: maybe move to utils
		header = header.closest(".fh_header");
		var field_name = $(header).data("fhid");
		var new_dir = $(header).hasClass("mc_asc")? "desc" : "asc" ; // TODO: more correctly is to find dir so: if new_field==old_field => !old_order; else => asc (=def)
		return {"field" : field_name, "order" : new_dir};
	}
	ro_show_order(panel, tname, order){ // called once after table is shown, adds the corresp class to order-field (to show it)
		// $(".th-tt_detail-" + files_order.field).data("order", files_order.order); // also may use '#tt_thumbs_form .fh-header th[data-fhid]=<field>' (not checked) ; TODO: not works.. data attr change (run-time) - css not works
		if(order)
			panel.find(".th-" + tname + "-" + order.field).addClass("mc_" + order.order);
	}
	ro_to_str(order){ return order? order.field + " " + order.order : ""; }
	ro_set(f,o){ this.rec_order = {"field" : f, "order" : o}; }

	// DEF TABCOL  setting visible ws columns
	all_columns;
	tabcol;
	columns_cookie; // cookie name (which stores shown cols)
	tabcol_cb(name, state, inst){
		setCookie(inst.columns_cookie, inst.tabcol.visible_columns.join("+"), 1000);
		inst.clear();
		inst.show();
	}

	// CALLBACKS
	sel_rec = null; // may set action to be done on rec sel
	edit_rec = null; // may set action to be done on rec dbl-click 
	on_show = null; // to call on render records
	//
	params = null;
	cond = ""; // additional cond used for each show and added to filter ; used eg to show stuff only of some campaign ; string, eg "camp_id=3"
	set_cond(cond){this.cond=cond;}
	page_size = 30; // PAGER
	pager_id; // PAGER
	clear_pager(){	this.mainform.find("#"+this.pager_id).remove(); } // PAGER

	// LBSP / SEARCH INIT
	find_files_panel_click(panel){
		if(ff_empty( panel) ){
			show_alert(lp("no_filter_cond"));
			return false;
		}
		this.params = ff_params(panel);
		this.clear();
		this.show();
	}
	find_files_click(){	var t = this; t.find_files_panel_click( t.searchpanel.find(".tc_search_form") ); t.hide_search_panel(); }
	find_files_lbsp_click(){ var t = this; t.find_files_panel_click( t.mainform.find(".lbsp_form") );  }
	show_search_panel(){
		this.searchpanel.css({'top': ( this.mainform.offset().top + 'px') }); 
		this.searchpanel.css({'left': ( this.mainform.offset().left + 'px') }); 
		this.searchpanel.removeClass("hidden");
	}
	hide_search_panel(){
		this.searchpanel.addClass("hidden");
	}
	get_active_rec(){ return $(this.mainsel).find(".active.tr-" + this.alias); }
	// CB_SEL_REC - get selected recs
	get_selection(){ return $(this.mainsel).find(".selected.tr-" + this.alias); }
	// returns selection if sms selected, else - active rec
	get_target_recs(){ 
		var sel = this.get_selection();
		return sel.length? sel : this.get_active_rec();
	}
	find_rec(id){ return $(this.mainsel).find(".tr-"+this.alias+"[data-id='" + id + "']"); }
	// get field of given rec with given name
	get_field(rec, fname){ return rec.find(".td-"+this.alias+"-"+fname); } // TODO: use it

	cancel_search(){
		var t = this;
		if(t.xhr && t.xhr.readyState!=4)
			t.xhr.abort(); // TODO: at the moment it may be empty
		ff_clear( t.searchform );
		t.mainform.find(".lbsp_input").val("");
		t.params = null;
		t.clear(); // NEXT
		t.show();
	}


	search_init(fields){
		var t = this;
		// LBSP
		ff_init(t.mainform.find(".lbsp_form"), function(){ t.find_files_lbsp_click(); } , false); // false means do not search on select/date change 
		t.mainform.find(".lbsp_search_btn").click( function(){ t.find_files_lbsp_click(); } );
		t.mainform.find(   ".lbsp_cancel_btn"     ).click( function(){t.cancel_search()} );
		t.searchpanel.find(".tc_search_cancel_btn").click( function(){t.cancel_search()} );  // TODO: same button does two different things - clears form and stops request;
		t.mainform.find(".lbsp_expand").click( function(){ t.show_search_panel(); } );
		// SEARCH
		t.searchform.prepend(fields);
		ff_init(t.searchform, function(){ t.find_files_click(); }, false); // false means do not search on select/date change 
		t.searchpanel.find('.tc_search_close_btn').on('click', function(){ t.hide_search_panel(); } ); // note: wrap in func to avoid pass event obj as param 
		t.searchpanel.find('.tc_search_clear_btn').on('click',function(){  
			ff_clear( t.searchform );
		})
		t.searchpanel.find('.tc_search_btn').on('click', function(){ t.find_files_click(); } );
	}
	constructor(
			mainsel, // now yet have to pass selector, not obj, while some funcs, like make_clickable, cl_add_class... require selector
			searchpanel, // is supposed to contain .tc_search_form
			table, ac, search_fields, sel_rec=null, edit_rec=null, alias=""){
		var t = this;
		this.table = table; // table name
		this.alias = alias==""? table : alias; // 
		this.mainsel = mainsel;
		if(searchpanel){
			this.searchpanel = searchpanel;
			this.searchform = searchpanel.find(".tc_search_form");
		}
		this.mainform = $(this.mainsel); // main form
		this.curr_rec_id = 0;
		// TABCOL
		this.all_columns = Object.keys(ac);
		var visible_columns = [];
		for(var i=0;i<this.all_columns.length;i++) if( ac[ this.all_columns[i] ] != "#" ) visible_columns.push( this.all_columns[i] ) ;
		this.columns_cookie = "visible_columns" + this.alias; // the name of the cookie to save user cols; it's individual for each table; 
		var vcc = getCookie(this.columns_cookie);
		if(vcc)
			visible_columns = vcc.split("+"); // DEF TABCOL_WS_COOKIE saving cols in cookie
		//var all_columns = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_all_ws_columns", "inbox" : inbox?1:''} ).resp_text ) ;   // TABCOL_WS
		this.tabcol = new TabCol1(visible_columns, ac, this.tabcol_cb, "mc_field_capt"+'.'+this.alias, "", this);   // TABCOL_WS
		//  WS_FIORD
		t.mainform.on("click", ".mc_row_order", function(){
			t.rec_order = t.ro_extract($(this)); 
			t.clear(); 
			t.show(); 
		});
		if(search_fields)
			this.search_init(search_fields);
		this.pager_id = "tt_pager_" + this.alias;  // PAGER
		this.xhr = null;
		cbsr_click(this.mainform, this.alias); // CB_SEL_REC - select all
		this.sel_rec = sel_rec;
		this.edit_rec = edit_rec;
		make_clickable1(null, this.sel_rec, this.edit_rec, this.mainsel, ".tr-" + this.alias);
		/* donno why it was here; more presize code to do it is in archive.js; this one caused that both inner and outer table received .mc_focused
		// SINGLE_KEYDOWN ARROW_MOVE ; here is used not to differ which clickable panel focused but to differ clickable from search panel
		t.mainform.on("click", function(e){
			if($(e.target).closest(".clickable-row").length)
				$(this).addClass("mc_focused");
			else
				$(this).removeClass("mc_focused");
		});*/
	}

	// remove shown data
	clear(full=true){ // 
		this.mainform.find(".fh-elem").remove(); // remove table header/body
		if(full)
			this.clear_pager();
	}
	refresh(rec_id=null){ 
		if(!rec_id && this.get_active_rec().length) rec_id = this.get_active_rec().data("id");
		this.clear(); this.show(0, rec_id); 
	} 
	// PAGER
	show_page(page){ // FIRE CASE TODO: do not get: now pages work only for DETA (not for thumbs)?
		this.clear(false);
		this.show( (page-1)*this.page_size );
	}
	// DEF DEFREC; must be done here while need also select necessary page; other additional stuff is made by client
	show(start=0, def_rec_id=null){ // email - is one of subscribers (which redi shown) ; all_users - SHOW_ALL_WS
		var t = this;
		t.curr_rec_id = def_rec_id;  // TODO: used?
		wait_screen.add_operation("show");
		var where = t.params==null? "" : JSON.stringify(t.params);
		var order = t.ro_to_str(t.rec_order);
		var need_create_pager = def_rec_id || start==0;
		var page_num = 1;
		// DEF_PAGE ; if need find a rec - need know the page
		if(def_rec_id){ // DEF RER refind rec
			var pos = call_php_sync("contr/main.php", {"action" : "get_rec_pos", "id": def_rec_id, "table": t.table, "where": where, cond: t.cond, "order": order} ).resp_text;   
			page_num = Math.trunc(pos/t.page_size) + 1;
			start = (page_num-1)*t.page_size;
		}
		t.xhr = $.ajax({
			"type": "POST",
			"url": "contr/main.php",
			"data": {action : "show_table", "table" : t.table, "where" : where, "order" : order, cond: t.cond,
					"columns": JSON.stringify(t.tabcol.visible_columns), "get_count": need_create_pager, start:start, limit:t.page_size, alias: t.alias}, // FIORD, TABCOL, PAGER
			"success": function(res, dummy, request){
				$(res).insertAfter(t.mainform.find(".tc_before_detail"));
				t.mainform.find(".fh-header tr").addClass("mc_section_header"); // height/color
				// $("#table-ws_in,#table-ws tr").each( function(){ var tds = $(this).find(".td-ws-size"); if(tds.length) tds.html( size_to_huma(tds.html()) ); } );  // used to show human size
				// $("#tt_ws_form .td-ws-date_mod, .td-ws-date_sent, .td-ws-date_expire").each( function(){ $(this).html( shrink_date($(this).html() ) ); } );   // shrink date cols
				//$("#tt_ws_form .td-ws-name").each( function(){ var name = $(this).html(); $(this).prop("title", name); $(this).html( shrink_string(name, 50) ); } ); // use to shrink some long fields
				cbsr_class(t.mainform, "td-" + t.alias + "-RES_checked", "th-" + t.alias + "-RES_checked"); // call before make_clickable
				t.ro_show_order(t.mainform, t.alias, t.rec_order); // WS_FIORD
				if(def_rec_id)
					set_active( t.find_rec( def_rec_id ) , t.sel_rec);
				// DEF CB_SEL_REC_WS: stuff to use  CB_SEL_REC for ws list
				// PAGER
				if(need_create_pager){
					var count = request.getResponseHeader("count"); // total count; server returns only portion
					t.clear_pager();
					var max = Math.trunc( parseInt(count)/t.page_size + 0.99999 );
					if(max>1){ // if need pager
						var counter = create_counter(t.pager_id, function(p){ t.show_page(p); }, page_num, max, 1, function(ps){t.page_size=ps; t.refresh(); /* PAGE_SIZE*/} );
						t.mainform.find(".mc_counter_cont").append( counter );
						counter.find(".uc_ps").val(t.page_size); // PAGE_SIZE
						// TODO: Maybe save in cookie
					}
				}
				if(t.on_show)
					t.on_show();
				// call it after client's on_show while it may change columns width
				fh_init_table(t.mainform);
			},
			"complete": function(){
				//if( !is_in_edit() )set_upload_frame("100");  // if edit form is shown - not hide upload form // NOTE: commented after CAN_UPLOAD while it hides upl frame if was shown in YY; besides seems useless because of XX
					 // hide upload frame
				wait_screen.remove_operation("show");
			}
		})
	}
}
