<?php

ini_set("post_max_size", "8000M");
ini_set("upload_max_filesize", "8000M");
ini_set("max_input_time", "3000");
ini_set("max_execution_time", "3000");
ini_set("memory_limit", "-1");
set_time_limit(3000);

	/*
	26.08.20
	created to move code for moving uploaded files from controller to fu DEF MUH
	*/

        require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."utils/utils.php"); // exec_log  extract_zip get_dir_contents
        require_once(proj_path."utils/log.php");
        require_once(proj_path."model/db.php");  // append_file_zip  exec_cmd
        require_once(proj_path."model/events.php");

	
	function move_uploaded_files($upload_path, $user_path, &$files, $data){ // add_to_zip: ASK_ADD_ZIP
		log\info("starting upload");
		if(session_id() == '')
			session_start();
		if(!session_id())
			throw new Exception("failed to start session");
		//
		$user_id = get_curr_user_id();
		$data = json_decode($data, true);

		/*ob_start();
		phpinfo(INFO_CONFIGURATION);
		log\error( ob_get_clean() );*/

		$action = $data["client"];
		log\info("move_uploaded_files, action '$action'");
		//
		$tfp = $upload_path; // temp path where files are uploaded
		$urp = $user_path; // user/upload relative path (curr dir in explorer)
		// if(!$urp) throw new Exception("upload path empty");   29.08.22 actually it may be empty 
		$ufp = get_source_path().$urp; // user full path
		if(!file_exists($ufp))
			mkdir($ufp, dir_perm, true);

		log\debug("ufp $ufp");

		if($action=="mini"){
			$cat = $data["category"];
			foreach($files as $file){
				if(!file_exists($tfp.$file->name)) continue; // hapens in case when upload cancelled
				$name = db\escape2($file->name);
				if( $r=exec_cmd("rs", $tfp.$file->name, $ufp) ) // TODO: maybe check if already exists and replace/rename/skip 
					throw new Exception("copy uploaded files error: '$r'");
				db\execute("delete from files where path = '$user_path' and name = '$name'");
				db\execute("insert into files(path,name,category) values ('$user_path', '$name', '$cat')");
				make_thumb($ufp.$name, $ufp.get_file_thumb_path(db\get_last_id(), $name)); // DEF FILE_THUMB: use thumbs in web-int instead of full sized images; shit-outlook can't resize
			}
		}else if($action=="hires"){ // hires
			$ufp = get_source_path().hires_path_rel.$urp;
			if(!file_exists($ufp))
				mkdir($ufp, dir_perm, true);
			foreach($files as $file){
				$ffn = $tfp.$file->name;
				if(!file_exists($ffn)) continue;
				$name_hires = db\escape2($file->name);
				log\debug("NH $name_hires");
				//$name_hires = add_suffix($name_hires, "_hr");
				//$nex = pathinfo($name_hires, PATHINFO_FILENAME);
				//$id = db\select_field("files", "id", "path = '$user_path' and name like '$nex.%'"); // find file with same name (without ext)
				$id = db\select_field("hires", "id", "path = '$user_path' and name = '$name_hires'"); // find file with same name (without ext)
				if($id)
					db\execute("delete from hires where id = $id");
				//}else log\error("file not found: $id");
				$fs = filesize($ffn);
				$fd = date(db\get_date_format(), filemtime($ffn));
				$ft = "JPEG";
				if( $r=exec_cmd("rs", $ffn, $ufp.$name_hires) ) // TODO: maybe check if already exists and replace/rename/skip 
					throw new Exception("copy uploaded files error: '$r'");
				//$thm = "medium_$id.jpg";
				//$ths = "small_$id.jpg";
				//make_thumb($ffn, $thmp=get_source_path().hires_thumb_path_rel.$thm, "800");
				//make_thumb($thmp, get_source_path().hires_thumb_path_rel.$ths);
				db\execute( "insert into hires ".db\compile_insert(["path" => $user_path, "name" => $name_hires]) );
				//exec_log("sudo ".cpp_path_bin."info_file_hr -it -T hires -s /opt/abc_info/bin/lb_prada.ini > /var/www/html/abc &"); // need edit sudoers: apache ALL=(ALL) NOPASSWD:/path/module *     user_id: SEFIR
				//db\execute("update files set hires_name = '$name_hires' where id=$id"); // find file with same name (without ext)
			}
		}else if($action=="map"){
			log\debug($data);
			$shop_id = $data["shop_id"];
			foreach($files as $file){
				if(!file_exists($tfp.$file->name)) continue;
				$name = db\escape2($file->name);
				if( $r=exec_cmd("rs", $tfp.$file->name, $ufp) ) // TODO: maybe check if already exists and replace/rename/skip 
					throw new Exception("copy uploaded files error: '$r'");
				db\execute("delete from shops_maps where name = '$name'");
				db\execute("insert into shops_maps(name,shop_id) values ('$name', '$shop_id')");
			}
		}else if($action=="triple"){
			$files_prev = scandir($ufp); // DEF RPF remove previous files
			$lbs_id = basename(trim($ufp,"/"));
			foreach($files as $file){
				if(!file_exists($tfp.$file->name)) continue;
				$name = db\escape2($file->name);
				$ext=strtolower(extract_ext($name));
				log\debug("EXT", $ext);
				if(!in_array($ext,["indd","idml","pdf"])) continue; // also need for RPF to not delete other files
				foreach($files_prev as $fp) if(extract_ext($fp)==$ext) exec_cmd("rm", $ufp.$fp); // RPF ; remove old file with same ext; note: can't delete all at once, while may happen that files uploaded by one each time; so can't distinguish old from new
				if($ext=="pdf") foreach($files_prev as $fp) if(extract_ext($fp)=="jpg") exec_cmd("rm", $ufp.$fp); // remove jpg scales of old PDF ROS
				if( $r=exec_cmd("rs", $tfp.$file->name, $ufp) )
					throw new Exception("copy uploaded files error: '$r'");
				// 
				if(extract_ext($file->name)=="pdf"){
					make_scales($ufp.$file->name, $urp, $lbs_id);
					clear_pdf($lbs_id);
				}
			}
			// check all 3 present
			$exts = array();
			$files1 = scandir($ufp); // NOTE: $files variable is passed by ref, shouldn't modify it
			//log\debug($files);
			foreach($files1 as $file){
				$exts[]=extract_ext($file);
			}
			if(	
				in_array("pdf",$exts) &&
				in_array("idml",$exts) &&
				in_array("indd",$exts) )
				set_lbs_state($lbs_id, "uploaded", "Order uploaded", "GRAPHIC"); // TODO: this will send email only when complete order uploaded; maybe also need send single lbs email for the case when lbs was rejected and re-uploaded
		}
		/*
		// move
		if( $r=exec_cmd("rs", $tfp, $ufp) ) // TODO: maybe check if already exists and replace/rename/skip 
			throw new Exception("copy uploaded files error: '$r'");
		// info
		$sf = cpp_path_bin."abc_file_lb.ini"; $out = proj_path."abc.log";
		exec_log("sudo ".cpp_path_bin."abc_file -L -a --start_dir='$urp' --settings_file='$sf'"); // need edit sudoers: apache ALL=(ALL) NOPASSWD:/path/module *     user_id: SEFIR
		*/
	}

	function client_move_uploaded_file($file_path, $user_path, $data){
		log\info("starting upload: $file_path");
		if(session_id() == '')
			session_start();
		if(!session_id())
			throw new Exception("failed to start session");
		//
		$user_id = get_curr_user_id();
		//
		$tfp = $file_path; // temp path where files are uploaded
		$urp = $user_path; // user/upload relative path (curr dir in explorer)
		// if(!$urp) throw new Exception("upload path empty");   29.08.22 actually it may be empty 
		$ufp = get_source_path().$urp; // user full path
		if(!file_exists($ufp))
			mkdir($ufp, dir_perm, true);

		// move
		if( $r=exec_cmd("rs", $tfp, $ufp) ) // TODO: maybe check if already exists and replace/rename/skip 
			throw new Exception("copy uploaded files error: '$r'");
		// TODO: db
	}

	function set_file_date($file_path, $fdt){  // PASS_FILE_DATE
		if( preg_match("/^(.+)(\s\(.+\))$/", $fdt, $m) )
			$fdt = $m[1]; // cut time zone explanation in par. eg "Sun Jan 26 2020 19:02:54 GMT+0100 (Central European Standard Time)"
		try{
			$dt = new DateTime($fdt);
			$dt->setTimeZone(new DateTimeZone('Europe/Rome')); // TODO 3
			touch($file_path, $dt->getTimeStamp());
		}catch(Exception $e){ log\error("failed to parse js date '$fdt'"); }
	 }
	 
	// TRIPLES
	function make_scale($from_pn, $w, $h, $pn, $k){
		$wc = $w*$k/100;
		$hc = $h*$k/100;
		$sn = $wc.'x'.$hc;
		$to = add_suffix($from_pn, "_$k");
		log\info($from_pn);
		log\info($to);
		log\info("gm convert -size $sn \"$from_pn\" -resize $sn \"$to\"");
		exec("gm convert -size $sn \"$from_pn\" -resize $sn \"$to\"");
	}
	function make_scales($from, $target_dir_rel, $lbs_id){
		$tdf = get_source_path().$target_dir_rel;
		exec_log("/opt/abc_info/src/image_info/render_pdf \"$from\" \"$tdf\"", $output); // for both pdf and images
		$from = replace_ext($from, "jpg");
		$pages = preg_split("/;/", $output[0]); // NOTE: fabr said that there is only one page, so pages==="0"
		log\info($pages);
		foreach($pages as $page){
			//if(!$page) break;
			$size = preg_split("/-/", $page);
			$pn = $size[0];
			$w = $size[1];
			$h = $size[2];
			$from_pn = add_suffix($from, "_".$pn); // the name which issues render_pdf
			$nn = replace_name($from_pn, generate_random_string()); exec_cmd("mv", $from_pn, $nn); $from_pn = $nn; // DEF APUP app update; need use new name for each new upl scales to avoid that browser uses cache (when rejected and reuploaded)
			make_scale($from_pn, $w, $h, $pn, 25);
			make_scale($from_pn, $w, $h, $pn, 50);
			make_scale($from_pn, $w, $h, $pn, 75);
			// insert db
			// TODO: now approves table contains also shop_id/camp_id (just dupl of lbs fields); inserted for convenience but donno if used
			$name = db\escape2(basename($from));
			$app = array("page" => $pn, "name" => $name, "path" => db\escape2($target_dir_rel.basename($from_pn)), "width" => $w, "height" => $h, "owner" => get_user_info("email"), "lbs_id" => $lbs_id, "id" => $lbs_id); // DEF APPID=LBSID use same id from lbs and app to avoid confusion
			db\execute("delete from approves where lbs_id = $lbs_id"); // for the case if there already was a rec
			db\execute("insert into approves ".db\compile_insert($app, null));
			break; // ONLY first page
		}
	}

	function make_thumb($from, $to, $size=190){
		exec("gm convert \"$from\" -resize x$size \"$to\"");
	}
?>
