<?php
// TODO: TODEL was used temporarily to test approves; code moved to model/upload.pdf, triple
require_once(dirname(__FILE__)."/../path.php");
require_once(proj_path."utils/log.php");
require_once(proj_path."model/db.php");

function make_scale($from_pn, $w, $h, $pn, $k){
	$wc = $w*$k/100;
	$hc = $h*$k/100;
	$sn = $wc.'x'.$hc;
	$to = add_suffix($from_pn, "_$k");
	log\info($from_pn);
	log\info($to);
	log\info("gm convert -size $sn \"$from_pn\" -resize $sn \"$to\"");
	exec("gm convert -size $sn \"$from_pn\" -resize $sn \"$to\"");
}

try{
	$user_id = get_curr_user_id();
	if(!$user_id) // LOGONEXP
		throw new user_exception('no_user');
	
	log\set_log_file(log_path."upload.log");

	log\info("her");

	$target_dir = proj_path."files/";
	$from = $_FILES["myFile"]["tmp_name"];
	$name = $_FILES["myFile"]["name"];
	$to = $target_dir.$name;

	if(db\exists("approves", "name = '".db\escape($name)."'"))
		throw new user_exception("already exists");

	log\info( $from, $to);
	if (move_uploaded_file($from, $to)) {
		echo "ok";
	} else {
		echo "Sorry, there was an error uploading your file.";
	}
	$from = $to;
	exec("/opt/abc_info/src/image_info/render_pdf \"$from\" \"$target_dir\"", $output); // for both pdf and images
	$from = replace_ext($from, "jpg");
	$pages = preg_split("/;/", $output[0]);
	log\info($pages);
	foreach($pages as $page){
		if(!$page) break;
		$size = preg_split("/-/", $page);
		$pn = $size[0];
		log\info($size);
		$w = $size[1];
		$h = $size[2];
		$from_pn = add_suffix($from, "_".$pn);
		make_scale($from_pn, $w, $h, $pn, 25);
		make_scale($from_pn, $w, $h, $pn, 50);
		make_scale($from_pn, $w, $h, $pn, 75);
		// insert db
		$app = array("page" => $pn, "name" => db\escape($name), "path" => basename($from_pn), "width" => $w, "height" => $h, "owner" => get_user_info("email"));
		db\execute("insert into approves ".db\compile_insert($app, null));
	}

}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}
?>
