<?php
ini_set("post_max_size", "8000M");
ini_set("upload_max_filesize", "8000M");
ini_set("max_input_time", "3000");
ini_set("max_execution_time", "3000");
ini_set("memory_limit", "-1");
set_time_limit(3000);

	// PORTAL
	$temp_portal = ""; // TEMP_USER
	$portal_list = array("depedrini");
	function get_portal_name($def="depedrini"){ // get_portal
		//if(isset($_GET["portal"])) return $_GET["portal"];  // check if passed in request eg download.php EMAIL_LINK   TEMP_USER: portal can't be in db (in links table) while to access db need to know portal
		global $temp_portal; if($temp_portal) return $temp_portal;
		if(session_id() == '')	session_start();
		return isset($_SESSION["portal"])? $_SESSION["portal"] : $def;
	}
	function get_source_path(){ return source_path.get_portal_name().'/'; }
	//function get_files_path(){ return "files_".get_portal_name().'/'; } TODO: BUG LIFO links forbidden; managed to open links unter tt, but under root yet not work
	function get_files_path(){ return "table_tree/files_".get_portal_name().'/'; }
	function get_settings(){
		$settings_file = proj_path.'settings.ini';
		//if($pn=get_portal_name()) $settings_file = add_suffix($settings_file, "_$pn"); // each portal has its settings file; also need one for all, for stages when no portal set
		return parse_ini_file($settings_file, true);
	}
	//
	define("project_title", "Lightbox");
	define("project_name", "lightbox");
	define('www_root', '/var/www/html/');
	define('proj_path_rel', 'depedrini/');
	if(!defined('proj_path'))
		define('proj_path', www_root.proj_path_rel);
	define('flag_path', proj_path.'flag/');
	define('log_path', proj_path.'log/');
	define("project_icon", '/'.proj_path_rel."img/logo_sm.ico" );
	define('base_url', 'https://portals.depedrini.com/');
	//define('base_url', 'https://167.235.244.132/');
	define('client_name', 'alex');
	define('source_path', '/depedrini/');
	define('mount_path', '/mnt/ltfs/');
	define('temp_path', proj_path.'tmp/');
	define('backup_path', proj_path.'sql/');
	define('template_path', proj_path.'templates/');
	define('lib_path', '/var/www/'); // used as path to phpmailer dir
	//define('files_path', "files/"); // files of approves APAP //   now this path is in tt
	define('camp_path', "campaigns/"); // TODO: use it somehow in js
	// UPLOAD
	define('upload_path', proj_path.'fu/server/php/files/');
	define('upload_thumb_path', 'fu/server/php/thumb/');  // fu thumb's 
	define('company_domain', "depedrini.com");
	define("bootstrap_path", "../lib/bootstrap/");
	//define("hires_path_rel", "hires/"); // path under camp dir where hires are stored
	define("hires_path_rel", "hires/"); // HRNEW: path under portal path (link to storage)
	define("hires_thumb_path_rel", "hires_thumb/"); 

	define('lang_def', 'en');
	define('table_tree_path', proj_path."table_tree/");
	define('unregistered_log_file', log_path."unregistered.log");

	define('dir_perm', 0775); // leading 0 is important here
	define('dir_owner', 'www-data');
	define('dir_group', 'www-data');
	// min free space available (this is rather disk_min_space - min space for all mounpoints of the disk (public/cache))
	define('GB', pow(2,30));
	define('MB', pow(2,20));
	define('disk_min_free_size', 200*GB);
	$control_paths = array("log"=>log_path, "temp"=>temp_path, "root"=>"/");  // free size in each is controlled periodically (compared with root_min_free_size)
	define('root_min_free_size', 5*GB);
	define('notice_email', 'anosurov@depedrini.com');
	define('max_sql_conn', 60); // max num of concurrent mysql connections (now only in sleep state)
	define('max_apache_conn', 75); // max num of apache conns (now only alert)

	define('cpp_path', '/opt/abc_info/');
	define('cpp_path_bin', cpp_path.'bin/');
	define('cpp_path_log', cpp_path.'log/');
	define('cpp_path_summary', cpp_path.'summary/');
	define('cpp_path_error', cpp_path.'error/');
	define('cpp_error_file', cpp_path_error."alert.log");
	define('cpp_settings_file', cpp_path_bin."settings.ini");
	function create_dir($path){ mkdir($path,dir_perm); chown($path,dir_owner); chgrp($path,dir_group); }
	//
	function get_session_user_name($def="system"){
		if(session_id() == '')	session_start();
		return isset($_SESSION["user_name"])? $_SESSION["user_name"] : $def;
	}
	//
	// this stuff is here while needed by both view and model
	$role_list = array(
		array("name" => "ADMIN", "code" => "A", "type" => "user"),
		array("name" => "ENGINEERING", "code" => "E", "type" => "user"),
		array("name" => "VISUAL_ADMINISTRATOR", "code" => "VA", "type" => "user"),
		array("name" => "GRAPHIC", "code" => "G", "type" => "user"),
		array("name" => "PRODUCTION", "code" => "P", "type" => "group"),
		array("name" => "PRODUCTION_INTERNAL", "code" => "PI", "type" => "user"),
		array("name" => "LOCAL_VISUAL", "code" => "LV", "type" => "group"),
		array("name" => "HIRES", "code" => "HR", "type" => "user")  // DEF HRR: special user to see only hires page
	);	
	function get_user_roles($type=0){$r=array();global $role_list;foreach($role_list as $ro)if(!$type || $ro["type"]==$type)$r[]=$ro["name"];return $r;}
	function get_role_name($code){global $role_list; $r=find_array_key_value($role_list, "code", $code); return $r?$r["name"]:"";}
	function get_role_code($name){global $role_list; $r=find_array_key_value($role_list, "name", $name); return $r?$r["code"]:"";}
?>
