<?php
	/* 
		PORTAL
		created 22.04.22
		used to select portal
		also incapsulates list of portals
		called in same way that login.php from contr/login.php but before it
		receives location requested by user in get-location, saves it to form input
		on portal click sets form input to selected portal and call login.php
	*/
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."model/db.php");
	logout(); // 27.04: to force logout if user opens this page manually (or else selected portal not set if already set)
	if(session_id() == '') 	session_start(); // this is necessary to be able to read session vars (LOGIN_FAIL)
	$location = isset($_GET["location"])? htmlspecialchars($_GET["location"]) : "";
?>
<head>
	<title><?php echo project_title; ?></title>
	<link href="lib/bootstrap/css/bootstrap.min.css" rel="stylesheet">
	<link href="lib/bootstrap/css/bootstrap.css" rel="stylesheet">
	<link href="css/main.php" rel="stylesheet">
	<link href="css/login.css" rel="stylesheet">
	<link href="table_tree/css/style.css" rel="stylesheet"> <!-- popup -->
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="icon" type="img/ico" href="$icon$">
</head>
<body onload="on_load()">
	<div id = "mi_login_outer" > <!-- whole screen -->
		<!-- LOGIN_FAIL div -->
		<form id='mi_login_inner' class='center-screen-flex user ' action='contr/login.php' method='POST' style='background: transparent; max-width:600px;'>
			<div class='mc_portal_div' onclick="portal_click('prada')" ><img src='img/prada.png' style='width:100%;'></div>
			<div class='mc_portal_div' onclick="portal_click('miumiu')" ><img src='img/miumiu.png' style='width:100%;'></div>
			<input name='location' type='hidden' value='<?php echo $location; ?> '>
			<input name='action' type='hidden' value='set_portal'  >
			<input id='mi_portal' name='portal' type='hidden' >
		</form>
        </div>
</body>
<script src="lib/jquery/js/jquery-2.1.4.min.js"></script>
<script type="text/javascript">
	function portal_click(portal){
		document.getElementById("mi_portal").value = portal;
		document.getElementById("mi_login_inner").submit();
	}
</script>
