<?php 
        // DEF LOADEML stuff to download source eml on request

        ob_start();
        require_once(dirname(__FILE__)."/path.php");
        require_once(proj_path."path.php"); // sourche path
        require_once(proj_path."utils/utils.php");
        require_once(proj_path."utils/db_mysql.php");
        require_once(proj_path."model/db.php"); // get_curr_user_id, trar
        require_once(proj_path."model/errors.php");  // register_error
        require_once(dirname(__FILE__)."/share/lightbox.php"); 
		require_once(proj_path."utils/exception.php");

		log\set_log_file(log_path."download.log");
        ob_clean();

        if( !isset( $_GET['id'] ) ) 
                return;
    
        $id = $_GET['id'];

        if(session_id() == '') 
                session_start();
        $user_id = get_curr_user_id();
        if(!$user_id){
                log\error("user id not passed");
                return; 
        }
        //
        log\info("downloading file: $id");
		$table = isset( $_GET['t'] )? $_GET['t'] : "files";
        $rec = db\select_record($table, "path,name", "id=$id"); 
	try{
		//$path = trar_path($path=$rec["path"].$rec["name"]); // TODO: trar used now only in ic
		//$path = get_source_path().$rec["path"].$rec["name"]; better, but need use it also for thumbs
		$path = source_path.$rec["path"].$rec["name"];
	}catch(Exception $e){
		throw new user_exception('$file_not_found$: '."'$path'");
	}
        log\info("download path: $path");
	if(!user_dir_allowed($user_id, $rec["path"]))
		throw new user_exception('$dir_access_denied$');
        if( is_file($path) )
                //download_file_stream( file_get_contents($path), basename($path) );
                download_file_path( $path, basename($path) );
	else
		throw new user_exception('$file_not_found$: '."'$path'");
	log\info("Ok");
?>
