<?php
	// creates a select // NOTE: was changed 27.01.20 to use $opts: key->val instead of names/values
	// DEF CHANGE - what was changed in some commonly used functions (so should correct old code when merge new util funcs)
	// NOTE: TODO: this func disadv is that can't set opts order (is always by val)
	function render_select_opts($options, $def=false, $data_name=null, $data=null){
		// if($no_select)	$opts .= "<option disabled='disabled' selected='selected'>$no_select</option>";     //def not selectable (but selected by def) item
		$opts = "";
		$select_first = gettype($def)=="boolean"? $def : false;
		$def_val = gettype($def)!="boolean"? $def : false;
		foreach($options as $val => $name){
			$opts .= "<option";
			if($select_first){
				$opts .= " selected='selected' "; $select_first=false;
			}
			if($def_val && $def_val==$val)
				$opts .= " selected='selected' ";
			if($data_name) $opts .= " data-$data_name ='{$data[$val]}'";
			$opts .= " value ='$val'";
			$opts .= ">$name</option>";
		}
		return $opts;
	}

	// items: array of array = ("text" => , "value" =>)
	// needs css: radio-info.css
	// possible usage: js: var opt = $("input[name='the_name']:checked").val()
	//function render_radio_group($items, $name, $def=null, $attr='', $inline=true){ // TODO: $inline not used
	function render_radio_group($items, $name, $def=null, $inline=true){ // TODO: $inline not used
		$res = "";
		if(!$def && sizeof($items))
			try{
			$def = is_array($items[0])? $items[0]["value"] : $item[0];
			}catch(Exception $e){  log\debug(dump_stack()); log\debug("BUG31: ", $items); }
		foreach($items as $ind => $item){
			if(is_array($item)){	$value = $item['value']; $text = $item['text']; }
			else { $value = $item; $text = $item; }
			$checked = $def==$value? "checked" : "";
			$res .= "<div class='radio radio-info radio-inline' style='margin-right: 20px;'>".  // added margin while justify not works
				"<input id='$name$ind' type='radio' class='rg_item rg_$value' name='$name' value='$value' $checked>".   // id - to attach label (by same id), name (=group name) - to unite in same group, value - is what's selected (id)
				"<label>$text</label>".
				"</div>";
		}
		//return "<div class='container' style='width: 100%; display: flex;' $attr>$res</div>";  //  justify-content: space-between   NOT WORKS THIS SHIT
		return $res; // now client need wrap the res into some container itself (use sms like above)
	}

	function render_radio_group_not_works($items, $name, $inline=false){
		$res = ""; $cc=$inline?"custom-control-inline":"";
		foreach($items as $ind => $item){
			$value = $item['value']; $text = $item['text'];
			$res .= "<div class='$cc custom-radio'>\n" .
					"<input type='radio' class='custom-control-input' id='rg_$name_$ind' name='$name' value='$value'>\n".   // id - to attach label (by same id), name (=group name) - to unite in same group, value - is what's selected (id)
					"<label class='custom-control-label' for='rg$name$ind'>$text</label>\n". // text - what is shown
				"</div>\n";
		}
		return $res;
	}

	function render_ul($items, $id){
		return "<ul id='$id'>" . wrap($items, "<li>", "</li>") . "</ul>";
	}
	function render_map($id, $items){
		$res = "";
		foreach($items as $key => $value)
			$res .= "<div> <label class='st_caption'>" . $key . ": </label>" . "<label class='st_value'>" . $value . "</label> </div>";
		return "<div id='$id'> $res </div>";
	}

        function render_lines($lines, $keys, $max_len=0){
                // keys format
                $res = array();
                foreach($lines as $line){
                        $fl = $max_len && strlen($line)>$max_len? substr($line, 0, $max_len)."... ": $line;
                        $fl = htmlspecialchars($fl);
                        if( sizeof( $keys ) )
                                foreach($keys as $key)
                                        $fl = str_replace($key, "<span class='tt_word'>".$key."</span>", $fl);
                        $res[] = $fl;
                }
                echo implode("<br>", $res);
        }


	//echo render_radio_group(array(array("value"=>"new", "text"=>"nuovo"),array("value"=>"append", "text"=>"aggiungi"),array("value"=>"edit", "text"=>"modificare")), "tt_btype"); 
?>
